<?php

namespace Etrali\GinangBundle\Controller\BackboneLink;

use Admingenerated\EtraliGinangBundle\BaseBackboneLinkController\ListController as BaseListController;
use Etrali\GinangBundle\Entity\BackboneLink;

class ListController extends BaseListController
{
    public function buildQuery()
    {
        $q=parent::buildQuery();
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR")
        {
            $modifiers=BackboneLink::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $q=$q->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");
            }
        }

        return $q;
    }
}
