<?php

namespace Etrali\GinangBundle\Controller\BackboneLink;

use Admingenerated\EtraliGinangBundle\BaseBackboneLinkController\NewController as BaseNewController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Etrali\GinangBundle\Form\Type\BackboneLink\CustomValidator;
use Etrali\GinangBundle\SendMail;

class NewController extends BaseNewController
{
    
    public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(1,0); 
        return $type;
    }
    
    public function preForm($BackboneLink)
    {
        $BackboneLink->setCdBackboneLink("<automatic allocation>");
        $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(1);
        $BackboneLink->setIdTransactionType($TransType);
        $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(0);
        $BackboneLink->setIdTransactionStatus($TransStatus);
    }
    
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\BackboneLink $BackboneLink your \Etrali\GinangBundle\Entity\BackboneLink object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\BackboneLink $BackboneLink)
    {
            $extr=new \Etrali\GinangBundle\Entity\BackboneLinkExtremity();
            $extr->setIdBackboneLink($BackboneLink);
            $extr->setCdBackboneLinkExtremityRef("A1");
            
            $extr2=new \Etrali\GinangBundle\Entity\BackboneLinkExtremity();
            $extr2->setIdBackboneLink($BackboneLink);   
            $extr2->setCdBackboneLinkExtremityRef("B2");
            
            $extrt1=new \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech();
            $extrt1->setIdBackboneLink($BackboneLink);
            $extrt1->setIdBackboneLinkExtremity($extr);
            
            $extrt2=new \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech();
            $extrt2->setIdBackboneLink($BackboneLink);
            $extrt2->setIdBackboneLinkExtremity($extr2); 
            
            $BackboneLink->setNbOperation(1);
            $BackboneLink->setCdBackboneLink("BB".$BackboneLink->getIdBackboneLink());             
            $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(1);
            $BackboneLink->setIdTransactionType($TransType);            
            
            $em = $this->getDoctrine()->getManager();
            $em->persist($BackboneLink);
            $em->persist($extr);
            $em->persist($extr2);
            $em->persist($extrt1);
            $em->persist($extrt2);
            
        $chaineret=CustomValidator::isValidForNextStep($BackboneLink,$this->getDoctrine()->getEntityManager(),$this);
        if ($chaineret=="")
        {          
            
            $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(0);
            $BackboneLink->setIdTransactionStatus($TransStatus);        
            
            $history=new \Etrali\GinangBundle\Entity\BackboneLinkTransactions();
            $history->setIdBackboneLink($BackboneLink);
            $history->setCdBackboneLink($BackboneLink->getCdBackboneLink());
            $history->setIdTransactionStatus($TransStatus);
            $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(1);            
            $history->setIdTransactionType($TransType);
            $history->setLbOperation($TransType." 1");
            
            $em->persist($history); 
                        
        }
        else
            $this->get('session')->getFlashBag()->add('error',  "Object has been saved but to move on in workflow the fields below are mandatory : <br>".$chaineret );
        $em->flush();
    }
    
    
}
