<?php

namespace Etrali\GinangBundle\Controller\BackboneLinkExtremityTech;

use Admingenerated\EtraliGinangBundle\BaseBackboneLinkExtremityTechController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    public function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    }
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech your \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech)
    {       
        if ($BackboneLinkExtremityTech->getIdOutConnectionPath())
        {
            foreach ($BackboneLinkExtremityTech->getIdOutConnectionPath() as $line)
            {
                $line->setIdBackboneLinkExtremityTech($BackboneLinkExtremityTech);
            }
        }

    }    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech your \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech)
    {         
        $em=$this->getDoctrine()->getManager();        
        if ($BackboneLinkExtremityTech->getLbConnectionPath() != NULL && $BackboneLinkExtremityTech->getLbConnectionPath()!="")
        {
            if (strpos($BackboneLinkExtremityTech->getLbConnectionPath(),"/vlan:")!==FALSE)
            {
                $tab=explode("/",$BackboneLinkExtremityTech->getLbConnectionPath());
                $tab2=explode(":",$tab[0]);
                $portid=$tab2[1];
                
                $tab2=explode(":",$tab[1]);
                $vlanref=$tab2[1];
                
                if ($BackboneLinkExtremityTech->getIdVlan()->getLbVlan()!=$vlanref)
                {
                    $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                    $vlan=new Vlan();
                    $vlan->setIdPortInstance($PortInstance);
                    $vlan->setLbVlan($vlanref);
                    $vlan->setIdInBackboneLinkExtremityTech($BackboneLinkExtremityTech);
                    $em->persist($vlan);
                }                
            }
            else if (strpos($BackboneLinkExtremityTech->getLbConnectionPath(),"/timeslot:")!==FALSE)
            {
                $tab=explode("/",$BackboneLinkExtremityTech->getLbConnectionPath());
                $tab2=explode(":",$tab[0]);
                $portid=$tab2[1];
                
                $tab2=explode(":",$tab[1]);
                $ts=$tab2[1];
                
                $timeslots=explode(",",$ts);
                
                $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                foreach ($timeslots as $timeslot)
                {
                        $portts=$PortInstance->getTsByNumber($timeslot);                        
                        $portts->setIdInBackboneLinkExtremityTech($BackboneLinkExtremityTech);
                }
                $em->persist($portts);                                
            }
            else 
            {
                $tab=explode(":",$BackboneLinkExtremityTech->getLbConnectionPath());
                $portid=$tab[1];
                
                $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);

                $BackboneLinkExtremityTech->setIdPortInstance($PortInstance);
                $em->persist($BackboneLinkExtremityTech);
            }            
        }
        foreach ($BackboneLinkExtremityTech->getIdOutConnectionPath() as $path)
        {
            if ($path != NULL && $path!="")
            {
                if (strpos($path,"/vlan:")!==FALSE)
                {
                    $tab=explode("/",$path);
                    $tab2=explode(":",$tab[0]);
                    $portid=$tab2[1];

                    $tab2=explode(":",$tab[1]);
                    $vlanref=$tab2[1];

                    if (!$BackboneLinkExtremityTech->hasOutVlan($vlanref))
                    {
                        $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                        $vlan=new Vlan();
                        $vlan->setIdPortInstance($PortInstance);
                        $vlan->setLbVlan($vlanref);
                        $vlan->setIdBackboneLinkExtremityTech($BackboneLinkExtremityTech);
                        $em->persist($vlan);
                    }                
                }
                else if (strpos($path,"/timeslot:")!==FALSE)
                {
                    $tab=explode("/",$path);
                    $tab2=explode(":",$tab[0]);
                    $portid=$tab2[1];

                    $tab2=explode(":",$tab[1]);
                    $ts=$tab2[1];

                    $timeslots=explode(",",$ts);

                    $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);
                    foreach ($timeslots as $timeslot)
                    {
                            $portts=$PortInstance->getTsByNumber($timeslot);                        
                            $portts->setIdBackboneLinkExtremityTech($BackboneLinkExtremityTech);
                    }
                    $em->persist($portts);                                
                }
                else 
                {
                    $tab=explode(":",$path);
                    $portid=$tab[1];

                    $PortInstance=$em->getRepository('EtraliGinangBundle:PortInstance')->find($portid);

                    $BackboneLinkExtremityTech->setIdOutPortInstance($PortInstance);
                    $em->persist($BackboneLinkExtremityTech);
                }            
            }            
        }
        if ($BackboneLinkExtremityTech->getIdBackboneLink()->getIdTransactionType()->getIdTransactionType()==3 && $BackboneLinkExtremityTech->getDtBbTested()!=NULL)            
        {

            foreach ($BackboneLinkExtremityTech->getIdBackboneLink()->getIdBackboneLinkExtremityTech() as $extr)
            {
                if (!$extr->getBlOld() && $extr->getDtBbTested()==NULL)
                {
                    $extr->setDtBbTested($BackboneLinkExtremityTech->getDtBbTested());
                    $em->persist($extr);
                }
            }

        }
        $em->flush();        
    }
}
