<?php

namespace Etrali\GinangBundle\Controller\BackboneLinkExtremityTech;

use Admingenerated\EtraliGinangBundle\BaseBackboneLinkExtremityTechController\NewController as BaseNewController;

class NewController extends BaseNewController
{
        public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(1,0); 
        return $type;
    }
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech your \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech)
    {       
        if ($BackboneLinkExtremityTech->getIdOutConnectionPath())
        {
            foreach ($BackboneLinkExtremityTech->getIdOutConnectionPath() as $line)
            {
                $line->setIdBackboneLinkExtremityTech($BackboneLinkExtremityTech);
            }
        }

    }      
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech your \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech $BackboneLinkExtremityTech)
    {
        $tech=  new \Etrali\GinangBundle\Entity\BackboneLinkExtremity();
        $tech->setIdBackboneLink($BackboneLinkExtremityTech->getIdBackboneLink());
       
        $BackboneLinkExtremityTech->setIdBackboneLinkExtremity($tech);
        
        $em = $this->getDoctrine()->getManager();
            $em->persist($tech);
            $em->persist($BackboneLinkExtremityTech);
            $em->flush();
    }      
}
