<?php

namespace Etrali\GinangBundle\Controller\Branch;

use Admingenerated\EtraliGinangBundle\BaseBranchController\ListController as BaseListController;

class ListController extends BaseListController
{
    public function buildQuery()
    {
        $q=parent::buildQuery();
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR" && ($this->getRequest()->get('tag')==NULL || $this->getRequest()->get('tag')!='BilledCustomer'))
        {
            $idBranchs=array();            
            if ($this->get('request')->query->has('isSelect') && $this->get('request')->query->has('parentclass'))
            {
                $entity="Etrali\\GinangBundle\\Entity\\".$this->get('request')->query->get('parentclass');
                $modifiers=$entity::getModifierRoles();
                foreach ($this->getUser()->getIdUserInBranch() as $branch)
                {
                    if (in_array($branch->getRole(),$modifiers))                    
                            $idBranchs[]=$branch->getIdBranch()->getIdBranch();
                }                
            }
            else
            {
                foreach ($this->getUser()->getIdUserInBranch() as $branch)
                {
                            $idBranchs[]=$branch->getIdBranch()->getIdBranch();
                }                
            }
            if (count($idBranchs)>0)
            {
                $q=$q->andWhere("q.idBranch in (".implode(",",$idBranchs).")");
            }
        }

        return $q;
    }
    
    public function selectWithUser($query)
    {
        if ($this->get('request')->query->get('motherid'))
        {
            $em=$this->getDoctrine()->getEntityManager();
            $query=$query->innerJoin("q.idUserInBranch","uib")->innerJoin("uib.idMyuser","u")->andWhere("u.username=:username")->setParameter('username',$this->getRequest()->query->get('motherid') );
        }                        
        return $query;
    }    
    
    public function getWithUserAction()
    {
        $this->addToQuery="selectWithUser";
        return $this->indexAction();
    }     
}
