<?php

namespace Etrali\GinangBundle\Controller\CabinetInstance;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;
use Admingenerated\EtraliGinangBundle\BaseCabinetInstanceController\NewController as BaseNewController;
use Etrali\GinangBundle\Entity\SlotInstance;
use Etrali\GinangBundle\Entity\CardInstance;
use Etrali\GinangBundle\Entity\PatchPanelInstance;
use Etrali\GinangBundle\Entity\CabinetInstance;
use Etrali\GinangBundle\Entity\PortInstance;
use Etrali\GinangBundle\Entity\EquipmentInstance;

class NewController extends BaseNewController
{
    
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));
        if ($this->get('request')->query->has('return'))
            $session->set('return',$this->get('request')->query->get('return')); 
        if ($this->get('request')->query->has('nombre'))
            $session->set('nombre',$this->get('request')->query->get('nombre'));        
        return parent::indexAction();
    }
        
    public function createAction()
    {
        $em=$this->getDoctrine()->getEntityManager()        ;
        $CabinetInstance = $this->getNewObject();

        $this->preBindRequest($CabinetInstance);
        $form = $this->createForm($this->getNewType(), $CabinetInstance);
      
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $CabinetInstance);
                $session = $this->getRequest()->getSession();  
                $idpere=$session->get('idpere');
                $Pere=$em->getRepository('EtraliGinangBundle:Pop')->find($idpere);
                $CabinetInstance->setIdPop($Pere);              
                $this->saveObject($CabinetInstance);
                $this->postSave($form, $CabinetInstance);

                $entites=array();
                $entites[]=$CabinetInstance;
                
                if ($session->has("nombre"))
                {
                    for ($i=1;$i<$session->get("nombre");$i++)
                    {
                        $newcab=clone $CabinetInstance;                         
                        $entites[]=$newcab;
                    }
                }
                
                foreach ($entites as $cabinst)
                {
                    $models=$cabinst->getIdComplexModel()->getIdCabinet();
                    $cpt=0;
                    foreach ($models as $model)
                    {   
                        if ($cpt>0)
                            $cabinst=clone $CabinetInstance;
                        $cpt++;
                        $cabinst->setIdCabinet($model);
                        foreach ($model->getIdCostingCabinetLine() as $costing)
                        {
                            $newcost=clone $costing;
                            $newcost->setIdCabinet(NULL);
                            $newcost->setIdCabinetInstance($cabinst);
                            $em->persist($newcost); 
                        }
                         
                        $em->persist($cabinst);                          
                    foreach($model->getIdPatchPanel() as $ppanel)
                    {
                        $ppanelinst=new PatchPanelInstance();
                        $ppanelinst->setCdPatchPanelInstance($ppanel->getCdPatchPanel());
                        $ppanelinst->setLbPatchPanelInstance($ppanel->getLbPatchPanel());
                        $ppanelinst->setCmPatchPanelInstance($ppanel->getCmPatchPanel());
                        $ppanelinst->setBlDeactivated(true);
                        $ppanelinst->setIdPatchPanel($ppanel);
                        $ppanelinst->setIdCabinetInstance($cabinst);
                        foreach ($ppanel->getIdCostingPatchPanelLine() as $costing)
                        {
                            $newcost=clone $costing;
                            $newcost->setIdPatchPanel(NULL);
                            $newcost->setIdPatchPanelInstance($ppanelinst); 
                            $em->persist($newcost); 
                        }
                      
                        $em->persist($ppanelinst); 
                            foreach ($ppanel->getIdPort() as $port)
                            {
                                $portinst=new PortInstance();
                                $portinst->setCdPortInstance($port->getCdPort());
                                $portinst->setLbPortInstance($port->getLbPort());
                                $portinst->setCmPortInstance($port->getCmPort());  
                                $portinst->setIdPortType($port->getIdPortType()); 
                                $portinst->setBlDeactivated(true);
                                $portinst->setIdPort($port);
                                $portinst->setIdPatchPanelInstance($ppanelinst);
                                
                                $em->persist($portinst);                                                                      
                            }                         
                    }                    
                    foreach($model->getIdEquipment() as $equip)
                    {
                        $equipinst=new EquipmentInstance();
                        $equipinst->setCdEquipmentInstance($equip->getCdEquipment());
                        $equipinst->setLbEquipmentInstance($equip->getLbEquipment());
                        $equipinst->setCmEquipmentInstance($equip->getCmEquipment());
                        $equipinst->setBlDeactivated(true);
                        $equipinst->setIdEquipment($equip);
                        $equipinst->setIdCabinetInstance($cabinst);
                        foreach ($equip->getIdCostingEquipmentLine() as $costing)
                        {
                            $newcost=clone $costing;
                            $newcost->setIdEquipment(NULL);
                            $newcost->setIdEquipmentInstance($equipinst); 
                            $em->persist($newcost); 
                        }
                     
                        $em->persist($equipinst);     
                        foreach ($equip->getIdCard() as $dcard)
                        {
                            $dcardinst=new CardInstance();
                            $dcardinst->setCdCardInstance($dcard->getCdCard());
                            $dcardinst->setLbCardInstance($dcard->getLbCard());                            
                            $dcardinst->setBlDeactivated(true);
                            $dcardinst->setIdCard($dcard);
                            $dcardinst->setIdEquipmentInstance($equipinst);
                            foreach ($dcard->getIdCostingCardLine() as $costing)
                            {
                                $newcost=clone $costing;
                                $newcost->setIdCard(NULL);
                                $newcost->setIdCardInstance($dcardinst); 
                                $em->persist($newcost); 
                            }
                            
                            $em->persist($dcardinst);   
                            foreach ($dcard->getIdPort() as $port)
                            {
                                $portinst=new PortInstance();
                                $portinst->setCdPortInstance($port->getCdPort());
                                $portinst->setLbPortInstance($port->getLbPort());
                                $portinst->setCmPortInstance($port->getCmPort()); 
                                $portinst->setIdPortType($port->getIdPortType());                                
                                $portinst->setBlDeactivated(true);
                                $portinst->setIdPort($port);
                                $portinst->setIdCardInstance($cardinst);

                                 
                                $em->persist($portinst);                                                                      
                            }                                    
                        }                                
                        
                        foreach($equip->getIdSlot() as $slot)
                        {
                            $slotinst=new SlotInstance();
                            $slotinst->setCdSlotInstance($slot->getCdSlot());
                            $slotinst->setLbSlotInstance($slot->getLbSlot());
                            $slotinst->setBlDeactivated(true);
                            $slotinst->setIdSlot($slot);
                            $slotinst->setIdEquipmentInstance($equipinst);
                            $em->persist($slotinst);                                 
                            foreach($slot->getIdCard() as $card)
                            {
                                $cardinst=new CardInstance();
                                $cardinst->setCdCardInstance($card->getCdCard());
                                $cardinst->setLbCardInstance($card->getLbCard());                                     
                                $cardinst->setBlDeactivated(true);
                                $cardinst->setIdCard($card);
                                $cardinst->setIdSlotInstance($slotinst);
                                foreach ($card->getIdCostingCardLine() as $costing)
                                {
                                    $newcost=clone $costing;
                                    $newcost->setIdCard(NULL);
                                    $newcost->setIdCardInstance($cardinst);  
                                    $em->persist($newcost); 
                                }
                              
                                $em->persist($cardinst);                                  
                                foreach ($card->getIdPort() as $port)
                                {
                                    $portinst=new PortInstance();
                                    $portinst->setCdPortInstance($port->getCdPort());
                                    $portinst->setLbPortInstance($port->getLbPort());
                                    $portinst->setCmPortInstance($port->getCmPort());
                                    $portinst->setIdPortType($port->getIdPortType());                                    
                                    $portinst->setBlDeactivated(true);
                                    $portinst->setIdPort($port);
                                    $portinst->setIdCardInstance($cardinst);

                                    
                                    $em->persist($portinst);                                                                      
                                }
                                foreach ($card->getIdDaughterCard() as $dcard)
                                {
                                    $dcardinst=new CardInstance();
                                    $dcardinst->setCdCardInstance($dcard->getCdCard());
                                    $dcardinst->setLbCardInstance($dcard->getLbCard());                                       
                                    $dcardinst->setBlDeactivated(true);
                                    $dcardinst->setIdCard($dcard);
                                    $dcardinst->setIdMotherCard($cardinst);
                                    foreach ($dcard->getIdCostingCardLine() as $costing)
                                    {
                                        $newcost=clone $costing;
                                        $newcost->setIdCard(NULL);
                                        $newcost->setIdCardInstance($dcardinst);  
                                        $em->persist($newcost); 
                                    }
                                    
                                    $em->persist($dcardinst);   
                                    foreach ($dcard->getIdPort() as $port)
                                    {
                                        $portinst=new PortInstance();
                                        $portinst->setCdPortInstance($port->getCdPort());
                                        $portinst->setLbPortInstance($port->getLbPort());
                                        $portinst->setCmPortInstance($port->getCmPort());  
                                        $portinst->setIdPortType($port->getIdPortType());                                        
                                        $portinst->setBlDeactivated(true);
                                        $portinst->setIdPort($port);
                                        $portinst->setIdCardInstance($cardinst);
 
                                        
                                        $em->persist($portinst);                                                                      
                                    }                                    
                                }                                
                            }
                        }
                                 
                    }
                    }
                }
                $em->flush();           
                
                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );
                return new Response('<html><body><script>parent.location.reload(true);</script></body></html>');
            } catch (\Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $CabinetInstance);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('EtraliGinangBundle:CabinetInstanceNew:index.html.twig', $this->getAdditionalRenderParameters($CabinetInstance) + array(
            "CabinetInstance" => $CabinetInstance,
            "form" => $form->createView(),
        ));
    }
    
    
}
