<?php

namespace Etrali\GinangBundle\Controller\ComplexModel;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
use \Doctrine\Common\Collections\ArrayCollection as ArrayCollection;
use Admingenerated\EtraliGinangBundle\BaseComplexModelController\EditController as BaseEditController;

class EditController extends BaseEditController
{
  
    
    public function getReturnFunction($pk)
    {
        return new RedirectResponse($this->generateUrl("EtraliGinangBundle_admin_etrali_ginang_bundle_ComplexModel_design" ,array("pk"=>$pk)));
    }
    
    public function designAction($pk)
    {
        $ComplexModel = $this->getObject($pk);

        if (!$ComplexModel) {
            throw new NotFoundHttpException("The Etrali\GinangBundle\Entity\ComplexModel with idComplexModel $pk can't be found");
        }        
        
        return $this->render('EtraliGinangBundle:ComplexModelDesign:index.html.twig', array(
            "ComplexModel" => $ComplexModel
        ));
    } 
    
    public function insertAction(Request $request)
    {
        $typepere=$request->get("typepere");
        $idpere=$request->get("idpere");
        $pk=$request->get("pk");        
        $em=$this->getDoctrine()->getEntityManager();
        $ComplexModel=$em->getRepository('EtraliGinangBundle:ComplexModel')->find($pk);        
        
        if ($typepere=="ui-gina-cab")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Cabinet')->find($idpere);                    
            if ($ComplexModel->getIdEquipment() && $ComplexModel->getIdEquipment()->count()>0)
            {
                $ac = new ArrayCollection();
                foreach ($ComplexModel->getIdEquipment() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdCabinet($Pere);                      
                }                
                $Pere->setIdEquipment($ac);                
            }
            if ($ComplexModel->getIdPatchPanel() && $ComplexModel->getIdPatchPanel()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPatchPanel() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdCabinet($Pere);  
                }               
                $Pere->setIdPatchPanel($ac);                
            }            
        }
        else if ($typepere=="ui-gina-equi")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Equipment')->find($idpere);        
            if ($ComplexModel->getIdSlot() && $ComplexModel->getIdSlot()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdSlot() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdEquipment($Pere);  
                }               
                $Pere->setIdSlot($ac);                
            }
            if ($ComplexModel->getIdCard() && $ComplexModel->getIdCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdEquipment($Pere);   
                }              
                $Pere->setIdCard($ac);                
            }             
        }
        else if ($typepere=="ui-gina-patch")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:PatchPanel')->find($idpere);             
            if ($ComplexModel->getIdPort() && $ComplexModel->getIdPort()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPort() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdPatchPanel($Pere);                       
                }                
                $Pere->setIdPort($ac);                
            }
        }
        else if ($typepere=="ui-gina-slots")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Slot')->find($idpere);        
            if ($ComplexModel->getIdCard() && $ComplexModel->getIdCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdSlot($Pere);   
                }                
            }             
            $Pere->setIdCard($ac);            
        }
        else if ($typepere=="ui-gina-fille")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Card')->find($idpere);        
            if ($ComplexModel->getIdPort() && $ComplexModel->getIdPort()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPort() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdCard($Pere);                       
                }                
                $Pere->setIdPort($ac);                
            }             
        }
        else if ($typepere=="ui-gina-mere")
        {
            $Pere=$em->getRepository('EtraliGinangBundle:Card')->find($idpere);        
            if ($ComplexModel->getIdDaughterCard() && $ComplexModel->getIdDaughterCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdDaughterCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdMotherCard($Pere);                    
                }                
                $Pere->setIdDaughterCard($ac);
            }             
        }        
        else 
        {
            $Pere=$em->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere); 
            if ($ComplexModel->getIdCabinet() && $ComplexModel->getIdCabinet()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdCabinet() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdComplexModel($Pere);
                }                  
                $Pere->setIdCabinet($ac);
            }            
            if ($ComplexModel->getIdEquipment() && $ComplexModel->getIdEquipment()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdEquipment() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);
                    $cloneElem->setIdComplexModel($Pere);
                }                  
                $Pere->setIdEquipment($ac);
            }
            if ($ComplexModel->getIdPatchPanel() && $ComplexModel->getIdPatchPanel()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPatchPanel() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);   
                    $cloneElem->setIdComplexModel($Pere);                    
                }               
                $Pere->setIdPatchPanel($ac);                
            }      
            if ($ComplexModel->getIdSlot() && $ComplexModel->getIdSlot()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdSlot() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem); 
                    $cloneElem->setIdComplexModel($Pere);                    
                }               
                $Pere->setIdSlot($ac);                
            }
            if ($ComplexModel->getIdCard() && $ComplexModel->getIdCard()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdCard() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique();                     $ac->add($cloneElem);                    
                    $cloneElem->setIdComplexModel($Pere);                    
                }   
                $Pere->setIdCard($ac);                
            }  
            if ($ComplexModel->getIdPort() && $ComplexModel->getIdPort()->count()>0)
            {
                $ac = new ArrayCollection();                
                foreach ($ComplexModel->getIdPort() as $elem)
                {
                    $cloneElem=clone $elem;
                    $cloneElem->duplique(); 
                    $ac->add($cloneElem);
                    $cloneElem->setIdComplexModel($Pere);
                }
                $Pere->setIdPort($ac);
            }                
        }
        $em->persist($Pere);
        $em->flush();

        return new Response();
    }

    public function getProviderForCostAction($pk,$model)
    {
        $ComplexModel = $this->getObject($pk);

        if ($ComplexModel) {
            $id_contact="";
            $lb_contact="";
            $nb=0;
            $getter='get'.ucfirst($model);
            $elem=$ComplexModel->$getter()->first();
            $c=$elem->getIdContact();
            if ($c!=NULL)
                {
                    if ($c->getBlDeactivated() && $c->getIdContactType()->getIdContactType()==4)
                    {
                        $id_contact=$c->getIdContactProvider();
                        $lb_contact=$c;
                        if ($c->getBlDefault())
                        {
                            $nb=1;
                            break;
                        }
                        else
                            $nb++;
                    }
                }
                if ($nb>1)
                {
                    $id_contact="";
                    $lb_contact="";
                }
                $id_address="";
                $lb_address="";
                $nb=0;
                $c=$elem->getIdProviderAddress();
                if ($c!=NULL)
                {
                    if ($c->getBlStatus())
                    {
                        $id_address=$c->getIdAddressProvider();
                        $lb_address=$c;
                        if ($c->getIdAddressType()!=NULL && $c->getIdAddressType()->getIdAddressType()==3)
                        {
                            $nb=1;
                            break;
                        }
                        else
                            $nb++;
                    }
                }
                if ($nb>1)
                {
                    $id_address="";
                    $lb_address="";
                }

                return new Response($elem->getIdProvider()->getIdProvider()."\n".$elem->getIdProvider()."\n".$id_contact."\n".$lb_contact."\n".$id_address."\n".$lb_address);
        }
        else
            return new Response("");

    }
    
}
