<?php

namespace Etrali\GinangBundle\Controller\CostingCableLine;

use Admingenerated\EtraliGinangBundle\BaseCostingCableLineController\EditController as BaseEditController;

class EditController extends BaseEditController
{
           /**
     * Called jus after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\CostingCableLine $CostingCableLine your \Etrali\GinangBundle\Entity\CostingCableLine  object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\CostingCableLine $CostingCableLine)
    {
        $em=$this->getDoctrine()->getManager();        
        $uow = $em->getUnitOfWork();
        $uow->computeChangeSets();
        $changeset = $uow->getEntityChangeSet($CostingCableLine);
              
        foreach ($changeset as $fieldname=>$change)
        {
            if ($fieldname=="dtEndMrc")
            {
                if ($change[1]!=NULL && $change[0]==NULL)
                {
                    $costing=clone $CostingCableLine;
                    $costing->setMtMrc(null);
                    $costing->setMtNrc(null);
                    $costing->setMtMrcEuro(null);
                    $costing->setMtMrcEuro(null);
                    $costing->setLbMrc(null);
                    $costing->setLbNrc(null);   
                    $costing->setDtEndMrc(null);
                    $costing->setDtStartMrc($CostingCableLine->getDtEndMrc());
                    $costing->getDtStartMrc()->add(new \DateInterval('P1D'));
                    $em->persist($costing);
                    $em->flush();
                } 
                break;
            }
        }            
    }  
}
