<?php

namespace Etrali\GinangBundle\Controller\Customer;

use Admingenerated\EtraliGinangBundle\BaseCustomerController\ListController as BaseListController;
use Etrali\GinangBundle\Entity\Customer;

class ListController extends BaseListController
{
    public function selectWithDeliveryAndAdmin($query)
    {
        $query=$query->innerJoin("q.idAddress","a")->innerJoin("a.idAddressType","at")->andWhere("at.idAddressType=2")->andWhere("a.blStatus=1");
        $query=$query->innerJoin("q.idContact","c")->innerJoin("c.idContactType","ct")->andWhere("ct.idContactType=2")->andWhere("c.blDeactivated=1");        
        return $query;
    }
    
    public function getWithAddrAndContactAction()
    {
        $this->addToQuery="selectWithDeliveryAndAdmin";
        return $this->indexAction();
    }
    
    public function bcListAction()
    {
        $em = $this->getDoctrine()->getManager(); 
        $Service=$em->getRepository('EtraliGinangBundle:Service')->find($this->getRequest()->query->get('motherid'));
        $tab=array();
        foreach  ($Service->getIdServiceExtremity() as $extr)
        {
            if ($extr->getIdCustomer()!=NULL && !in_array($extr->getIdCustomer(),$tab))
                $tab[]=$extr->getIdCustomer();
        }
        return $this->render('EtraliGinangBundle:CustomerList:bclist.html.twig', array(
            "Customers" => $tab,
            "isSelect" => 1,
            "Service" => $Service
        ));
    }
  
    public function buildQuery()
    {
        $q=parent::buildQuery();
        if ($this->getUser()->getRole()!="ROLE_SUPER_ADMINISTRATOR" && ($this->getRequest()->get('tag')==NULL || ($this->getRequest()->get('tag')!='ServiceExtremity' && $this->getRequest()->get('tag')!='BilledCustomer')))
        {
            $modifiers=Customer::getReaderRoles();
            $idBranchs=array();
            foreach ($this->getUser()->getIdUserInBranch() as $branch)
            {
                if (in_array($branch->getRole(),$modifiers))
                        $idBranchs[]=$branch->getIdBranch()->getIdBranch();
            }
            if (count($idBranchs)>0)
            {
                $q=$q->innerJoin("q.idBranch","br")->andWhere("br.idBranch in (".implode(",",$idBranchs).")");
            }
        }
        return $q;
    }    
    
       
}
