<?php

namespace Etrali\GinangBundle\Controller\LocalLoop;

use Admingenerated\EtraliGinangBundle\BaseLocalLoopController\NewController as BaseNewController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Etrali\GinangBundle\Form\Type\LocalLoop\CustomValidator;
use Etrali\GinangBundle\SendMail;

class NewController extends BaseNewController
{
        
    public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(5,22); 
        return $type;
    }
    
    public function preForm($LocalLoop)
    {
        $LocalLoop->setCdLocalLoop("<automatic allocation>");

        $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(22);
        $LocalLoop->setIdTransactionStatus($TransStatus);

        $Owner=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:LocalLoopOwner')->find(1);
        $LocalLoop->setIdLocalLoopOwner($Owner);
    }

    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\LocalLoop $LocalLoop your \Etrali\GinangBundle\Entity\LocalLoop object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\LocalLoop $LocalLoop)
    {
        $extr=new \Etrali\GinangBundle\Entity\LocalLoopExtremity();
        $extr->setIdLocalLoop($LocalLoop);
        $extr->setCdLocalLoopExtremityRef("A1");

        $extr2=new \Etrali\GinangBundle\Entity\LocalLoopExtremity();
        $extr2->setIdLocalLoop($LocalLoop);   
        $extr2->setCdLocalLoopExtremityRef("B2");

        $extrt1=new \Etrali\GinangBundle\Entity\LocalLoopExtremityTech();
        $extrt1->setIdLocalLoop($LocalLoop);
        $extrt1->setIdLocalLoopExtremity($extr);

        $extrt2=new \Etrali\GinangBundle\Entity\LocalLoopExtremityTech();
        $extrt2->setIdLocalLoop($LocalLoop);
        $extrt2->setIdLocalLoopExtremity($extr2);  
        
        $LocalLoop->setNbOperation(1); 
        $LocalLoop->setCdLocalLoop("LL".$LocalLoop->getIdLocalLoop());          

        $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(5);
        $LocalLoop->setIdTransactionType($TransType);        
        $em = $this->getDoctrine()->getManager();
        $em->persist($LocalLoop);
        $em->persist($extr);
        $em->persist($extr2);
        $em->persist($extrt1);
        $em->persist($extrt2);

        $chaineret=CustomValidator::isValidForNextStep($LocalLoop,$this->getDoctrine()->getEntityManager(),$this);
        if ($chaineret=="")
        {          
            
            $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(22);
            $LocalLoop->setIdTransactionStatus($TransStatus);        
            
            $history=new \Etrali\GinangBundle\Entity\LocalLoopTransactions();
            $history->setIdLocalLoop($LocalLoop);
            $history->setCdLocalLoop($LocalLoop->getCdLocalLoop());
            $history->setIdTransactionStatus($TransStatus);
            $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(5);            
            $history->setIdTransactionType($TransType);
            $history->setLbOperation($TransType." 1");      

            $em->persist($history);

        }
        else
            $this->get('session')->getFlashBag()->add('error',  "Object has been saved but to move on in workflow the fields below are mandatory : <br>".$chaineret );
        $em->flush();        
    }
    
    
}
