<?php

namespace Etrali\GinangBundle\Controller\LocalLoopExtremityTech;

use Admingenerated\EtraliGinangBundle\BaseLocalLoopExtremityTechController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(5,22); 
        return $type;
    }
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $LocalLoopExtremityTech your \Etrali\GinangBundle\Entity\LocalLoopExtremityTech object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $LocalLoopExtremityTech)
    {       
        if ($LocalLoopExtremityTech->getIdOutConnectionPath())
        {
            foreach ($LocalLoopExtremityTech->getIdOutConnectionPath() as $line)
            {
                $line->setIdLocalLoopExtremityTech($LocalLoopExtremityTech);
            }
        }

    }     
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $LocalLoopExtremityTech your \Etrali\GinangBundle\Entity\LocalLoopExtremityTech object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\LocalLoopExtremityTech $LocalLoopExtremityTech)
    {
        $tech=  new \Etrali\GinangBundle\Entity\LocalLoopExtremity();
        $tech->setIdLocalLoop($LocalLoopExtremityTech->getIdLocalLoop());
       
        $LocalLoopExtremityTech->setIdLocalLoopExtremity($tech);
        
        $em = $this->getDoctrine()->getManager();
            $em->persist($tech);
            $em->persist($LocalLoopExtremityTech);
            $em->flush();
    } 
}
