<?php

namespace Etrali\GinangBundle\Controller\PatchPanel;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Admingenerated\EtraliGinangBundle\BasePatchPanelController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    
    public function linkAction(Request $request)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $PatchPanel=$em->getRepository('EtraliGinangBundle:PatchPanel')->find($request->get("id"));
        $type_pere=$request->get("typepere");
        switch ($type_pere)
        {
            case "ui-gina-comp":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($request->get("idpere"));
                   $PatchPanel->setIdComplexModel($Pere);                                
                break;
            case "ui-gina-cab":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($request->get("idpere"));
                   $PatchPanel->setIdCabinet($Pere);
                break;
            case "ui-gina-equi":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($request->get("idpere"));                            
                break;
            case "ui-gina-patch":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:PatchPanel')->find($request->get("idpere"));
                break;
            case "ui-gina-slots":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Slot')->find($request->get("idpere"));
                break;                
            case "ui-gina-fille":
            case "ui-gina-mere":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($request->get("idpere"));             
                break;              
        }
        $em->persist($PatchPanel);
        $em->flush();
        return new Response();
    }
        
   public function getReturnFunction($pk)
    {
                return new Response('<html><body><script>parent.location.reload(true);</script></body></html>');
    }
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\PatchPanel $PatchPanel your \Etrali\GinangBundle\Entity\PatchPanel object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\PatchPanel $PatchPanel)
    {

        if ($PatchPanel->getIdCostingPatchPanelLine() )
        {
            foreach ($PatchPanel->getIdCostingPatchPanelLine()as $line)
            {
                $line->setIdPatchPanel($PatchPanel);
            }
        }

    }

 
}
