<?php

namespace Etrali\GinangBundle\Controller\PatchPanel;

use Admingenerated\EtraliGinangBundle\BasePatchPanelController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));       
        return parent::indexAction();
    }
    
    public function getReturnFunction($PatchPanel)
    {
        return $this->render('EtraliGinangBundle:PatchPanelModal:index.html.twig', array(
                    "PatchPanel" => $PatchPanel
                ));
    }

    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\PatchPanel $PatchPanel your \Etrali\GinangBundle\Entity\PatchPanel object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\PatchPanel $PatchPanel)
    {
        if ($PatchPanel->getIdCostingPatchPanelLine())
        {
            foreach ($PatchPanel->getIdCostingPatchPanelLine() as $line)
            {
                $line->setIdPatchPanel($PatchPanel);
            }
        }

        $session = $this->getRequest()->getSession();         
        if ($session->has('typepere') && $session->has('idpere'))
        {
            $type_pere=$session->get('typepere');
            $idpere=$session->get('idpere');
            switch ($type_pere)
            {
                case "ui-gina-comp":
                       $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere);
                       $PatchPanel->setIdComplexModel($Pere);
                    break;    
            case "ui-gina-cab":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($idpere);
                   $PatchPanel->setIdCabinet($Pere);                
                break;
            }
        }           
    }      
}
