<?php

namespace Etrali\GinangBundle\Controller\PatchPanelInstance;

use Admingenerated\EtraliGinangBundle\BasePatchPanelInstanceController\NewController as BaseNewController;
use Etrali\GinangBundle\Entity\PortInstance;
use Etrali\GinangBundle\Entity\Ts;
use Exception;
use Symfony\Component\HttpFoundation\Response;

class NewController extends BaseNewController
{
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));
        if ($this->get('request')->query->has('return'))
            $session->set('return',$this->get('request')->query->get('return')); 
        if ($this->get('request')->query->has('nombre'))
            $session->set('nombre',$this->get('request')->query->get('nombre'));        
        return parent::indexAction();
    }
        
    private function handleTimeslots($em,$port,$patchinst)
    {
                $portinst=new PortInstance();
                $portinst->setCdPortInstance($port->getCdPort());
                $portinst->setLbPortInstance($port->getLbPort());
                $portinst->setCmPortInstance($port->getCmPort()); 
                $portinst->setIdPortType($port->getIdPortType());                
                $portinst->setBlDeactivated(true);
                $portinst->setIdPort($port);
                $portinst->setIdPatchPanelInstance($patchinst);
                $portinst->setNbNumber($port->getNbNumber());



                $em->persist($portinst);         
                               
                $TsStatus=$em->getRepository('EtraliGinangBundle:TsStatus')->find(1);                    
                for ($i=0;$i<$port->getNbTimeslots();$i++)
                {
                    $ts=new Ts();
                    $ts->setIdPortInstance($portinst);
                    $ts->setNbTs($i+$port->getIdPortType()->getNbTsStart());
                    $ts->setNbChannel($i+$port->getIdPortType()->getNbChannelStart());
                    $ts->setLbTs($ts->getNbTs());
                    $ts->setIdTsStatus($TsStatus);                        

                    $em->persist($ts);
                }                 
    } 
    
    public function createAction()
    {
        $em=$this->getDoctrine()->getEntityManager()        ;
        $PatchPanelInstance = $this->getNewObject();

        $this->preBindRequest($PatchPanelInstance);
        $form = $this->createForm($this->getNewType(), $PatchPanelInstance);
      
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $PatchPanelInstance);
                $session = $this->getRequest()->getSession();  
                $idpere=$session->get('idpere');
                $Pere=$em->getRepository('EtraliGinangBundle:CabinetInstance')->find($idpere);
                $PatchPanelInstance->setIdCabinetInstance($Pere);               
                $this->saveObject($PatchPanelInstance);
                $this->postSave($form, $PatchPanelInstance);

                $entites=array();
                $entites[]=$PatchPanelInstance;
                
                if ($session->has("nombre"))
                {
                    for ($i=1;$i<$session->get("nombre");$i++)
                    {
                        $entites[]=clone $PatchPanelInstance;
                    }
                }
                
                foreach ($entites as $ppanelinst)
                {
                    $models=$ppanelinst->getIdComplexModel()->getIdPatchPanel();
                    $cpt=0;
                    foreach ($models as $model)
                    {   
                        if ($cpt>0)
                            $ppanelinst=clone $PatchPanelInstance;
                        $cpt++;
                        $ppanelinst->setIdPatchPanel($model);
                        
                        foreach ($model->getIdCostingPatchPanelLine() as $costing)
                        {
                            $newcost=clone $costing;
                            $newcost->setIdPatchPanel(NULL);
                            $newcost->setIdPatchPanelInstance($ppanelinst); 
                            $em->persist($newcost); 
                        }

                        
                        $em->persist($ppanelinst); 
                        
                        foreach($model->getIdPort() as $port)
                        {
                            handleTimeslots($em,$port,$ppanelinst);
                        }                    
                    }
                }
                $em->flush();           
                
                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );
                return new Response('<html><body><script>parent.location.reload(true);</script></body></html>');
            } catch (Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $PatchPanelInstance);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('EtraliGinangBundle:PatchPanelInstanceNew:index.html.twig', $this->getAdditionalRenderParameters($PatchPanelInstance) + array(
            "PatchPanelInstance" => $PatchPanelInstance,
            "form" => $form->createView(),
        ));
    }
        
}
