<?php

namespace Etrali\GinangBundle\Controller\Service;

use Etrali\GinangBundle\Entity\ServiceCaracs;
use Etrali\GinangBundle\Form\Type\Service\CustomValidator;
use Admingenerated\EtraliGinangBundle\BaseServiceController\NewController as BaseNewController;
use Etrali\GinangBundle\Entity\TransferPrice;

class NewController extends BaseNewController
{
    
    public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(9,44);          
        return $type;
    }
    
    public function preForm($Service)
    {
        $Service->setCdService("<automatic allocation>");
        $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(9);
        $Service->setIdTransactionType($TransType);
        $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(44);
        $Service->setIdTransactionStatus($TransStatus);

    }
    

        
     /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Service $Service your \Etrali\GinangBundle\Entity\Service object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Service $Service)
    {
        $em=$this->getDoctrine()->getEntityManager();
        
  
            
            $nbExtr=$Service->getIdProduct()->getIdProductType()->getNbExtremities();
            
            $extr=new \Etrali\GinangBundle\Entity\ServiceExtremity();
            $extr->setIdService($Service);
            $extr->setCdServiceExtremity("A1");                       
                        
            $extrt1=new \Etrali\GinangBundle\Entity\ServiceExtremityTech();
            $extrt1->setIdService($Service);
            $extrt1->setIdServiceExtremity($extr);            
            
            $em->persist($extr);
            $em->persist($extrt1);
                        
            
            if ($nbExtr>1)
            {
                $extr2=new \Etrali\GinangBundle\Entity\ServiceExtremity();
                $extr2->setIdService($Service);
                $extr2->setCdServiceExtremity("B2");
                
                $extrt2=new \Etrali\GinangBundle\Entity\ServiceExtremityTech();
                $extrt2->setIdService($Service);
                $extrt2->setIdServiceExtremity($extr2);                
            
                $em->persist($extr2);
                $em->persist($extrt2);                            
            }            
            
            if ($Service->getIdProduct()->getIdProductType()->getBlBillable())
            {
                $bill=new \Etrali\GinangBundle\Entity\BillingService();
                $bill->setIdService($Service);

                $bill_line=new \Etrali\GinangBundle\Entity\BillingServiceLine();
                $bill_line->setIdService($Service);             
                $bill_line->setIdBillingService($bill);
                $bill_line->addIdServiceExtremity($extr);
                
                if (isset($extr2))
                    $bill_line->addIdServiceExtremity($extr2);
                $em->persist($bill_line);                
                $em->persist($bill);

                
            }
            
            $ProductCaracs=$Service->getIdProduct()->getIdProductType()->getIdProductCaracs();
            foreach ($ProductCaracs as $carac)
            {
                if ($carac->getNbLocation()==0)
                {
                    $s_carac=new ServiceCaracs();
                    $s_carac->setIdProductCaracs($carac);
                    $s_carac->setIdService($Service);
                    $em->persist($s_carac);                
                }
                else if ($carac->getNbLocation()==1)
                {
                    $s_carac=new ServiceCaracs();
                    $s_carac->setIdProductCaracs($carac);
                    $s_carac->setIdServiceExtremity($extr);
                    $em->persist($s_carac);              
                    
                    if (isset($extr2))
                    {
                        $s_carac=new ServiceCaracs();
                        $s_carac->setIdProductCaracs($carac);
                        $s_carac->setIdServiceExtremity($extr2);
                        $em->persist($s_carac);                         
                    }
                }
                else if ($carac->getNbLocation()==2)
                {
                    $s_carac=new ServiceCaracs();
                    $s_carac->setIdProductCaracs($carac);
                    $s_carac->setIdServiceExtremityTech($extrt1);
                    $em->persist($s_carac);              
                    
                    if (isset($extrt2))
                    {
                        $s_carac=new ServiceCaracs();
                        $s_carac->setIdProductCaracs($carac);
                        $s_carac->setIdServiceExtremityTech($extrt2);
                        $em->persist($s_carac);                         
                    }
                }                
            }            
            
            $Service->setNbOperation(1); 
            $Service->setCdService("S".$Service->getIdService());                                                  
            
            $em->persist($Service);
        
        $em->flush();
    }

}
