<?php

namespace Etrali\GinangBundle\Controller\ServiceExtremity;

use Admingenerated\EtraliGinangBundle\BaseServiceExtremityController\NewController as BaseNewController;
use Etrali\GinangBundle\Entity\ServiceCaracs;
use Etrali\GinangBundle\Entity\ServiceExtremity;
use Etrali\GinangBundle\Entity\ServiceExtremityTech;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Etrali\GinangBundle\Entity\TransferPrice;

class NewController extends BaseNewController
{
    var $parentObj=null;
    
    public function indexAction()
    {
            $em=$this->getDoctrine()->getManager();
            $object=$em->getRepository('EtraliGinangBundle:Service')->find($this->get('request')->query->get('motherid'));
            
            $ServiceExtremity=new ServiceExtremity();
            $ServiceExtremity->setIdService($object);
            
            if ($object->getIdProduct()->getIdProductType()->getIdProductType()!=21)
            {
                $Currency=$em->getRepository('EtraliGinangBundle:Currency')->findOneByCdCurrency("EUR");           
                $tp=new TransferPrice();
                $tp->setIdServiceExtremity($ServiceExtremity);
                $tp->setIdCurrency($Currency);   
                $em->persist($tp);                
            }
            
            $cpt=$object->getNotOldExtremityCount();
            $ServiceExtremity->setCdServiceExtremity(chr(65+$cpt).$cpt);                     
            
            $tech=  new ServiceExtremityTech();
            $tech->setIdService($object);
            $tech->setIdServiceExtremity($ServiceExtremity); 
            
            $ServiceExtremity->setIdServiceExtremityTech($tech);

            $em->persist($tech);
            $em->persist($ServiceExtremity);

            
            $ProductCaracs=$object->getIdProduct()->getIdProductType()->getIdProductCaracs();
            foreach ($ProductCaracs as $carac)
            {
                if ($carac->getNbLocation()==1)
                {
                    $s_carac=new ServiceCaracs();
                    $s_carac->setIdProductCaracs($carac);
                    $s_carac->setIdServiceExtremity($ServiceExtremity);
                    $em->persist($s_carac);              
                }
                else if ($carac->getNbLocation()==2)
                {
                    $s_carac=new ServiceCaracs();
                    $s_carac->setIdProductCaracs($carac);
                    $s_carac->setIdServiceExtremityTech($tech);
                    $em->persist($s_carac);              
                }                
            }  

            $em->flush();        
            

            if ($object->getIdTransactionStatus()->getIdTransactionStatus()!=44)
            {
                $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(86);        
                $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(13); 
                
                $object->setIdTransactionType($TransType);
                $object->setIdTransactionStatus($TransStatus);
                $object->setIdTransferExtremity($ServiceExtremity);
                $object->setBlValidated(false);                
                $object->setIdSelectedExtremity(NULL);    
                $object->setBlLlstatus(false);
                $object->setBlBbstatus(false);                 

                $object->setNbOperation($object->getNbOperation()+1); 

                $em->persist($object);
                $em->flush();
            }
            
            return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_ServiceExtremity_edit" ,array("pk"=>$ServiceExtremity->getIdServiceExtremity()))."?isSelect=1");
    }
    
    public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(9,44);  
        $type->setOld(false); 
        $type->setObject($this->parentObj);
        return $type;
    }  
    
    public function preForm($ServiceExtremity)
    {
            $this->parentObj=$ServiceExtremity;
    }
}
