<?php

namespace Etrali\GinangBundle\Controller\ServiceExtremityTech;
use Etrali\GinangBundle\Entity\ServiceCaracs;
use Etrali\GinangBundle\Entity\ServiceExtremity;
use Etrali\GinangBundle\Entity\ServiceExtremityTech;
use Admingenerated\EtraliGinangBundle\BaseServiceExtremityTechController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    var $parentObj=null;
    
    public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(9,44);  
        $type->setObject($this->parentObj);        
        return $type;
    }    
    
    public function preForm($ServiceExtremityTech)
    {
            $object=$this->getDoctrine()->getManager()->getRepository('EtraliGinangBundle:Service')->find($this->get('request')->query->get('motherid'));
            
            $ProductCaracs=$object->getIdProduct()->getIdProductType()->getIdProductCaracs();
            foreach ($ProductCaracs as $carac)
            {
                if ($carac->getNbLocation()==2)
                {
                    $s_carac=new ServiceCaracs();
                    $s_carac->setIdProductCaracs($carac);
                    $s_carac->setIdServiceExtremityTech($ServiceExtremityTech);  
                    $ServiceExtremityTech->addIdServiceCarac($s_carac);   
                }
            }
            $ServiceExtremityTech->setIdService($object);            
            $this->parentObj=$ServiceExtremityTech;
    }
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $ServiceExtremityTech your \Etrali\GinangBundle\Entity\ServiceExtremityTech object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\ServiceExtremityTech $ServiceExtremityTech)
    {
        $tech=  new \Etrali\GinangBundle\Entity\ServiceExtremity();
        $tech->setIdService($ServiceExtremityTech->getIdService());
       
        $ServiceExtremityTech->setIdServiceExtremity($tech);
        
        $em = $this->getDoctrine()->getManager();
            $em->persist($tech);
            $em->persist($ServiceExtremityTech);
            $em->flush();
    }     
}
