<?php

namespace Etrali\GinangBundle\Controller\Slot;

use Admingenerated\EtraliGinangBundle\BaseSlotController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));    
        if ($this->get('request')->query->has('nombre'))
            $session->set('nombre',$this->get('request')->query->get('nombre'));          
        return parent::indexAction();
    }
    
    public function getReturnFunction($Slot)
    {
        $session = $this->getRequest()->getSession();        
        return $this->render('EtraliGinangBundle:SlotModal:index.html.twig', array(
                    "Slots" => $this->slots
                ));
    }
    /**
     * Called jus after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Slot $Slot your \Etrali\GinangBundle\Entity\Slot object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Slot $Slot)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $session = $this->getRequest()->getSession(); 
        $nombre=$session->get('nombre');
        $slots=array();
        $slots[]=$Slot;        
        if ($nombre>1)
        {
            for ($i=1;$i<$nombre;$i++)
            {
                $sl=clone $Slot;
                if ($this->get('session')->has('typepere') && $session->has('idpere'))
                {
                    $type_pere=$session->get('typepere');
                    $idpere=$session->get('idpere');
                    switch ($type_pere)
                    {
                        case "ui-gina-comp":
                               $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere);
                               $sl->setIdComplexModel($Pere);
                            break;    
                    case "ui-gina-equi":
                           $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($idpere);
                           $sl->setIdEquipment($Pere);                                
                        break;
                    }
                }                 
                $em->persist($sl);
                $slots[]=$sl;                
            }
            $em->flush();
        } 

        $this->slots=$slots;
        $Equipment=$Slot->getIdEquipment();        
        $nb=1;
        if ($Equipment!=NULL)
        {
            foreach ($Equipment->getIdSlot() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }          
            $em->flush();
        }
    }   
    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Slot $Slot your \Etrali\GinangBundle\Entity\Slot object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Slot $Slot)
    {
        $session = $this->getRequest()->getSession();         
        if ($this->get('session')->has('typepere') && $session->has('idpere'))
        {
            $type_pere=$session->get('typepere');
            $idpere=$session->get('idpere');
            switch ($type_pere)
            {
                case "ui-gina-comp":
                       $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere);
                       $Slot->setIdComplexModel($Pere);
                    break;    
            case "ui-gina-equi":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($idpere);
                   $Slot->setIdEquipment($Pere);                                
                break;
            }
        }           
    }       

}
