<?php

namespace Etrali\GinangBundle\Controller\WorldwideGroup;

use Admingenerated\EtraliGinangBundle\BaseWorldwideGroupController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\WorldwideGroup $WorldwideGroup your \Etrali\GinangBundle\Entity\WorldwideGroup object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\WorldwideGroup $WorldwideGroup)
    {
        if ($WorldwideGroup->getIdAddress())
        {
            foreach ($WorldwideGroup->getIdBranchCluster() as $line)
            {
                $line->setIdWorldwideGroup($WorldwideGroup);
            }
        }       
    }     
}
