<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * AddressMagellan
 *
 * @ORM\Table(name="address_magellan")
 * @ORM\Entity
 */
class AddressMagellan
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_address_magellan", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idAddressMagellan;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_address_gina", type="integer", nullable=true)
     */
    private $idAddressGina;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_account_magellan", type="string", length=15, nullable=true)
     */
    private $cdAccountMagellan;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;

    /**
     * @var \Customer
     *
     * @ORM\ManyToOne(targetEntity="Customer")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_customer_gina", referencedColumnName="id_customer")
     * })
     */
    private $idCustomerGina;

    /**
     * @var \AddressType
     *
     * @ORM\ManyToOne(targetEntity="AddressType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_type_address", referencedColumnName="id_address_type")
     * })
     */
    private $idTypeAddress;



    /**
     * Get idAddressMagellan
     *
     * @return integer 
     */
    public function getIdAddressMagellan()
    {
        return $this->idAddressMagellan;
    }

    /**
     * Set idAddressGina
     *
     * @param integer $idAddressGina
     * @return AddressMagellan
     */
    public function setIdAddressGina($idAddressGina)
    {
        $this->idAddressGina = $idAddressGina;
    
        return $this;
    }

    /**
     * Get idAddressGina
     *
     * @return integer 
     */
    public function getIdAddressGina()
    {
        return $this->idAddressGina;
    }

    /**
     * Set cdAccountMagellan
     *
     * @param string $cdAccountMagellan
     * @return AddressMagellan
     */
    public function setCdAccountMagellan($cdAccountMagellan)
    {
        $this->cdAccountMagellan = $cdAccountMagellan;
    
        return $this;
    }

    /**
     * Get cdAccountMagellan
     *
     * @return string 
     */
    public function getCdAccountMagellan()
    {
        return $this->cdAccountMagellan;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return AddressMagellan
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set idCustomerGina
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomerGina
     * @return AddressMagellan
     */
    public function setIdCustomerGina(\Etrali\GinangBundle\Entity\Customer $idCustomerGina = null)
    {
        $this->idCustomerGina = $idCustomerGina;
    
        return $this;
    }

    /**
     * Get idCustomerGina
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomerGina()
    {
        return $this->idCustomerGina;
    }

    /**
     * Set idTypeAddress
     *
     * @param \Etrali\GinangBundle\Entity\AddressType $idTypeAddress
     * @return AddressMagellan
     */
    public function setIdTypeAddress(\Etrali\GinangBundle\Entity\AddressType $idTypeAddress = null)
    {
        $this->idTypeAddress = $idTypeAddress;
    
        return $this;
    }

    /**
     * Get idTypeAddress
     *
     * @return \Etrali\GinangBundle\Entity\AddressType 
     */
    public function getIdTypeAddress()
    {
        return $this->idTypeAddress;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }