<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CiSessions
 *
 * @ORM\Table(name="ci_sessions")
 * @ORM\Entity
 */
class CiSessions
{
    /**
     * @var string
     *
     * @ORM\Column(name="session_id", type="string", length=40, nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $sessionId;

    /**
     * @var string
     *
     * @ORM\Column(name="session_user_id", type="string", length=40, nullable=false)
     */
    private $sessionUserId;

    /**
     * @var string
     *
     * @ORM\Column(name="ip_address", type="string", length=40, nullable=false)
     */
    private $ipAddress;

    /**
     * @var string
     *
     * @ORM\Column(name="user_agent", type="string", length=150, nullable=false)
     */
    private $userAgent;

    /**
     * @var string
     *
     * @ORM\Column(name="last_page", type="string", length=150, nullable=false)
     */
    private $lastPage;

    /**
     * @var integer
     *
     * @ORM\Column(name="last_activity", type="integer", nullable=false)
     */
    private $lastActivity;

    /**
     * @var string
     *
     * @ORM\Column(name="session_data", type="string", length=250, nullable=true)
     */
    private $sessionData;

    /**
     * @var string
     *
     * @ORM\Column(name="user_data", type="string", length=255, nullable=false)
     */
    private $userData;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get sessionId
     *
     * @return string 
     */
    public function getSessionId()
    {
        return $this->sessionId;
    }

    /**
     * Set sessionUserId
     *
     * @param string $sessionUserId
     * @return CiSessions
     */
    public function setSessionUserId($sessionUserId)
    {
        $this->sessionUserId = $sessionUserId;
    
        return $this;
    }

    /**
     * Get sessionUserId
     *
     * @return string 
     */
    public function getSessionUserId()
    {
        return $this->sessionUserId;
    }

    /**
     * Set ipAddress
     *
     * @param string $ipAddress
     * @return CiSessions
     */
    public function setIpAddress($ipAddress)
    {
        $this->ipAddress = $ipAddress;
    
        return $this;
    }

    /**
     * Get ipAddress
     *
     * @return string 
     */
    public function getIpAddress()
    {
        return $this->ipAddress;
    }

    /**
     * Set userAgent
     *
     * @param string $userAgent
     * @return CiSessions
     */
    public function setUserAgent($userAgent)
    {
        $this->userAgent = $userAgent;
    
        return $this;
    }

    /**
     * Get userAgent
     *
     * @return string 
     */
    public function getUserAgent()
    {
        return $this->userAgent;
    }

    /**
     * Set lastPage
     *
     * @param string $lastPage
     * @return CiSessions
     */
    public function setLastPage($lastPage)
    {
        $this->lastPage = $lastPage;
    
        return $this;
    }

    /**
     * Get lastPage
     *
     * @return string 
     */
    public function getLastPage()
    {
        return $this->lastPage;
    }

    /**
     * Set lastActivity
     *
     * @param integer $lastActivity
     * @return CiSessions
     */
    public function setLastActivity($lastActivity)
    {
        $this->lastActivity = $lastActivity;
    
        return $this;
    }

    /**
     * Get lastActivity
     *
     * @return integer 
     */
    public function getLastActivity()
    {
        return $this->lastActivity;
    }

    /**
     * Set sessionData
     *
     * @param string $sessionData
     * @return CiSessions
     */
    public function setSessionData($sessionData)
    {
        $this->sessionData = $sessionData;
    
        return $this;
    }

    /**
     * Get sessionData
     *
     * @return string 
     */
    public function getSessionData()
    {
        return $this->sessionData;
    }

    /**
     * Set userData
     *
     * @param string $userData
     * @return CiSessions
     */
    public function setUserData($userData)
    {
        $this->userData = $userData;
    
        return $this;
    }

    /**
     * Get userData
     *
     * @return string 
     */
    public function getUserData()
    {
        return $this->userData;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CiSessions
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }