<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CostCenter
 *
 * @ORM\Table(name="cost_center")
 * @ORM\Entity
 */
class CostCenter
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_cost_center", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCostCenter;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_cost_center", type="string", length=15, nullable=true)
     */
    private $cdCostCenter;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_cost_center", type="string", length=100, nullable=true)
     */
    private $lbCostCenter;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_cost_center", type="decimal", nullable=true)
     */
    private $nbCostCenter;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idCostCenter
     *
     * @return integer 
     */
    public function getIdCostCenter()
    {
        return $this->idCostCenter;
    }

    /**
     * Set cdCostCenter
     *
     * @param string $cdCostCenter
     * @return CostCenter
     */
    public function setCdCostCenter($cdCostCenter)
    {
        $this->cdCostCenter = $cdCostCenter;
    
        return $this;
    }

    /**
     * Get cdCostCenter
     *
     * @return string 
     */
    public function getCdCostCenter()
    {
        return $this->cdCostCenter;
    }

    /**
     * Set lbCostCenter
     *
     * @param string $lbCostCenter
     * @return CostCenter
     */
    public function setLbCostCenter($lbCostCenter)
    {
        $this->lbCostCenter = $lbCostCenter;
    
        return $this;
    }

    /**
     * Get lbCostCenter
     *
     * @return string 
     */
    public function getLbCostCenter()
    {
        return $this->lbCostCenter;
    }

    /**
     * Set nbCostCenter
     *
     * @param float $nbCostCenter
     * @return CostCenter
     */
    public function setNbCostCenter($nbCostCenter)
    {
        $this->nbCostCenter = $nbCostCenter;
    
        return $this;
    }

    /**
     * Get nbCostCenter
     *
     * @return float 
     */
    public function getNbCostCenter()
    {
        return $this->nbCostCenter;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return CostCenter
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }