<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CustomerAddress
 *
 * @ORM\Table(name="customer_address")
 * @ORM\Entity
 */
class CustomerAddress
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var \Customer
     *
     * @ORM\ManyToOne(targetEntity="Customer")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_customer", referencedColumnName="id_customer")
     * })
     */
    private $idCustomer;

    /**
     * @var \Address
     *
     * @ORM\ManyToOne(targetEntity="Address")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address", referencedColumnName="id_address")
     * })
     */
    private $idAddress;



    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     * @return CustomerAddress
     */
    public function setIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer = null)
    {
        $this->idCustomer = $idCustomer;
    
        return $this;
    }

    /**
     * Get idCustomer
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomer()
    {
        return $this->idCustomer;
    }

    /**
     * Set idAddress
     *
     * @param \Etrali\GinangBundle\Entity\Address $idAddress
     * @return CustomerAddress
     */
    public function setIdAddress(\Etrali\GinangBundle\Entity\Address $idAddress = null)
    {
        $this->idAddress = $idAddress;
    
        return $this;
    }

    /**
     * Get idAddress
     *
     * @return \Etrali\GinangBundle\Entity\Address 
     */
    public function getIdAddress()
    {
        return $this->idAddress;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }