<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * CustomerMagellan
 *
 * @ORM\Table(name="customer_magellan")
 * @ORM\Entity
 */
class CustomerMagellan
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_customer_magellan", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCustomerMagellan;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_load", type="boolean", nullable=true)
     */
    private $blLoad;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_fact", type="boolean", nullable=true)
     */
    private $blFact;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_account_magellan", type="string", length=15, nullable=true)
     */
    private $cdAccountMagellan;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;

    /**
     * @var \Customer
     *
     * @ORM\ManyToOne(targetEntity="Customer")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_customer_gina", referencedColumnName="id_customer")
     * })
     */
    private $idCustomerGina;



    /**
     * Get idCustomerMagellan
     *
     * @return integer 
     */
    public function getIdCustomerMagellan()
    {
        return $this->idCustomerMagellan;
    }

    /**
     * Set blLoad
     *
     * @param boolean $blLoad
     * @return CustomerMagellan
     */
    public function setBlLoad($blLoad)
    {
        $this->blLoad = $blLoad;
    
        return $this;
    }

    /**
     * Get blLoad
     *
     * @return boolean 
     */
    public function getBlLoad()
    {
        return $this->blLoad;
    }

    /**
     * Set blFact
     *
     * @param boolean $blFact
     * @return CustomerMagellan
     */
    public function setBlFact($blFact)
    {
        $this->blFact = $blFact;
    
        return $this;
    }

    /**
     * Get blFact
     *
     * @return boolean 
     */
    public function getBlFact()
    {
        return $this->blFact;
    }

    /**
     * Set cdAccountMagellan
     *
     * @param string $cdAccountMagellan
     * @return CustomerMagellan
     */
    public function setCdAccountMagellan($cdAccountMagellan)
    {
        $this->cdAccountMagellan = $cdAccountMagellan;
    
        return $this;
    }

    /**
     * Get cdAccountMagellan
     *
     * @return string 
     */
    public function getCdAccountMagellan()
    {
        return $this->cdAccountMagellan;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return CustomerMagellan
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set idCustomerGina
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomerGina
     * @return CustomerMagellan
     */
    public function setIdCustomerGina(\Etrali\GinangBundle\Entity\Customer $idCustomerGina = null)
    {
        $this->idCustomerGina = $idCustomerGina;
    
        return $this;
    }

    /**
     * Get idCustomerGina
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomerGina()
    {
        return $this->idCustomerGina;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }