<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * EventType
 *
 * @ORM\Table(name="event_type")
 * @ORM\Entity
 */
class EventType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_event_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idEventType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_event_type", type="string", length=50, nullable=true)
     */
    private $cdEventType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_event_type", type="string", length=255, nullable=true)
     */
    private $lbEventType;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idEventType
     *
     * @return integer 
     */
    public function getIdEventType()
    {
        return $this->idEventType;
    }

    /**
     * Set cdEventType
     *
     * @param string $cdEventType
     * @return EventType
     */
    public function setCdEventType($cdEventType)
    {
        $this->cdEventType = $cdEventType;
    
        return $this;
    }

    /**
     * Get cdEventType
     *
     * @return string 
     */
    public function getCdEventType()
    {
        return $this->cdEventType;
    }

    /**
     * Set lbEventType
     *
     * @param string $lbEventType
     * @return EventType
     */
    public function setLbEventType($lbEventType)
    {
        $this->lbEventType = $lbEventType;
    
        return $this;
    }

    /**
     * Get lbEventType
     *
     * @return string 
     */
    public function getLbEventType()
    {
        return $this->lbEventType;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return EventType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }