<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LinkProtocol
 *
 * @ORM\Table(name="link_protocol")
 * @ORM\Entity
 */
class LinkProtocol
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_link_protocol", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLinkProtocol;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_link_protocol", type="string", length=100, nullable=true)
     */
    private $cdLinkProtocol;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_link_protocol", type="string", length=255, nullable=true)
     */
    private $lbLinkProtocol;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_rate", type="integer", nullable=true)
     */
    private $nbRate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idLinkProtocol
     *
     * @return integer 
     */
    public function getIdLinkProtocol()
    {
        return $this->idLinkProtocol;
    }

    /**
     * Set cdLinkProtocol
     *
     * @param string $cdLinkProtocol
     * @return LinkProtocol
     */
    public function setCdLinkProtocol($cdLinkProtocol)
    {
        $this->cdLinkProtocol = $cdLinkProtocol;
    
        return $this;
    }

    /**
     * Get cdLinkProtocol
     *
     * @return string 
     */
    public function getCdLinkProtocol()
    {
        return $this->cdLinkProtocol;
    }

    /**
     * Set lbLinkProtocol
     *
     * @param string $lbLinkProtocol
     * @return LinkProtocol
     */
    public function setLbLinkProtocol($lbLinkProtocol)
    {
        $this->lbLinkProtocol = $lbLinkProtocol;
    
        return $this;
    }

    /**
     * Get lbLinkProtocol
     *
     * @return string 
     */
    public function getLbLinkProtocol()
    {
        return $this->lbLinkProtocol;
    }

    /**
     * Set nbRate
     *
     * @param integer $nbRate
     * @return LinkProtocol
     */
    public function setNbRate($nbRate)
    {
        $this->nbRate = $nbRate;
    
        return $this;
    }

    /**
     * Get nbRate
     *
     * @return integer 
     */
    public function getNbRate()
    {
        return $this->nbRate;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return LinkProtocol
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }