<?php

namespace Etrali\GinangBundle\Entity;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LocalLoopCostType
 *
 * @ORM\Table(name="local_loop_cost_type")
 * @ORM\Entity
 */
class LocalLoopCostType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_local_loop_cost_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLocalLoopCostType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_local_loop_cost_type", type="string", length=255, nullable=true)
     * @Assert\NotBlank()
     * @Assert\MaxLength(50) 
     */
    private $lbLocalLoopCostType;


    /**
     * Get __toString
     *
     * @return string
     */    
    
    public function __toString()
    {
            return $this->getLbLocalLoopCostType().'';
    }
    
  public function getParentBranch() { return NULL; } 
  
  
  
    /**
     * Get idLocalLoopCostType
     *
     * @return integer 
     */
    public function getIdLocalLoopCostType()
    {
        return $this->idLocalLoopCostType;
    }

    /**
     * Set lbLocalLoopCostType
     *
     * @param string $lbLocalLoopCostType
     * @return LocalLoopCostType
     */
    public function setLbLocalLoopCostType($lbLocalLoopCostType)
    {
        $this->lbLocalLoopCostType = $lbLocalLoopCostType;
    
        return $this;
    }

    /**
     * Get lbLocalLoopCostType
     *
     * @return string 
     */
    public function getLbLocalLoopCostType()
    {
        return $this->lbLocalLoopCostType;
    }
}