<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Log
 *
 * @ORM\Table(name="log")
 * @ORM\Entity
 */
class Log
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_log", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLog;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_object", type="integer", nullable=true)
     */
    private $idObject;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="string", length=255, nullable=true)
     */
    private $cmComment;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectType;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;



    /**
     * Get idLog
     *
     * @return integer 
     */
    public function getIdLog()
    {
        return $this->idLog;
    }

    /**
     * Set idObject
     *
     * @param integer $idObject
     * @return Log
     */
    public function setIdObject($idObject)
    {
        $this->idObject = $idObject;
    
        return $this;
    }

    /**
     * Get idObject
     *
     * @return integer 
     */
    public function getIdObject()
    {
        return $this->idObject;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return Log
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return Log
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return Log
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return Log
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }