<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * LogModel
 *
 * @ORM\Table(name="log_model")
 * @ORM\Entity
 */
class LogModel
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_log_model", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idLogModel;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_comment", type="string", length=255, nullable=true)
     */
    private $cmComment;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectType;



    /**
     * Get idLogModel
     *
     * @return integer 
     */
    public function getIdLogModel()
    {
        return $this->idLogModel;
    }

    /**
     * Set cmComment
     *
     * @param string $cmComment
     * @return LogModel
     */
    public function setCmComment($cmComment)
    {
        $this->cmComment = $cmComment;
    
        return $this;
    }

    /**
     * Get cmComment
     *
     * @return string 
     */
    public function getCmComment()
    {
        return $this->cmComment;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return LogModel
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }