<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Mail
 *
 * @ORM\Table(name="mail")
 * @ORM\Entity
 */
class Mail 
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_mail", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idMail;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_transaction_type", type="string", length=50, nullable=true)
     */
    private $lbTransactionType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_mail", type="string", length=100, nullable=true)
     */
    private $lbMail;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_subject", type="string", length=100, nullable=true)
     */
    private $lbSubject;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_text", type="string", length=255, nullable=true)
     */
    private $lbText;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_mail", type="integer", nullable=true)
     */
    private $nbMail;

    public function __toString()
    {
        return $this->getLbSubject()."";
    }

    /**
     * Get idMail
     *
     * @return integer 
     */
    public function getIdMail()
    {
        return $this->idMail;
    }

    /**
     * Set lbTransactionType
     *
     * @param string $lbTransactionType
     * @return Mail
     */
    public function setLbTransactionType($lbTransactionType)
    {
        $this->lbTransactionType = $lbTransactionType;
    
        return $this;
    }

    /**
     * Get lbTransactionType
     *
     * @return string 
     */
    public function getLbTransactionType()
    {
        return $this->lbTransactionType;
    }

    /**
     * Set lbMail
     *
     * @param string $lbMail
     * @return Mail
     */
    public function setLbMail($lbMail)
    {
        $this->lbMail = $lbMail;
    
        return $this;
    }

    /**
     * Get lbMail
     *
     * @return string 
     */
    public function getLbMail()
    {
        return $this->lbMail;
    }

    /**
     * Set lbSubject
     *
     * @param string $lbSubject
     * @return Mail
     */
    public function setLbSubject($lbSubject)
    {
        $this->lbSubject = $lbSubject;
    
        return $this;
    }

    /**
     * Get lbSubject
     *
     * @return string 
     */
    public function getLbSubject()
    {
        return $this->lbSubject;
    }

    /**
     * Set lbText
     *
     * @param string $lbText
     * @return Mail
     */
    public function setLbText($lbText)
    {
        $this->lbText = $lbText;
    
        return $this;
    }

    /**
     * Get lbText
     *
     * @return string 
     */
    public function getLbText()
    {
        return $this->lbText;
    }

    /**
     * Set nbMail
     *
     * @param integer $nbMail
     * @return Mail
     */
    public function setNbMail($nbMail)
    {
        $this->nbMail = $nbMail;
    
        return $this;
    }

    /**
     * Get nbMail
     *
     * @return integer 
     */
    public function getNbMail()
    {
        return $this->nbMail;
    }public function getParentBranch() { return NULL; }  }