<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ObjectType
 *
 * @ORM\Table(name="object_type")
 * @ORM\Entity
 */
class ObjectType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_object_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idObjectType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_object_type", type="string", length=100, nullable=true)
     */
    private $cdObjectType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_object_type", type="string", length=100, nullable=true)
     */
    private $lbObjectType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_table_name", type="string", length=100, nullable=true)
     */
    private $lbTableName;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_id_name", type="string", length=100, nullable=true)
     */
    private $lbIdName;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idObjectType
     *
     * @return integer 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }

    /**
     * Set cdObjectType
     *
     * @param string $cdObjectType
     * @return ObjectType
     */
    public function setCdObjectType($cdObjectType)
    {
        $this->cdObjectType = $cdObjectType;
    
        return $this;
    }

    /**
     * Get cdObjectType
     *
     * @return string 
     */
    public function getCdObjectType()
    {
        return $this->cdObjectType;
    }

    /**
     * Set lbObjectType
     *
     * @param string $lbObjectType
     * @return ObjectType
     */
    public function setLbObjectType($lbObjectType)
    {
        $this->lbObjectType = $lbObjectType;
    
        return $this;
    }

    /**
     * Get lbObjectType
     *
     * @return string 
     */
    public function getLbObjectType()
    {
        return $this->lbObjectType;
    }

    /**
     * Set lbTableName
     *
     * @param string $lbTableName
     * @return ObjectType
     */
    public function setLbTableName($lbTableName)
    {
        $this->lbTableName = $lbTableName;
    
        return $this;
    }

    /**
     * Get lbTableName
     *
     * @return string 
     */
    public function getLbTableName()
    {
        return $this->lbTableName;
    }

    /**
     * Set lbIdName
     *
     * @param string $lbIdName
     * @return ObjectType
     */
    public function setLbIdName($lbIdName)
    {
        $this->lbIdName = $lbIdName;
    
        return $this;
    }

    /**
     * Get lbIdName
     *
     * @return string 
     */
    public function getLbIdName()
    {
        return $this->lbIdName;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ObjectType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }