<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * PreferenceColonne
 *
 * @ORM\Table()
 * @ORM\Entity(repositoryClass="Etrali\GinangBundle\Entity\PreferenceColonneRepository")
 */
class PreferenceColonne
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="entite", type="string", length=255)
     */
    private $entite;

    /**
     * @var string
     *
     * @ORM\Column(name="colonne", type="string", length=255)
     */
    private $colonne;

    /**
     * @var boolean
     *
     * @ORM\Column(name="visible", type="boolean")
     */
    private $visible;

    /**
     * @var integer
     *
     * @ORM\Column(name="position", type="integer")
     */
    private $position;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set entite
     *
     * @param string $entite
     * @return PreferenceColonne
     */
    public function setEntite($entite)
    {
        $this->entite = $entite;
    
        return $this;
    }

    /**
     * Get entite
     *
     * @return string 
     */
    public function getEntite()
    {
        return $this->entite;
    }

    /**
     * Set colonne
     *
     * @param string $colonne
     * @return PreferenceColonne
     */
    public function setColonne($colonne)
    {
        $this->colonne = $colonne;
    
        return $this;
    }

    /**
     * Get colonne
     *
     * @return string 
     */
    public function getColonne()
    {
        return $this->colonne;
    }

    /**
     * Set visible
     *
     * @param boolean $visible
     * @return PreferenceColonne
     */
    public function setVisible($visible)
    {
        $this->visible = $visible;
    
        return $this;
    }

    /**
     * Get visible
     *
     * @return boolean 
     */
    public function getVisible()
    {
        return $this->visible;
    }

    /**
     * Set position
     *
     * @param integer $position
     * @return PreferenceColonne
     */
    public function setPosition($position)
    {
        $this->position = $position;
    
        return $this;
    }

    /**
     * Get position
     *
     * @return integer 
     */
    public function getPosition()
    {
        return $this->position;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return PreferenceColonne
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }