<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Requirement
 *
 * @ORM\Table(name="requirement")
 * @ORM\Entity
 */
class Requirement
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_requirement", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idRequirement;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_requirement", type="string", length=15, nullable=true)
     */
    private $cdRequirement;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_requirement", type="string", length=250, nullable=true)
     */
    private $lbRequirement;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \RequirementType
     *
     * @ORM\ManyToOne(targetEntity="RequirementType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_requirement_type", referencedColumnName="id_requirement_type")
     * })
     */
    private $idRequirementType;



    /**
     * Get idRequirement
     *
     * @return integer 
     */
    public function getIdRequirement()
    {
        return $this->idRequirement;
    }

    /**
     * Set cdRequirement
     *
     * @param string $cdRequirement
     * @return Requirement
     */
    public function setCdRequirement($cdRequirement)
    {
        $this->cdRequirement = $cdRequirement;
    
        return $this;
    }

    /**
     * Get cdRequirement
     *
     * @return string 
     */
    public function getCdRequirement()
    {
        return $this->cdRequirement;
    }

    /**
     * Set lbRequirement
     *
     * @param string $lbRequirement
     * @return Requirement
     */
    public function setLbRequirement($lbRequirement)
    {
        $this->lbRequirement = $lbRequirement;
    
        return $this;
    }

    /**
     * Get lbRequirement
     *
     * @return string 
     */
    public function getLbRequirement()
    {
        return $this->lbRequirement;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Requirement
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idRequirementType
     *
     * @param \Etrali\GinangBundle\Entity\RequirementType $idRequirementType
     * @return Requirement
     */
    public function setIdRequirementType(\Etrali\GinangBundle\Entity\RequirementType $idRequirementType = null)
    {
        $this->idRequirementType = $idRequirementType;
    
        return $this;
    }

    /**
     * Get idRequirementType
     *
     * @return \Etrali\GinangBundle\Entity\RequirementType 
     */
    public function getIdRequirementType()
    {
        return $this->idRequirementType;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }