<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * RequirementType
 *
 * @ORM\Table(name="requirement_type")
 * @ORM\Entity
 */
class RequirementType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_requirement_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idRequirementType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_requirement_type", type="string", length=15, nullable=false)
     */
    private $cdRequirementType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_requirement_type", type="string", length=250, nullable=true)
     */
    private $lbRequirementType;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_quantity", type="decimal", nullable=true)
     */
    private $nbQuantity;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idRequirementType
     *
     * @return integer 
     */
    public function getIdRequirementType()
    {
        return $this->idRequirementType;
    }

    /**
     * Set cdRequirementType
     *
     * @param string $cdRequirementType
     * @return RequirementType
     */
    public function setCdRequirementType($cdRequirementType)
    {
        $this->cdRequirementType = $cdRequirementType;
    
        return $this;
    }

    /**
     * Get cdRequirementType
     *
     * @return string 
     */
    public function getCdRequirementType()
    {
        return $this->cdRequirementType;
    }

    /**
     * Set lbRequirementType
     *
     * @param string $lbRequirementType
     * @return RequirementType
     */
    public function setLbRequirementType($lbRequirementType)
    {
        $this->lbRequirementType = $lbRequirementType;
    
        return $this;
    }

    /**
     * Get lbRequirementType
     *
     * @return string 
     */
    public function getLbRequirementType()
    {
        return $this->lbRequirementType;
    }

    /**
     * Set nbQuantity
     *
     * @param float $nbQuantity
     * @return RequirementType
     */
    public function setNbQuantity($nbQuantity)
    {
        $this->nbQuantity = $nbQuantity;
    
        return $this;
    }

    /**
     * Get nbQuantity
     *
     * @return float 
     */
    public function getNbQuantity()
    {
        return $this->nbQuantity;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return RequirementType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }