<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceCaracs
 *
 * @ORM\Table(name="service_caracs")
 * @ORM\Entity
 */
class ServiceCaracs
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_caracs", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceCaracs;

    /**
     * @var string
     *
     * @ORM\Column(name="valeur", type="string", length=45, nullable=true)
     */
    private $valeur;

    /**
     * @var \ProductCaracs
     *
     * @ORM\ManyToOne(targetEntity="ProductCaracs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_product_caracs", referencedColumnName="id_product_caracs")
     * })
     */
    private $idProductCaracs;

    /**
     * @var \Service
     *
     * @ORM\ManyToOne(targetEntity="Service", inversedBy="idServiceCaracs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service", referencedColumnName="id_service")
     * })
     */
    private $idService;
    
    /**
     * @var \ServiceExtremity
     *
     * @ORM\ManyToOne(targetEntity="ServiceExtremity", inversedBy="idServiceCaracs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_extremity", referencedColumnName="id_service_extremity")
     * })
     */
    private $idServiceExtremity;   
    
    /**
     * @var \ServiceExtremityTech
     *
     * @ORM\ManyToOne(targetEntity="ServiceExtremityTech", inversedBy="idServiceCaracs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_service_extremity_tech", referencedColumnName="id_service_extremity_tech")
     * })
     */
    private $idServiceExtremityTech;    


    public function __toString()
    {
        return "test";
        //return $this->getIdProductCaracs()->getLbCarac()." : ".$this->getValeur();
    }

  

    /**
     * Get idServiceCaracs
     *
     * @return integer 
     */
    public function getIdServiceCaracs()
    {
        return $this->idServiceCaracs;
    }

    /**
     * Set valeur
     *
     * @param string $valeur
     * @return ServiceCaracs
     */
    public function setValeur($valeur)
    {
        $this->valeur = $valeur;
    
        return $this;
    }

    /**
     * Get valeur
     *
     * @return string 
     */
    public function getValeur()
    {
        return $this->valeur;
    }

    /**
     * Set idProductCaracs
     *
     * @param \Etrali\GinangBundle\Entity\ProductCaracs $idProductCaracs
     * @return ServiceCaracs
     */
    public function setIdProductCaracs(\Etrali\GinangBundle\Entity\ProductCaracs $idProductCaracs = null)
    {
        $this->idProductCaracs = $idProductCaracs;
    
        return $this;
    }

    /**
     * Get idProductCaracs
     *
     * @return \Etrali\GinangBundle\Entity\ProductCaracs 
     */
    public function getIdProductCaracs()
    {
        return $this->idProductCaracs;
    }

    /**
     * Set idService
     *
     * @param \Etrali\GinangBundle\Entity\Service $idService
     * @return ServiceCaracs
     */
    public function setIdService(\Etrali\GinangBundle\Entity\Service $idService = null)
    {
        $this->idService = $idService;
    
        return $this;
    }

    /**
     * Get idService
     *
     * @return \Etrali\GinangBundle\Entity\Service 
     */
    public function getIdService()
    {
        return $this->idService;
    }

    /**
     * Set idServiceExtremity
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity
     * @return ServiceCaracs
     */
    public function setIdServiceExtremity(\Etrali\GinangBundle\Entity\ServiceExtremity $idServiceExtremity = null)
    {
        $this->idServiceExtremity = $idServiceExtremity;
    
        return $this;
    }

    /**
     * Get idServiceExtremity
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremity 
     */
    public function getIdServiceExtremity()
    {
        return $this->idServiceExtremity;
    }

    /**
     * Set idServiceExtremityTech
     *
     * @param \Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech
     * @return ServiceCaracs
     */
    public function setIdServiceExtremityTech(\Etrali\GinangBundle\Entity\ServiceExtremityTech $idServiceExtremityTech = null)
    {
        $this->idServiceExtremityTech = $idServiceExtremityTech;
    
        return $this;
    }

    /**
     * Get idServiceExtremityTech
     *
     * @return \Etrali\GinangBundle\Entity\ServiceExtremityTech 
     */
    public function getIdServiceExtremityTech()
    {
        return $this->idServiceExtremityTech;
    }public function getParentBranch() { return NULL; }  }