<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceHistory
 *
 * @ORM\Table(name="service_history")
 * @ORM\Entity
 */
class ServiceHistory {

    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_history", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceHistory;

    /**
     * @var \History
     *
     * @ORM\ManyToOne(targetEntity="History")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_history", referencedColumnName="id_history")
     * })
     */
    private $idHistory;

    /**
     * Get idServiceHistory
     *
     * @return integer 
     */
    public function getIdServiceHistory() {
        return $this->idServiceHistory;
    }

    /**
     * Set idHistory
     *
     * @param \Etrali\GinangBundle\Entity\History $idHistory
     * @return ServiceHistory
     */
    public function setIdHistory(\Etrali\GinangBundle\Entity\History $idHistory = null) {
        $this->idHistory = $idHistory;

        return $this;
    }

    /**
     * Get idHistory
     *
     * @return \Etrali\GinangBundle\Entity\History 
     */
    public function getIdHistory() {
        return $this->idHistory;
    }

    public function __toString() {
        return '';
    }

    public function getParentBranch() {
        return NULL;
    }

}