<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceNotes
 *
 * @ORM\Table(name="service_notes")
 * @ORM\Entity
 */
class ServiceNotes
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_notes", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceNotes;

    /**
     * @var string
     *
     * @ORM\Column(name="note", type="text", nullable=true)
     */
    private $note;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_note", type="datetime", nullable=true)
     */
    private $dtNote;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;



    /**
     * Get idServiceNotes
     *
     * @return integer 
     */
    public function getIdServiceNotes()
    {
        return $this->idServiceNotes;
    }

    /**
     * Set note
     *
     * @param string $note
     * @return ServiceNotes
     */
    public function setNote($note)
    {
        $this->note = $note;
    
        return $this;
    }

    /**
     * Get note
     *
     * @return string 
     */
    public function getNote()
    {
        return $this->note;
    }

    /**
     * Set dtNote
     *
     * @param \DateTime $dtNote
     * @return ServiceNotes
     */
    public function setDtNote($dtNote)
    {
        $this->dtNote = $dtNote;
    
        return $this;
    }

    /**
     * Get dtNote
     *
     * @return \DateTime 
     */
    public function getDtNote()
    {
        return $this->dtNote;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return ServiceNotes
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }