<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ShelfType
 *
 * @ORM\Table(name="shelf_type")
 * @ORM\Entity
 */
class ShelfType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_shelf_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idShelfType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_shelf_type", type="string", length=45, nullable=true)
     */
    private $cdShelfType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_shelf_type", type="string", length=255, nullable=true)
     */
    private $lbShelfType;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_shelf_type", type="string", length=255, nullable=true)
     */
    private $cmShelfType;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idShelfType
     *
     * @return integer 
     */
    public function getIdShelfType()
    {
        return $this->idShelfType;
    }

    /**
     * Set cdShelfType
     *
     * @param string $cdShelfType
     * @return ShelfType
     */
    public function setCdShelfType($cdShelfType)
    {
        $this->cdShelfType = $cdShelfType;
    
        return $this;
    }

    /**
     * Get cdShelfType
     *
     * @return string 
     */
    public function getCdShelfType()
    {
        return $this->cdShelfType;
    }

    /**
     * Set lbShelfType
     *
     * @param string $lbShelfType
     * @return ShelfType
     */
    public function setLbShelfType($lbShelfType)
    {
        $this->lbShelfType = $lbShelfType;
    
        return $this;
    }

    /**
     * Get lbShelfType
     *
     * @return string 
     */
    public function getLbShelfType()
    {
        return $this->lbShelfType;
    }

    /**
     * Set cmShelfType
     *
     * @param string $cmShelfType
     * @return ShelfType
     */
    public function setCmShelfType($cmShelfType)
    {
        $this->cmShelfType = $cmShelfType;
    
        return $this;
    }

    /**
     * Get cmShelfType
     *
     * @return string 
     */
    public function getCmShelfType()
    {
        return $this->cmShelfType;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return ShelfType
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return ShelfType
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ShelfType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }