<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * TsStatus
 *
 * @ORM\Table(name="ts_status")
 * @ORM\Entity
 */
class TsStatus
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_ts_status", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idTsStatus;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_status", type="string", length=100, nullable=false)
     */
    private $lbStatus;


public function __toString() { return ''.$this->getLbStatus(); } 

public function getParentBranch() { return NULL; }  



    /**
     * Get idTsStatus
     *
     * @return integer 
     */
    public function getIdTsStatus()
    {
        return $this->idTsStatus;
    }

    /**
     * Set lbStatus
     *
     * @param string $lbStatus
     * @return TsStatus
     */
    public function setLbStatus($lbStatus)
    {
        $this->lbStatus = $lbStatus;
    
        return $this;
    }

    /**
     * Get lbStatus
     *
     * @return string 
     */
    public function getLbStatus()
    {
        return $this->lbStatus;
    }
}