<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * UserInBranchProfile
 *
 * @ORM\Table(name="user_in_branch_profile")
 * @ORM\Entity
 */
class UserInBranchProfile
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_in_branch_profile", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idUserInBranchProfile;

    /**
     * @var \UserInBranch
     *
     * @ORM\ManyToOne(targetEntity="UserInBranch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_in_branch", referencedColumnName="id_user_in_branch")
     * })
     */
    private $idUserInBranch;

    /**
     * @var \Profile
     *
     * @ORM\ManyToOne(targetEntity="Profile")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_profile", referencedColumnName="id_profile")
     * })
     */
    private $idProfile;



    /**
     * Get idUserInBranchProfile
     *
     * @return integer 
     */
    public function getIdUserInBranchProfile()
    {
        return $this->idUserInBranchProfile;
    }

    /**
     * Set idUserInBranch
     *
     * @param \Etrali\GinangBundle\Entity\UserInBranch $idUserInBranch
     * @return UserInBranchProfile
     */
    public function setIdUserInBranch(\Etrali\GinangBundle\Entity\UserInBranch $idUserInBranch = null)
    {
        $this->idUserInBranch = $idUserInBranch;
    
        return $this;
    }

    /**
     * Get idUserInBranch
     *
     * @return \Etrali\GinangBundle\Entity\UserInBranch 
     */
    public function getIdUserInBranch()
    {
        return $this->idUserInBranch;
    }

    /**
     * Set idProfile
     *
     * @param \Etrali\GinangBundle\Entity\Profile $idProfile
     * @return UserInBranchProfile
     */
    public function setIdProfile(\Etrali\GinangBundle\Entity\Profile $idProfile = null)
    {
        $this->idProfile = $idProfile;
    
        return $this;
    }

    /**
     * Get idProfile
     *
     * @return \Etrali\GinangBundle\Entity\Profile 
     */
    public function getIdProfile()
    {
        return $this->idProfile;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }