<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Variant
 *
 * @ORM\Table(name="variant")
 * @ORM\Entity
 */
class Variant
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_variant", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idVariant;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_variant", type="string", length=15, nullable=true)
     */
    private $cdVariant;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_variant", type="string", length=250, nullable=true)
     */
    private $lbVariant;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * @var \VariantType
     *
     * @ORM\ManyToOne(targetEntity="VariantType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_variant_type", referencedColumnName="id_variant_type")
     * })
     */
    private $idVariantType;



    /**
     * Get idVariant
     *
     * @return integer 
     */
    public function getIdVariant()
    {
        return $this->idVariant;
    }

    /**
     * Set cdVariant
     *
     * @param string $cdVariant
     * @return Variant
     */
    public function setCdVariant($cdVariant)
    {
        $this->cdVariant = $cdVariant;
    
        return $this;
    }

    /**
     * Get cdVariant
     *
     * @return string 
     */
    public function getCdVariant()
    {
        return $this->cdVariant;
    }

    /**
     * Set lbVariant
     *
     * @param string $lbVariant
     * @return Variant
     */
    public function setLbVariant($lbVariant)
    {
        $this->lbVariant = $lbVariant;
    
        return $this;
    }

    /**
     * Get lbVariant
     *
     * @return string 
     */
    public function getLbVariant()
    {
        return $this->lbVariant;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Variant
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }



    /**
     * Set idVariantType
     *
     * @param \Etrali\GinangBundle\Entity\VariantType $idVariantType
     * @return Variant
     */
    public function setIdVariantType(\Etrali\GinangBundle\Entity\VariantType $idVariantType = null)
    {
        $this->idVariantType = $idVariantType;
    
        return $this;
    }

    /**
     * Get idVariantType
     *
     * @return \Etrali\GinangBundle\Entity\VariantType 
     */
    public function getIdVariantType()
    {
        return $this->idVariantType;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }