<?php

namespace Etrali\GinangBundle\Form\Type\BackboneLink;

use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Form\FormError;
use Symfony\Component\Form\Event\DataEvent;
use Symfony\Component\Form\FormEvents;

class CustomValidator {
    
   private static function validateFactorized($setting,FormBuilderInterface $builder,$entity_name,$entityManager,$id_transaction_type,$id_transaction_status,$is_old,$subform="",$is_transfer,$object=null)
    {
            if ($setting->getBlHide())
             {      
                 if ($builder->has($setting->getLbField()))
                {                    
                    $type = $builder->get($setting->getLbField())->getType()->getName(); 
                        if ($type=="datepicker")
                        {
                            $type="datetime";
                            $options=array("widget"=>"single_text","label"=>"°","required"=>false,'attr'=>array('style'=>'display:none;'));             
                            $builder->add($setting->getLbField(), $type, $options);
                            $builder->get($setting->getLbField())->setRequired(false);                           
                        }
                        else
                        {
                            $type = "hidden";       // get the name of the type
                            $options=$builder->getOptions();
                            $builder->add($setting->getLbField(), $type, $options);
                            $builder->get($setting->getLbField())->setRequired(false);
                        }
                }              
             }

                   if ($builder->has($setting->getLbField()))
                   {      
                       $dohide=true;                       
                       if ($setting->getBlEditable())
                       {     
                           if ($id_transaction_type==2 && ($entity_name=="BackboneLinkExtremity" || $entity_name=="BackboneLinkExtremityTech"))
                           {    
                                if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old && $is_transfer))
                                {
                                    $dohide=false;
                                }                                                   
                          }
                          else
                          {
                                if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old))
                                {
                                    $dohide=false;
                                }                                 
                          }
                       }
                       if ($dohide)
                       {
                           $builder->get($setting->getLbField())->setDisabled(true);      
                            if (substr($setting->getLbField(),0,2)=='dt')
                            {
                                $getter='get'.ucfirst($setting->getLbField());
                                $type = $builder->get($setting->getLbField())->getType()->getName(); 
                                if ($type=="datepicker" && ($object==NULL || $object->$getter()==NULL))
                                {
                                    $type="datetime";
                                    $options=array("widget"=>"single_text","label"=>"°","required"=>false,'attr'=>array('style'=>'display:none;'));             
                                    $builder->add($setting->getLbField(), $type, $options);
                                    $builder->get($setting->getLbField())->setRequired(false);                                        
                                }                                    
                            }                           
                       }
                   }
             if ($setting->getBlMandatory())
             {
                if ($builder->has($setting->getLbField()))
                {   
                     if ($id_transaction_type==2 && ($entity_name=="BackboneLinkExtremity" || $entity_name=="BackboneLinkExtremityTech"))
                     {
                          if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old && $is_transfer))
                                   $builder->get($setting->getLbField())->setRequired(true);
                     }
                     else
                        $builder->get($setting->getLbField())->setRequired(true);
                     
                }
             }
                else
                {
                   if ($builder->has($setting->getLbField()))
                   {                 
                           if ($setting->getBlOldExtremity() && $is_old)
                                   $builder->get($setting->getLbField())->setRequired(false);
                           if (!$setting->getBlOldExtremity() && !$is_old)
                               $builder->get($setting->getLbField())->setRequired(false);                         
                   }
                }                          
    }      
    
    public static function validateFieldFromDb(FormBuilderInterface $builder,$entity_name,$entityManager,$id_transaction_type,$id_transaction_status,$is_old,$subform="",$is_transfer,$object=null)
    {
        $id_status=$id_transaction_status+1;
             
         $treated=array();         
         if (($id_transaction_type==1 && $id_status>5) || ($id_transaction_type==2 && $id_status>11) || ($id_transaction_type==3 && $id_status>17) || ($id_transaction_type==4 && $id_status>20))
             $id_status=$id_transaction_status;
         $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\BackboneLinkInterfaceSettings')
                    ->createQueryBuilder('q')->innerJoin('q.idTransactionType','t')->leftJoin('q.idTransactionStatus','s')
                    ->andWhere("q.lbEntity='".$entity_name."'")
                    ->andWhere("t.idTransactionType=".$id_transaction_type)
                    ->andWhere("s.idTransactionStatus=".$id_status)->getQuery()->getResult();
         foreach($result as $setting)
         {
             $treated[$setting->getLbField()]=true;
             self::validateFactorized($setting,$builder,$entity_name,$entityManager,$id_transaction_type,$id_status,$is_old,$subform,$is_transfer,$object);                          
         } 

         $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\BackboneLinkInterfaceSettings')
                    ->createQueryBuilder('q')->innerJoin('q.idTransactionType','t')
                    ->andWhere("q.lbEntity='".$entity_name."'")
                    ->andWhere("t.idTransactionType=".$id_transaction_type)
                    ->andWhere("q.idTransactionStatus is null")->getQuery()->getResult();
         foreach($result as $setting)
         {
             if (!isset($treated[$setting->getLbField()]))
             {
                self::validateFactorized($setting,$builder,$entity_name,$entityManager,$id_transaction_type,$id_status,$is_old,$subform,$is_transfer,$object);                   
             }
         }          
                     
        
    }
    
    
    public static function isValidForNextStep($entity,$entityManager,$controller)
    {       
         $id_type=$entity->getIdTransactionType()->getIdTransactionType();        
         $id_status=$entity->getIdTransactionStatus()->getIdTransactionStatus()+1;
         if (($id_type==1 && $id_status>5) || ($id_type==2 && $id_status>11) || ($id_type==3 && $id_status>17)  || ($id_type==4 && $id_status>19))
             return "NA";

         $chaineret="";
         $missfields=array();
         
         $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\BackboneLinkInterfaceSettings')
                    ->createQueryBuilder('q')->innerJoin('q.idTransactionType','t')->leftJoin('q.idTransactionStatus','s')
                    ->andWhere("t.idTransactionType=".$entity->getIdTransactionType()->getIdTransactionType())
                    ->andWhere("s.idTransactionStatus=".$id_status)->getQuery()->getResult();

            foreach($result as $setting)
            {
                if ($setting->getBlMandatory())
                {
                   $assocname="get".ucfirst($setting->getLbField());
                   if ($setting->getLbEntity()=="BackboneLinkExtremity")
                   {
                       foreach ($entity->getIdBackboneLinkExtremity() as $extr)
                       {
                           if ($setting->getBlOldExtremity() && $extr->getBlOld() && $extr->$assocname()==NULL)
                           {
                               $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                           }
                           if (!$setting->getBlOldExtremity() && !$extr->getBlOld()   && ($entity->getIdTransferExtremity()==NULL ||  $id_type!=2  || $extr->getIdBackboneLinkExtremity()==$entity->getIdTransferExtremity()->getIdBackboneLinkExtremity())  && $extr->$assocname()==NULL)
                           {
                               $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                           }
                       }
                   }
                   else if ($setting->getLbEntity()=="BackboneLinkExtremityTech")
                   {
                       foreach ($entity->getIdBackboneLinkExtremityTech() as $extr)
                       {
                           if ($setting->getBlOldExtremity() && $extr->getIdBackboneLinkExtremity()->getBlOld() && $extr->$assocname()==NULL)
                                   $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                           if (!$setting->getBlOldExtremity() && !$extr->getIdBackboneLinkExtremity()->getBlOld()  && ($entity->getIdTransferExtremity()==NULL   ||  $id_type!=2 || $extr->getIdBackboneLinkExtremity()->getIdBackboneLinkExtremity()==$entity->getIdTransferExtremity()->getIdBackboneLinkExtremity())  && $extr->$assocname()==NULL)
                               $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                       }
                   }                   
                   else if ($entity->$assocname()==NULL)
                       $missfields[$setting->getLbEntity()][$setting->getLbField()]=$entity;
                }
            }
        
        foreach ($missfields as $key=>$value)
        {
            $chaineret.="In $key : ";
            $labels=array();
            $ymlfile=$controller->get("kernel")->getRootDir().'/../src/Etrali/GinangBundle/Resources/config/'.$key.'-generator.yml';                           
            if (file_exists($ymlfile))
                $infos=$controller->getFromExternYaml($ymlfile,'params.fields');     
            foreach ($value as $fieldname=>$entdesc)
            {
                if (isset($infos[$fieldname]))
                    $chaineret.=$infos[$fieldname]["label"].",";
                else
                    $chaineret.=$fieldname.",";
            }
            $chaineret.="<br>";
        }
            
        return $chaineret;
        
    }
}

?>
