<?php

namespace Etrali\GinangBundle\Form\Type\BackboneLink;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Admingenerated\EtraliGinangBundle\Form\BaseBackboneLinkType\FiltersType as BaseFiltersType;

class FiltersType extends BaseFiltersType
{
     public function buildForm(FormBuilderInterface $builder, array $options)
     {
         parent::buildForm($builder,$options);
         $builder->add('idTransactionStatus', 'entity', array(  'em' => 'default', 'query_builder' => function($er) {
      return $er->createQueryBuilder('ts')
                ->where('ts.idTransactionStatus>=1')->andWhere('ts.idTransactionStatus<=21')
                ->orderBy('ts.idTransactionStatus', 'ASC');
      }, 'class' => 'Etrali\\GinangBundle\\Entity\\TransactionStatus',  'multiple' => false,  'required' => false,  'label' => 'Backbone link status',  'help' => NULL,  'translation_domain' => 'Admin',  'cascade_validation' => true,));

     }
}
