<?php

namespace Etrali\GinangBundle\Form\Type\LocalLoop;

use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use Symfony\Component\Form\FormError;
use Symfony\Component\Form\Event\DataEvent;
use Symfony\Component\Form\FormEvents;

class CustomValidator {
    
    
    private static function validateFactorized($setting,FormBuilderInterface $builder,$entity_name,$entityManager,$id_transaction_type,$id_transaction_status,$is_old,$subform="",$is_transfer,$object=null)
    {
            if ($setting->getBlHide())
             {      
                 if ($builder->has($setting->getLbField()))
                {                    
                    $type = $builder->get($setting->getLbField())->getType()->getName(); 
                        if ($type=="datepicker")
                        {
                            $type="datetime";
                            $options=array("widget"=>"single_text","label"=>"°","required"=>false,'attr'=>array('style'=>'display:none;'));             
                            $builder->add($setting->getLbField(), $type, $options);
                            $builder->get($setting->getLbField())->setRequired(false);                           
                        }
                        else
                        {
                            $type = "hidden";       // get the name of the type
                            $options=$builder->getOptions();
                            $builder->add($setting->getLbField(), $type, $options);
                            $builder->get($setting->getLbField())->setRequired(false);
                        }
                }              
             }
                   if ($builder->has($setting->getLbField()))
                   {                                 
                       $dohide=true;                       
                       if ($setting->getBlEditable())
                       {     
                           if ($id_transaction_type==6 && ($entity_name=="LocalLoopExtremity" || $entity_name=="LocalLoopExtremityTech"))
                           {    
                                if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old && $is_transfer))
                                {
                                    $dohide=false;
                                }                                                   
                          }
                          else
                          {
                                if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old))
                                {
                                    $dohide=false;
                                }                                 
                          }
                       }
                       if ($dohide)
                       {                          
                           $builder->get($setting->getLbField())->setDisabled(true);      
                            if (substr($setting->getLbField(),0,2)=='dt')
                            {
                                $getter='get'.ucfirst($setting->getLbField());
                                $type = $builder->get($setting->getLbField())->getType()->getName(); 
                                if ($type=="datepicker" && ($object==NULL || $object->$getter()==NULL))
                                {
                                    $type="datetime";
                                    $options=array("widget"=>"single_text","label"=>"°","required"=>false,'attr'=>array('style'=>'display:none;'));             
                                    $builder->add($setting->getLbField(), $type, $options);
                                    $builder->get($setting->getLbField())->setRequired(false);                                        
                                }                                    
                            }                           
                       }
                   }
             if ($setting->getBlMandatory())
             {
                if ($builder->has($setting->getLbField()))
                {   
                     if ($id_transaction_type==6 && ($entity_name=="LocalLoopExtremity" || $entity_name=="LocalLoopExtremityTech"))
                     {
                          if (($setting->getBlOldExtremity() && $is_old) || (!$setting->getBlOldExtremity() && !$is_old && $is_transfer))
                                   $builder->get($setting->getLbField())->setRequired(true);
                     }
                     else
                        $builder->get($setting->getLbField())->setRequired(true);
                     
                }
             }
                else
                {
                   if ($builder->has($setting->getLbField()))
                   {                 
                           if ($setting->getBlOldExtremity() && $is_old)
                                   $builder->get($setting->getLbField())->setRequired(false);
                           if (!$setting->getBlOldExtremity() && !$is_old)
                               $builder->get($setting->getLbField())->setRequired(false);                         
                   }
                }          
                 if  ($id_transaction_type==5 && $id_transaction_status==26 &&  $entity_name=="LocalLoopExtremityTech")                     
                 {
                      $fields=array('idTechnicalContact','idTechnicalContactPop','idTechnicalContactProvider');
                      foreach ($fields as $f)
                      {
                          $type = $builder->get($f)->getType()->getName(); 
                          $options=$builder->get($f)->getOptions();      
                          $newop=array('action'=>$options['action'],'label'=>$options["label"],'label'=>$options["label"],'class'=>$options["class"],'motherentity'=>$options["motherentity"],'motherfield'=>$options["motherfield"],"attr"=>array('required'=>'required'));
                          $builder->add($f,$type , $newop);
                      }                                                                        
                 }
                 
                 if  ($id_transaction_type==5 && $id_transaction_status==23 &&  $entity_name=="LocalLoopExtremity")                     
                 {                     
                      $fields=array('idAdminContact','idContactPop','idContactProvider','idDeliveryAddress','idAddressPop','idAddressProvider');
                      foreach ($fields as $f)
                      {
                          $type = $builder->get($f)->getType()->getName(); 
                          $options=$builder->get($f)->getOptions();      
                          $newop=array('action'=>$options['action'],'label'=>$options["label"],'label'=>$options["label"],'class'=>$options["class"],'motherentity'=>$options["motherentity"],'motherfield'=>$options["motherfield"],"attr"=>array('required'=>'required'));
                          $builder->add($f,$type , $newop);
                      }                     
                 }                 
                if ($id_transaction_type==6 && $id_transaction_status==32  &&  $entity_name=="LocalLoopExtremityTech" && $is_transfer)
                {
                      $fields=array('idTechnicalContact','idTechnicalContactPop','idTechnicalContactProvider');
                      foreach ($fields as $f)
                      {
                          $type = $builder->get($f)->getType()->getName(); 
                          $options=$builder->get($f)->getOptions();      
                          $newop=array('action'=>$options['action'],'label'=>$options["label"],'label'=>$options["label"],'class'=>$options["class"],'motherentity'=>$options["motherentity"],'motherfield'=>$options["motherfield"],"attr"=>array('required'=>'required'));
                          $builder->add($f,$type , $newop);
                      }                   
                }                              
    }            
            
    public static function validateFieldFromDb(FormBuilderInterface $builder,$entity_name,$entityManager,$id_transaction_type,$id_transaction_status,$is_old,$subform="",$is_transfer,$object=null)
    {
        $id_status=$id_transaction_status+1;
         if (($id_transaction_type==5 && $id_status>27) || ($id_transaction_type==6 && $id_status>33) || ($id_transaction_type==7 && $id_status>39) || ($id_transaction_type==8 && $id_status>42))
             $id_status=$id_transaction_status;
             
         $treated=array();
         $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\BackboneLinkInterfaceSettings')
                    ->createQueryBuilder('q')->innerJoin('q.idTransactionType','t')->leftJoin('q.idTransactionStatus','s')
                    ->andWhere("q.lbEntity='".$entity_name."'")
                    ->andWhere("t.idTransactionType=".$id_transaction_type)
                    ->andWhere("s.idTransactionStatus=".$id_status)->getQuery()->getResult();
         foreach($result as $setting)
         {
             $treated[$setting->getLbField()]=true;
             self::validateFactorized($setting,$builder,$entity_name,$entityManager,$id_transaction_type,$id_status,$is_old,$subform,$is_transfer,$object);                         
         }         

         $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\BackboneLinkInterfaceSettings')
                    ->createQueryBuilder('q')->innerJoin('q.idTransactionType','t')
                    ->andWhere("q.lbEntity='".$entity_name."'")
                    ->andWhere("t.idTransactionType=".$id_transaction_type)
                    ->andWhere("q.idTransactionStatus is null")->getQuery()->getResult();
         foreach($result as $setting)
         {
             if (!isset($treated[$setting->getLbField()]))
             {
                self::validateFactorized($setting,$builder,$entity_name,$entityManager,$id_transaction_type,$id_status,$is_old,$subform,$is_transfer,$object);                                
             }
         }          
                                                
        
    }
    
    
    public static function isValidForNextStep($entity,$entityManager,$controller)
    {       
         $id_type=$entity->getIdTransactionType()->getIdTransactionType();        
         $id_status=$entity->getIdTransactionStatus()->getIdTransactionStatus()+1;
         if (($id_type==5 && $id_status>27) || ($id_type==6 && $id_status>33) || ($id_type==7 && $id_status>39)  || ($id_type==8 && $id_status>41))
             return "NA";

         $chaineret="";
         $missfields=array();
         
         $result=$entityManager->getRepository('Etrali\GinangBundle\Entity\BackboneLinkInterfaceSettings')
                    ->createQueryBuilder('q')->innerJoin('q.idTransactionType','t')->leftJoin('q.idTransactionStatus','s')
                    ->andWhere("t.idTransactionType=".$entity->getIdTransactionType()->getIdTransactionType())
                    ->andWhere("s.idTransactionStatus=".$id_status)->getQuery()->getResult();

            foreach($result as $setting)
            {
                if ($setting->getBlMandatory())
                {
                   $assocname="get".ucfirst($setting->getLbField());
                   if ($setting->getLbEntity()=="LocalLoopExtremity")
                   {
                       foreach ($entity->getIdLocalLoopExtremity() as $extr)
                       {
                           if ($setting->getBlOldExtremity() && $extr->getBlOld() && $extr->$assocname()==NULL)
                           {
                               $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                           }
                           if (!$setting->getBlOldExtremity() && !$extr->getBlOld()  && ($entity->getIdTransferExtremity()==NULL ||  $id_type!=6  || $extr->getIdLocalLoopExtremity()==$entity->getIdTransferExtremity()->getIdLocalLoopExtremity())  && $extr->$assocname()==NULL)
                           {
                               $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                           }
                       }
                   }
                   else if ($setting->getLbEntity()=="LocalLoopExtremityTech")
                   {
                       foreach ($entity->getIdLocalLoopExtremityTech() as $extr)
                       {
                           if ($setting->getBlOldExtremity() && $extr->getIdLocalLoopExtremity()->getBlOld() && $extr->$assocname()==NULL)
                                   $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                           if (!$setting->getBlOldExtremity() && !$extr->getIdLocalLoopExtremity()->getBlOld()  && ($entity->getIdTransferExtremity()==NULL   ||  $id_type!=6 || $extr->getIdLocalLoopExtremity()->getIdLocalLoopExtremity()==$entity->getIdTransferExtremity()->getIdLocalLoopExtremity())  && $extr->$assocname()==NULL)
                               $missfields[$setting->getLbEntity()][$setting->getLbField()]=$extr;
                       }
                   }                   
                   else if ($entity->$assocname()==NULL)
                       $missfields[$setting->getLbEntity()][$setting->getLbField()]=$entity;
                }
                
                /* hack for customer/pop/provider */
                foreach ($entity->getIdLocalLoopExtremity() as $extr)
                       {
                          if ($extr->getIdLocalLoopExtremityOwner()!=NULL)
                          {
                            switch ($extr->getIdLocalLoopExtremityOwner()->getIdLocalLoopExtremityOwner())
                            {
                                case 1:
                                    if ($extr->getIdCustomer()==NULL)
                                        $missfields["LocalLoopExtremity"]["idCustomer"]=$extr;
                                    if ($extr->getIdAdminContact()==NULL)
                                        $missfields["LocalLoopExtremity"]["idAdminContact"]=$extr;
                                    if ($extr->getIdDeliveryAddress()==NULL)
                                        $missfields["LocalLoopExtremity"]["idDeliveryAddress"]=$extr;
                                    break;                                  
                                case 2:
                                    if ($extr->getIdPop()==NULL)
                                        $missfields["LocalLoopExtremity"]["idPop"]=$extr;                                  
                                    if ($extr->getIdContactPop()==NULL)
                                        $missfields["LocalLoopExtremity"]["idContactPop"]=$extr;
                                    if ($extr->getIdAddressPop()==NULL)
                                        $missfields["LocalLoopExtremity"]["idAddressPop"]=$extr;                                  
                                    break;  
                                case 3:
                                    if ($extr->getIdProvider()==NULL)
                                        $missfields["LocalLoopExtremity"]["idProvider"]=$extr;                                  
                                    if ($extr->getIdContactProvider()==NULL)
                                        $missfields["LocalLoopExtremity"]["idContactPovider"]=$extr;
                                    if ($extr->getIdAddressProvider()==NULL)
                                        $missfields["LocalLoopExtremity"]["idAddressProvider"]=$extr;                                  
                                    break;                                   
                            }                           
                          }
                          else
                          {
                                if ($extr->getIdCustomer()==NULL)
                                        $missfields["LocalLoopExtremity"]["idCustomer"]=$extr;   
                                if ($extr->getIdPop()==NULL)
                                        $missfields["LocalLoopExtremity"]["idPop"]=$extr;                    
                                if ($extr->getIdProvider()==NULL)
                                        $missfields["LocalLoopExtremity"]["idProvider"]=$extr;      
                          }
                       }
                 if  (($id_type==5 && $id_status==26)  || ($id_type==6 && $id_status==32))
                 {
                      foreach ($entity->getIdLocalLoopExtremityTech() as $extr)
                      {
                          if (($id_type==5 && $id_status==26) || $extr->getIdLocalLoopExtremity()->getIdLocalLoopExtremity()==$entity->getIdTransferExtremity()->getIdLocalLoopExtremity())
                          {
                            switch ($extr->getIdLocalLoopExtremity()->getIdLocalLoopExtremityOwner()->getIdLocalLoopExtremityOwner())
                            {
                                case 1:
                                    if ($extr->getIdTechnicalContact()==NULL)
                                        $missfields["LocalLoopExtremityTech"]["idTechnicalContact"]=$extr;
                                    break;
                                case 2:
                                    if ($extr->getIdTechnicalContactPop()==NULL)
                                        $missfields["LocalLoopExtremityTech"]["idTechnicalContactPop"]=$extr;
                                    break;  
                                case 3:
                                    if ($extr->getIdTechnicalContactProvider()==NULL)
                                        $missfields["LocalLoopExtremityTech"]["idTechnicalContactProvider"]=$extr;
                                    break;                                    
                            }
                          }
                      }
                 }               
            }
            
        
        
        foreach ($missfields as $key=>$value)
        {
            $chaineret.="In $key : ";
            $labels=array();
            $ymlfile=$controller->get("kernel")->getRootDir().'/../src/Etrali/GinangBundle/Resources/config/'.$key.'-generator.yml';                           
            if (file_exists($ymlfile))
                $infos=$controller->getFromExternYaml($ymlfile,'params.fields');     
            foreach ($value as $fieldname=>$entdesc)
            {
                if (isset($infos[$fieldname]))
                    $chaineret.=$infos[$fieldname]["label"].",";
                else
                    $chaineret.=$fieldname.",";
            }
            $chaineret.="<br>";
        }
            
        return $chaineret;
        
    }
}

?>
