<?php

namespace Etrali\GinangBundle\Form\Type\Reporting;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;


class ReportingLocalLoopToCustomerBillingBranchType extends AbstractType 
{
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $annee = array();
    $mois = array('01'=>'01','02'=>'02','03'=>'03','04'=>'04','05'=>'05','06'=>'06','07'=>'07','08'=>'08','09'=>'09','10'=>'10','11'=>'11','12'=>'12');
    for($i=1995; $i<2031; $i++)
        $annee[$i]=$i;
    
    $builder->add('customerBillingBranch', 'entity',
            array(  
                'em' => 'default', 
                'required' => false, 
                'multiple' => true,
                'class' => 'EtraliGinangBundle:Branch',  
                'label' => 'Customer billing branch',  
                'help' => NULL,
                'translation_domain' => 'Admin',
                ));
    
    $builder->add('billingPeriodMois', 'choice', 
            array(                
                'required' => false,    
                'label' => '',
                'choices'   => $mois,
                'help' => NULL));  
    $builder->add('billingPeriodAnnee', 'choice', 
            array(   
                'required' => false,    
                'label' => '',
                'choices'   => $annee,
                'help' => NULL));  
  }
  
  public function getName()
  {
    return 'etrali_ginangBundle_reporting_local_loop_to_customer_billing_branch';
  }   

}

