<?php

namespace Etrali\GinangBundle\Form\Type\Reporting;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;


class ReportingServicesStatusPeriodType extends AbstractType 
{
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
  
    $builder->add('idBranch', 'entity',
            array(  
                'em' => 'default', 
                'required' => false, 
                'multiple' => true,
                'class' => 'EtraliGinangBundle:Branch',  
                'label' => 'Branch',  
                'help' => NULL,
                'translation_domain' => 'Admin',));
    
    $builder->add('idProduct', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Product',  
                'multiple' => true,  
                'label' => 'Product',                  
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('periodStartDate', 'datepicker', 
            array(  
                'required' => false,  
                'read_only' => false,  
                'label' => 'Period start date',  
                'help' => NULL,  
                'translation_domain' => 'Admin',  
                'cascade_validation' => true,));
    
    $builder->add('periodEndDate', 'datepicker', 
        array(  
            'required' => false,  
            'read_only' => false,  
            'label' => 'Period end date',  
            'help' => NULL,  
            'translation_domain' => 'Admin',  
            'cascade_validation' => true,));
  }
  
  public function getName()
  {
    return 'etrali_ginangBundle_reporting_services_status_period';
  }   

}

