<?php

namespace Etrali\GinangBundle\Form\Type;

use Symfony\Component\Form\Extension\Core\Type\TextType;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class TextFilterType extends AbstractType
{

    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {

         $options['val']['required'] = $options['required'];
         $options['valop']['required'] = $options['required'];       

         $builder
               ->add('val', new TextType(), $options['val'])
               ->add('valop', 'choice', array('choices'   => array('0' => 'contient', '1' => 'égale à', '2' => 'commence par', '3' => 'finit par','4' => 'ne contient pas', '5' => "n'est pas égale à", '6' => 'ne commence pas par', '7' => 'ne finit pas par'),'required'  => true,));
    }

    /**
     * {@inheritdoc}
     */
    public function getParent()
    {
        return 'form';
    }

    /**
     * {@inheritdoc}
     */
    public function getDefaultOptions(array $options)
    {
        return array(
        );
    }

    /**
     * {@inheritdoc}
     */
    public function getName()
    {
        return 'text_filter';
    }
}
