<?php

namespace Etrali\GinangBundle\Controller\BackboneLinkExtremity;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Admingenerated\EtraliGinangBundle\BaseBackboneLinkExtremityController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    public function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    } 
    
    public function transferAction($pk)
    {
        $oldExtremity = $this->getObject($pk);
         
        $extr=  new \Etrali\GinangBundle\Entity\BackboneLinkExtremity();
        $extr->setIdBackboneLink($oldExtremity->getIdBackboneLink());
        $extr->setIdOldExtremity($oldExtremity);
        $extr->setCdBackboneLinkExtremityRef($oldExtremity->getCdBackboneLinkExtremityRef()."New");
        
       
        $tech=  new \Etrali\GinangBundle\Entity\BackboneLinkExtremityTech();
        $tech->setIdBackboneLink($oldExtremity->getIdBackboneLink());
        $tech->setIdBackboneLinkExtremity($extr); 
        
        $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(6);        
        $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(2); 
        
        $oldExtremity->setBlOld(true);
        $oldExtremity->getIdBackboneLinkExtremityTech()->setBlOld(true);
        
        $bblink=$oldExtremity->getIdBackboneLink();
        $bblink->setIdTransferExtremity($extr);
        $bblink->setIdTransactionType($TransType);
        $bblink->setIdTransactionStatus($TransStatus);
        $bblink->setNbOperation($bblink->getNbOperation()+1);        
        
        $em = $this->getDoctrine()->getManager();
        $em->persist($oldExtremity->getIdBackboneLinkExtremityTech());
        $em->persist($oldExtremity);
        $em->persist($bblink);
        $em->persist($extr);
        $em->persist($tech);
        $em->flush();
        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_BackboneLink_edit", array('pk' => $oldExtremity->getIdBackboneLink()->getIdBackboneLink()) ));

    }
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\BackboneLinkExtremity $BackboneLinkExtremity your \Etrali\GinangBundle\Entity\BackboneLinkExtremity object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\BackboneLinkExtremity $BackboneLinkExtremity)
    {     
        $em = $this->getDoctrine()->getManager();
        $BackboneLinkExtremity->postSave($form, $em);
    }      
    
}
