<?php

namespace Etrali\GinangBundle\Controller\Branch;

use Admingenerated\EtraliGinangBundle\BaseBranchController\NewController as BaseNewController;
use DateInterval;
use DateTime;
use Etrali\GinangBundle\Entity\BillingPeriodRef;
use Etrali\GinangBundle\Entity\BillingPeriod;
use Etrali\GinangBundle\Entity\Branch;
use Symfony\Component\Form\Form;

class NewController extends BaseNewController
{
       /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param Form $form the valid form
     * @param Branch $Branch your \Etrali\GinangBundle\Entity\Branch object
     */
    public function postSave(Form $form, Branch $Branch)
    {                
        $frequencie=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:BillingFrequency')->find(1);
        
        $em = $this->getDoctrine()->getManager();        

        $dtStart=new DateTime();
        $dtStart->setDate(date("Y"), 1, 1);
        for ($i=0;$i<10;$i++)
        {
                    $cdperiod=$dtStart->format("Y-m");
                    $billperiod=new BillingPeriodRef();
                    $billperiod->setCdBillingPeriod($cdperiod);
                    $billperiod->setLbBillingPeriod("Billing ".$cdperiod);
                    $billperiod->setDtBillingStart(clone $dtStart);
                    $billperiod->setIdBranch($Branch);
                    $billperiod->addIdBillingFrequency($frequencie);
                    $em->persist($billperiod);
                    
                    $dtPeriodStart=clone $dtStart;
                    for ($j=0;$j<12;$j++)
                    {
                        $dtRefstart=clone $dtPeriodStart;
                        $dtRefstart->sub(new DateInterval('P1M'));
                        $dtRefend=clone $dtPeriodStart;
                        $dtRefend->sub(new DateInterval('P1D'));

                        $billing=new BillingPeriod();
                        $billing->setIdBillingPeriodRef($billperiod);
                        $billing->setIdBillingFrequency($frequencie);
                        $billing->setIdBranch($Branch);
                        $billing->setDtRefStart($dtRefstart);
                        $billing->setDtRefEnd($dtRefend);
                        $billing->setDtBillingStart(clone $dtPeriodStart);
                        $billing->setLbBillingPeriod($billing->getDtBillingStart()->format("Y-m"));

                        $dtPeriodStart->add(new DateInterval('P1M'));

                        $dtBillingEnd=clone $dtPeriodStart;
                        $dtBillingEnd->sub(new DateInterval('P1D'));                    
                        $billing->setDtBillingEnd($dtBillingEnd);

                        $em->persist($billing);                                               
                    }
                    $dtStart->add(new DateInterval('P1Y'));                    
        }               
        $em->flush();        
    }
    
}
