<?php

namespace Etrali\GinangBundle\Controller\Cabinet;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Admingenerated\EtraliGinangBundle\BaseCabinetController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    public function getReturnFunction($pk)
    {
        $Cabinet=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($pk);
        return $this->render('EtraliGinangBundle:CabinetModal:index.html.twig', array(
                    "Cabinet" => $Cabinet
                ));
    }
 

    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Cabinet $Cabinet your \Etrali\GinangBundle\Entity\Cabinet object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Cabinet $Cabinet)
    {
    
        if ($Cabinet->getIdCostingCabinetLine())
        {
            foreach ($Cabinet->getIdCostingCabinetLine() as $line)
            {
                $line->setIdCabinet($Cabinet);
            }
        }

    }    
    
    
    public function linkAction(Request $request)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $Cabinet=$em->getRepository('EtraliGinangBundle:Cabinet')->find($request->get("id"));
        $type_pere=$request->get("typepere");
        switch ($type_pere)
        {
            case "ui-gina-comp":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($request->get("idpere"));
                   $Cabinet->setIdComplexModel($Pere);
                break;
            case "ui-gina-cab":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($request->get("idpere"));               
                break;
            case "ui-gina-equi":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($request->get("idpere"));                
                break;
            case "ui-gina-patch":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:PatchPanel')->find($request->get("idpere"));
                break;
            case "ui-gina-slots":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Slot')->find($request->get("idpere"));
                break;                
            case "ui-gina-fille":
            case "ui-gina-mere":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($request->get("idpere"));
                break;              
        }
        $em->persist($Cabinet);
        $em->flush();        
        return new Response();
    }


}
