<?php

namespace Etrali\GinangBundle\Controller\Cabinet;

use Admingenerated\EtraliGinangBundle\BaseCabinetController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    
    public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));         
        return parent::indexAction();
    }
    
    public function getReturnFunction($Cabinet)
    {
        return $this->render('EtraliGinangBundle:CabinetModal:index.html.twig', array(
                    "Cabinet" => $Cabinet
                ));
    }

    
    /**
     * Called just before saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Cabinet $Cabinet your \Etrali\GinangBundle\Entity\Cabinet object
     */
    public function preSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Cabinet $Cabinet)
    {
        if ($Cabinet->getIdCostingCabinetLine())
        {        
            foreach ($Cabinet->getIdCostingCabinetLine() as $line)
            {
                $line->setIdCabinet($Cabinet);
            }
        }

        $session = $this->getRequest()->getSession();         
        if ($session->has('typepere') && $session->has('idpere'))
        {
            $type_pere=$session->get('typepere');
            $idpere=$session->get('idpere');
            switch ($type_pere)
            {
                case "ui-gina-pop":
                       $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Pop')->find($idpere);
                       $Cabinet->setIdPop($Pere);
                    break;                                  
                case "ui-gina-comp":
                       $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($idpere);
                       $Cabinet->setIdComplexModel($Pere);
                    break;           
            }
        }
    }    
}
