<?php

namespace Etrali\GinangBundle\Controller\Customer;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Admingenerated\EtraliGinangBundle\BaseCustomerController\EditController as BaseEditController;

class EditController extends BaseEditController
{
 
    
    /**
     * Called just after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Customer $Customer your \Etrali\GinangBundle\Entity\Customer object
     */    
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Customer $Customer)
    {
        foreach($Customer->getIdAddress() as $adr)
        {
            if ($adr->getBlStatus() && $adr->getIdAddressType()->getIdAddressType()==1)
                     $Customer->setLbAddress($adr);   
        }


    }
    
    public function contactAction($pk,$ctype,$atype)
    {
        $Customer = $this->getObject($pk);

        if ($Customer) {
            $id_contact="";
            $lb_contact="";
            $nb=0;
            foreach ($Customer->getIdContact() as $c)
            {
                if ($c->getBlDeactivated() && $c->getIdContactType()->getIdContactType()==$ctype)
                {                
                    $id_contact=$c->getIdContact();
                    $lb_contact=$c;                
                    if ($c->getBlDefault())
                    {
                        $nb=1;
                        break;
                    }
                    else
                        $nb++;
                }
            }
            if ($nb>1)
            {
                $id_contact="";
                $lb_contact="";                
            }
            $id_address="";
            $lb_address="";
            $nb=0;
            foreach ($Customer->getIdAddress() as $c)
            {
                if ($c->getBlStatus())                
                {
                    $id_address=$c->getIdAddress();
                    $lb_address=$c;                
                    if ($c->getIdAddressType()!=NULL && $c->getIdAddressType()->getIdAddressType()==$atype)
                    {
                        $nb=1;
                        break;
                    }
                    else
                        $nb++;
                }
            }
            if ($nb>1)
            {
                $id_address="";
                $lb_address="";                
            }
            
            return new Response($id_contact."\n".$lb_contact."\n".$id_address."\n".$lb_address);
        }        
        else
            return new Response("");
            
    }
    
    public function admincontactAction($pk)
    {
        return $this->contactAction($pk, 2,2);
    }
    
    public function billingcontactAction($pk)
    {
        return $this->contactAction($pk, 4,3);
    }    
 
}
