<?php

namespace Etrali\GinangBundle\Controller\Customer;

use Admingenerated\EtraliGinangBundle\BaseCustomerController\NewController as BaseNewController;

class NewController extends BaseNewController
{
    /**
     * Called just after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Customer $Customer your \Etrali\GinangBundle\Entity\Customer object
     */     
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Customer $Customer)
    {
        $Customer->setCdCustomer($Customer->getIdCustomer());
        $addr=new \Etrali\GinangBundle\Entity\Address();
        $addr->setIdCustomer($Customer);

        $type=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:AddressType')->find(1);
        $addr->setIdAddressType($type);  
        $addr->setLbAddress("");
        $addr->setCdZipCode("");
        
         $em=$this->getDoctrine()->getEntityManager();
         $em->persist($Customer);
         $em->persist($addr);
         $em->flush();
    }
    
}
