<?php

namespace Etrali\GinangBundle\Controller\HistoryModification;

use Admingenerated\EtraliGinangBundle\BaseHistoryModificationController\ListController as BaseListController;

class ListController extends BaseListController
{
    public function buildQuery()
    {
        $em=$this->getDoctrine()->getManager();
        $q=parent::buildQuery();
        $pk=$this->get("request")->get("pk");
        $ent=$this->get("request")->get("entity"); 
        $entarr=array();
        if ($ent=="Service")
        {
            $Service=$em->getRepository('EtraliGinangBundle:'.$ent)->find($pk);
            $entarr=array($ent=>array($pk));          
            $ids=array();
            foreach ($Service->getIdServiceExtremity() as $extr)
                $ids[]=$extr->getIdServiceExtremity();            
            $entarr["ServiceExtremity"]=$ids;

            $ids=array();
            foreach ($Service->getIdServiceExtremityTech() as $extr)
                $ids[]=$extr->getIdServiceExtremityTech();                        
            $entarr["ServiceExtremityTech"]=$ids;

            $ids=array();
            $ids2=array();
            $ids3=array();
            foreach ($Service->getIdBillingService() as $extr)
            {
                $ids[]=$extr->getIdBillingService();                        
                foreach ($extr->getIdBillingServiceLine() as $line)
                    $ids2[]=$line->getIdBillingServiceLine();
                foreach ($extr->getIdBillingOneShot() as $line)
                    $ids3[]=$line->getIdBillingOneShot();                
            }
            $entarr["BillingService"]=$ids;
            $entarr["BillingServiceLine"]=$ids2;
            $entarr["BillingOneShot"]=$ids3;
            
            $ids=array();
            foreach ($Service->getIdServiceOption() as $extr)
                $ids[]=$extr->getIdServiceOption();                        
            
            $entarr["ServiceOption"]=$ids;

            $ids=array();
            foreach ($Service->getIdNote() as $extr)
                $ids[]=$extr->getIdNote();                        
            
            $entarr["Note"]=$ids;
                       
        } else  if ($ent=="BackboneLink")
        {
            $Service=$em->getRepository('EtraliGinangBundle:'.$ent)->find($pk);
            $entarr=array($ent=>array($pk));          
            $ids=array();
            foreach ($Service->getIdBackboneLinkExtremity() as $extr)
                $ids[]=$extr->getIdBackboneLinkExtremity();            
            $entarr["BackboneLinkExtremity"]=$ids;

            $ids=array();
            foreach ($Service->getIdBackboneLinkExtremityTech() as $extr)
                $ids[]=$extr->getIdBackboneLinkExtremityTech();                        
            $entarr["BackboneLinkExtremityTech"]=$ids;

            $ids=array();
            foreach ($Service->getIdCostingBackboneLinkLine() as $extr)
                $ids[]=$extr->getIdCostingBackboneLinkLine();                        
            $entarr["CostingBackboneLinkLine"]=$ids;

            
            $ids=array();
            foreach ($Service->getIdBackboneLinkOption() as $extr)
                $ids[]=$extr->getIdBackboneLinkOption();                        
            
            $entarr["BackboneLinkOption"]=$ids;
            
        } else  if ($ent=="LocalLoop")
        {
            $Service=$em->getRepository('EtraliGinangBundle:'.$ent)->find($pk);
            $entarr=array($ent=>array($pk));          
            $ids=array();
            foreach ($Service->getIdLocalLoopExtremity() as $extr)
                $ids[]=$extr->getIdLocalLoopExtremity();            
            $entarr["LocalLoopExtremity"]=$ids;

            $ids=array();
            foreach ($Service->getIdLocalLoopExtremityTech() as $extr)
                $ids[]=$extr->getIdLocalLoopExtremityTech();                        
            $entarr["LocalLoopExtremityTech"]=$ids;

            $ids=array();
            foreach ($Service->getIdCostingLocalLoopLine() as $extr)
                $ids[]=$extr->getIdCostingLocalLoopLine();                        
            $entarr["CostingLocalLoopLine"]=$ids;

            
            $ids=array();
            foreach ($Service->getIdLocalLoopOption() as $extr)
                $ids[]=$extr->getIdLocalLoopOption();                        
            
            $entarr["LocalLoopOption"]=$ids;
        
            $ids=array();
            foreach ($Service->getIdNote() as $extr)
                $ids[]=$extr->getIdNote();                        
            
            $entarr["Note"]=$ids;            
           
        }          
        else   if ($ent=="Customer")
        {
            $Service=$em->getRepository('EtraliGinangBundle:'.$ent)->find($pk);
            $entarr=array($ent=>array($pk));          
            $ids=array();
            foreach ($Service->getIdAddress() as $extr)
                $ids[]=$extr->getIdAddress();            
            $entarr["Address"]=$ids;

            $ids=array();
            foreach ($Service->getIdContact() as $extr)
                $ids[]=$extr->getIdContact();                        
            $entarr["Contact"]=$ids;

            $ids=array();
            foreach ($Service->getIdProject() as $extr)
                $ids[]=$extr->getIdProject();                        
            $entarr["Project"]=$ids;
           
        }else   if ($ent=="Provider")
        {
            $Service=$em->getRepository('EtraliGinangBundle:'.$ent)->find($pk);
            $entarr=array($ent=>array($pk));          
            $ids=array();
            foreach ($Service->getIdAddressProvider() as $extr)
                $ids[]=$extr->getIdAddressProvider();            
            $entarr["AddressProvider"]=$ids;

            $ids=array();
            foreach ($Service->getIdContactProvider() as $extr)
                $ids[]=$extr->getIdContactProvider();                        
            $entarr["ContactProvider"]=$ids;

        }else   if ($ent=="Pop")
        {
            $Service=$em->getRepository('EtraliGinangBundle:'.$ent)->find($pk);
            $entarr=array($ent=>array($pk));          
            $ids=array();
            foreach ($Service->getIdAddressPop() as $extr)
                $ids[]=$extr->getIdAddressPop();            
            $entarr["AddressPop"]=$ids;

            $ids=array();
            foreach ($Service->getIdContactPop() as $extr)
                $ids[]=$extr->getIdContactPop();                        
            $entarr["ContactPop"]=$ids;          
            
            $ids=array();
            foreach ($Service->getIdCostingPop() as $extr)
                $ids[]=$extr->getIdCostingPop();                        
            $entarr["CostingPop"]=$ids;     
            
            $ids=array();
            $idsEquip=array();
            foreach ($Service->getIdCabinetInstance() as $extr)
            {
                $ids[]=$extr->getIdCabinetInstance();                        
                $ids2=array();
                foreach ($extr->getIdCostingCabinetLine() as $cost)
                    $ids2[]=$cost->getIdCostingCabinetLine();
                $entarr["CostingCabinetLine"]=$ids2;
                
                $ids2=array();
                foreach ($extr->getIdEquipmentInstance() as $equip)
                {
                    $ids2[]=$equip->getIdEquipmentInstance();
                    $ids3=array();
                    foreach ($equip->getIdCostingEquipmentLine() as $cost)
                        $ids3[]=$cost->getIdCostingEquipmentLine();
                    $entarr["CostingEquipmentLine"]=$ids3;

                    $ids3=array();
                    foreach ($equip->getIdSlotInstance() as $slot)
                    {
                        $ids3[]=$slot->getIdSlotInstance();
                        $ids4=array();
                        foreach ($slot->getIdCardInstance() as $card)
                        {
                            $ids4[]=$card->getIdCardInstance();
                            $ids5=array();
                            foreach ($card->getIdCostingCardLine() as $cost)
                                $ids5[]=$cost->getIdCostingCardLine();
                            $entarr["CostingCardLine"]=$ids5;                            
                            
                            $ids5=array();
                            foreach ($card->getIdDaughterCard() as $dcard)
                            {
                                $ids5[]=$dcard->getIdCardInstance();

                                $ids6=array();
                                foreach ($dcard->getIdPortInstance() as $port)
                                {
                                    $ids6[]=$port->getIdPortInstance();
                                    $ids7=array();
                                    foreach ($port->getIdCostingPortLine() as $cost)
                                        $ids7[]=$cost->getIdCostingPortLine();
                                    $entarr["CostingPortLine"]=$ids7;

                                }
                                $entarr["PortInstance"]=$ids6;

                            }
                            $entarr["CardInstance"]=$ids5;                                 
                            
                        }
                        $entarr["CardInstance"]=$ids4;                        
                    }
                    $entarr["SlotInstance"]=$ids3;
                    
                    $ids3=array();
                    foreach ($equip->getIdCardInstance() as $card)
                    {
                        $ids3[]=$card->getIdCardInstance();
                        
                        $ids4=array();
                        foreach ($card->getIdPortInstance() as $port)
                        {
                            $ids4[]=$port->getIdPortInstance();
                            $ids5=array();
                            foreach ($port->getIdCostingPortLine() as $cost)
                                $ids5[]=$cost->getIdCostingPortLine();
                            $entarr["CostingPortLine"]=$ids5;

                        }
                        $entarr["PortInstance"]=$ids4;
                       
                    }
                    $entarr["CardInstance"]=$ids3;                    
                    
                }
                $entarr["EquipmentInstance"]=$ids2;   
                
                $ids2=array();
                foreach ($extr->getIdPatchPanelInstance() as $equip)
                {
                    $ids2[]=$equip->getIdPatchPanelInstance();
                    $ids3=array();
                    foreach ($equip->getIdCostingPatchPanelLine() as $cost)
                        $ids3[]=$cost->getIdCostingPatchPanelLine();
                    $entarr["CostingPatchPanelLine"]=$ids3;

                    $ids3=array();
                    foreach ($equip->getIdPortInstance() as $port)
                    {
                        $ids3[]=$port->getIdPortInstance();
                        $ids4=array();
                        foreach ($port->getIdCostingPortLine() as $cost)
                            $ids4[]=$cost->getIdCostingPortLine();
                        $entarr["CostingPortLine"]=$ids4;
                        
                    }
                    $entarr["PortInstance"]=$ids3;
                    
                }
                $entarr["PatchPanelInstance"]=$ids2;                   
                
            }
            $entarr["CabinetInstance"]=$ids;                
        }
        

        if (count($entarr)>0)
        {
            $chaine="1=2 ";

            foreach ($entarr as $k=>$v)
            {
                if (count($v)>0)
                    $chaine.="or (h.idObject in (".implode(",",$v).") and h.lbEntity='".$k."') ";
            }

            $q=$q->innerJoin("q.idHistory","h")->andWhere($chaine);            
        }
        else
            $q=$q->innerJoin("q.idHistory","h")->andWhere("h.idObject = ".$pk." and h.lbEntity='".$ent."'");     
        return $q;
    }
}
