<?php

namespace Etrali\GinangBundle\Controller\LocalLoopExtremity;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Admingenerated\EtraliGinangBundle\BaseLocalLoopExtremityController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    public function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    } 
    
   
    
    public function transferAction($pk)
    {
        $oldExtremity = $this->getObject($pk);
         
        $extr=  new \Etrali\GinangBundle\Entity\LocalLoopExtremity();
        $extr->setIdLocalLoop($oldExtremity->getIdLocalLoop());
        $extr->setIdOldExtremity($oldExtremity);
        $extr->setCdLocalLoopExtremityRef($oldExtremity->getCdLocalLoopExtremityRef()."New");
       
        $tech=  new \Etrali\GinangBundle\Entity\LocalLoopExtremityTech();
        $tech->setIdLocalLoop($oldExtremity->getIdLocalLoop());
        $tech->setIdLocalLoopExtremity($extr); 
        
        $TransStatus=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionStatus')->find(28);        
        $TransType=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:TransactionType')->find(6); 
        
        $oldExtremity->setBlOld(true);
        $oldExtremity->getIdLocalLoopExtremityTech()->setBlOld(true);        
        $bblink=$oldExtremity->getIdLocalLoop();
        $bblink->setIdTransferExtremity($extr);        
        $bblink->setIdTransactionType($TransType);
        $bblink->setIdTransactionStatus($TransStatus);
        
        $bblink->setNbOperation($bblink->getNbOperation()+1); 
        
        $em = $this->getDoctrine()->getManager();
        $em->persist($oldExtremity);
        $em->persist($oldExtremity->getIdLocalLoopExtremityTech());        
        $em->persist($bblink);
        $em->persist($extr);
        $em->persist($tech);
        $em->flush();
        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_LocalLoop_edit", array('pk' => $oldExtremity->getIdLocalLoop()->getIdLocalLoop()) ));

    }  
    
    /**
     * This method is here to make your life better, so overwrite  it
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\LocalLoopExtremity $LocalLoopExtremity your \Etrali\GinangBundle\Entity\LocalLoopExtremity object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\LocalLoopExtremity $LocalLoopExtremity)
    {
        $em = $this->getDoctrine()->getManager();
        $LocalLoopExtremity->postSave($form, $em);
    }       
}
