<?php

namespace Etrali\GinangBundle\Controller\PortInstance;

use Admingenerated\EtraliGinangBundle\BasePortInstanceController\NewController as BaseNewController;
use Etrali\GinangBundle\Entity\PortInstance;
use Etrali\GinangBundle\Entity\Ts;
use Symfony\Component\Form\Form;

class NewController extends BaseNewController
{
    
    private function handleTimeslots($em,$s,$nb)
    {
                $s->setNbNumber($nb);
                
                if ($s->getIdPort()->getNbTimeslots()>0 && $s->getIdPort()->getNbTimeslots()<$s->getIdTs()->count())
                {
                    foreach($s->getIdTs() as $ts)
                    {
                        if ($ts->getNbTs()> ($s->getIdPort()->getNbTimeslots()+$s->getIdPortType()->getNbTsStart()))
                            $em->remove($ts);
                    }
                }   
                
                if ($s->getIdPort()->getNbTimeslots()>0 && $s->getIdPort()->getNbTimeslots()>$s->getIdTs()->count())
                {
                    $TsStatus=$em->getRepository('EtraliGinangBundle:TsStatus')->find(1);                    
                    $tscount=$s->getIdTs()->count();
                    for ($i=$tscount;$i<$s->getIdPort()->getNbTimeslots();$i++)
                    {
                        $ts=new Ts();
                        $ts->setIdPortInstance($s);
                        $ts->setNbTs($i+$s->getIdPortType()->getNbTsStart());
                        $ts->setNbChannel($i+$s->getIdPortType()->getNbChannelStart());
                        $ts->setLbTs($ts->getNbTs());
                        $ts->setIdTsStatus($TsStatus);                        
                        
                        $em->persist($ts);
                    }
                }
                
                $em->persist($s);   
                return $nb+1;
    }
    /**
     * Called jus after saveObject that persists the object
     *
     * @param Form $form the valid form
     * @param PortInstance $PortInstance your \Etrali\GinangBundle\Entity\PortInstance object
     */
    public function postSave(Form $form, PortInstance $PortInstance)
    {
        $this->ports=array($PortInstance);
        $em=$this->getDoctrine()->getEntityManager();        
        $CardInstance=$PortInstance->getIdCardInstance();        
        $nb=1;
        if ($CardInstance!=NULL)
        {
            foreach ($CardInstance->getIdPortInstance() as $s)
            {
                $nb=$this->handleTimeslots($em,$s,$nb);
            }          

        }
        $PatchPanelInstance=$PortInstance->getIdPatchPanelInstance();        
        $nb=1;
        if ($PatchPanelInstance!=NULL)
        {
            foreach ($PatchPanelInstance->getIdPortInstance() as $s)
            {
                $nb=$this->handleTimeslots($em,$s,$nb);
            }          
        }   
        $em->flush();        
    }     
}
