<?php

namespace Etrali\GinangBundle\Controller\ServiceDevice;

use Admingenerated\EtraliGinangBundle\BaseServiceDeviceController\EditController as BaseEditController;
use Etrali\GinangBundle\Entity\ServiceDevice;
use Symfony\Component\Form\Form;
use Symfony\Component\HttpFoundation\RedirectResponse;

class EditController extends BaseEditController
{
    public function getEditType($object)
    {
        $type=parent::getEditType($object);
        $type=$object->getEditType($type);
        return $type;
    }    
    
    public function terminateAction($pk)
    {
        $dev = $this->getObject($pk);
        $em = $this->getDoctrine()->getManager(); 
        $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(103);
        $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(15);   
        $serv=$dev->getIdService();
        $serv->setIdTransactionType($TransType);
        $serv->setIdTransactionStatus($TransStatus); 
        $serv->setNbOperation($serv->getNbOperation()+1); 
        $serv->setIdSelectedDevice($dev);         
        $em->persist($serv);       
        
        $em->flush();        
        return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_Service_edit", array('pk' => $serv->getIdService()) ));
    }   
    
       
}
