<?php

namespace Etrali\GinangBundle\Controller\ServiceDevice;

use Admingenerated\EtraliGinangBundle\BaseServiceDeviceController\NewController as BaseNewController;
use Etrali\GinangBundle\Entity\ServiceDevice;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Etrali\GinangBundle\Entity\TransferPrice;

class NewController extends BaseNewController
{
    var $parentObj=null;
    
    public function indexAction()
    {
            $em=$this->getDoctrine()->getManager();
            $object=$em->getRepository('EtraliGinangBundle:Service')->find($this->get('request')->query->get('motherid'));
            
            $ServiceDevice=new ServiceDevice();
            $ServiceDevice->setIdService($object);
            $cpt=$object->getIdServiceDevice()->count();
            $ServiceDevice->setCdServiceDevice(chr(65+$cpt).$cpt);               
            $em->persist($ServiceDevice);
            
            $Currency=$em->getRepository('EtraliGinangBundle:Currency')->findOneByCdCurrency("EUR");  
            
            $tp=new TransferPrice();
            $tp->setIdServiceDevice($ServiceDevice);
            $tp->setIdCurrency($Currency);
            $em->persist($tp);                    
            $em->flush();        
            

            if ($object->getIdTransactionStatus()->getIdTransactionStatus()!=44)
            {
                $TransStatus=$em->getRepository('EtraliGinangBundle:TransactionStatus')->find(100);        
                $TransType=$em->getRepository('EtraliGinangBundle:TransactionType')->find(14); 
                
                $object->setIdTransactionType($TransType);
                $object->setIdTransactionStatus($TransStatus);
                $object->setIdTransferExtremity(NULL);
                $object->setBlValidated(false);                
                $object->setIdSelectedExtremity(NULL);    
                $object->setBlLlstatus(false);
                $object->setBlBbstatus(false);                 

                $object->setNbOperation($object->getNbOperation()+1); 

                $em->persist($object);
                $em->flush();
            }
            return new RedirectResponse($this->generateUrl("Etrali_GinangBundle_ServiceDevice_edit" ,array("pk"=>$ServiceDevice->getIdServiceDevice()))."?isSelect=1");
    }
    
    public function getNewType()
    {
        $type=parent::getNewType();
        $type->setTransaction(9,44);  
        $type->setOld(false); 
        $type->setObject($this->parentObj);
        return $type;
    }  
    
    public function preForm($ServiceDevice)
    {
            $this->parentObj=$ServiceDevice;
    }
}
