<?php

namespace Etrali\GinangBundle\Controller\Slot;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Admingenerated\EtraliGinangBundle\BaseSlotController\EditController as BaseEditController;

class EditController extends BaseEditController
{
    public function linkAction(Request $request)
    {
        $em=$this->getDoctrine()->getEntityManager();
        $Slot=$em->getRepository('EtraliGinangBundle:Slot')->find($request->get("id"));
        $type_pere=$request->get("typepere");
        switch ($type_pere)
        {
            case "ui-gina-comp":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:ComplexModel')->find($request->get("idpere"));
                   $Slot->setIdComplexModel($Pere);                                
                break;
            case "ui-gina-cab":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Cabinet')->find($request->get("idpere"));
                break;
            case "ui-gina-equi":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Equipment')->find($request->get("idpere"));
                   $Slot->setIdEquipment($Pere);                                
                break;
            case "ui-gina-patch":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:PatchPanel')->find($request->get("idpere"));
                break;
            case "ui-gina-slots":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Slot')->find($request->get("idpere"));
                break;                
            case "ui-gina-fille":
            case "ui-gina-mere":
                   $Pere=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Card')->find($request->get("idpere"));
                    $Slot->setIdCabinet($Pere);                
                break;              
        }
        $em->persist($Slot);
        $em->flush();
        return new Response();
    }
    
    public function getReturnFunction($pk)
    {
        $Slot=$this->getDoctrine()->getEntityManager()->getRepository('EtraliGinangBundle:Slot')->find($pk);
        return $this->render('EtraliGinangBundle:SlotModal:index.html.twig', array(
                    "Slots" => $this->slots
                ));
    }    

    /**
     * Called jus after saveObject that persists the object
     *
     * @param \Symfony\Component\Form\Form $form the valid form
     * @param \Etrali\GinangBundle\Entity\Slot $Slot your \Etrali\GinangBundle\Entity\Slot object
     */
    public function postSave(\Symfony\Component\Form\Form $form, \Etrali\GinangBundle\Entity\Slot $Slot)
    {
        $this->slots=array($Slot);        
        $Equipment=$Slot->getIdEquipment();
        $em=$this->getDoctrine()->getEntityManager();
        $nb=1;
        if ($Equipment!=NULL)
        {
            foreach ($Equipment->getIdSlot() as $s)
            {
                $s->setNbNumber($nb);
                $nb++;
                $em->persist($s);
            }         
            $em->flush();
        }
    }      
}
