<?php

namespace Etrali\GinangBundle\Controller\SlotInstance;
use Etrali\GinangBundle\Entity\CardInstance;
use Etrali\GinangBundle\Entity\PatchPanelInstance;
use Etrali\GinangBundle\Entity\CabinetInstance;
use Etrali\GinangBundle\Entity\PortInstance;
use Etrali\GinangBundle\Entity\EquipmentInstance;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;
use Admingenerated\EtraliGinangBundle\BaseSlotInstanceController\NewController as BaseNewController;

class NewController extends BaseNewController
{
      public function indexAction()
    {
        $session = $this->getRequest()->getSession();
        if ($this->get('request')->query->has('typepere'))
            $session->set('typepere',$this->get('request')->query->get('typepere'));
        if ($this->get('request')->query->has('idpere'))
            $session->set('idpere',$this->get('request')->query->get('idpere'));
        if ($this->get('request')->query->has('return'))
            $session->set('return',$this->get('request')->query->get('return')); 
        if ($this->get('request')->query->has('nombre'))
            $session->set('nombre',$this->get('request')->query->get('nombre'));        
        return parent::indexAction();
    }
        
    public function createAction()
    {
        $em=$this->getDoctrine()->getEntityManager()        ;
        $SlotInstance = $this->getNewObject();

        $this->preBindRequest($SlotInstance);
        $form = $this->createForm($this->getNewType(), $SlotInstance);
      
        $form->bind($this->get('request'));

        if ($form->isValid()) {
            try {
                $this->preSave($form, $SlotInstance);
                $session = $this->getRequest()->getSession();  
                $idpere=$session->get('idpere');
                $Pere=$em->getRepository('EtraliGinangBundle:EquipmentInstance')->find($idpere);
                $SlotInstance->setIdEquipmentInstance($Pere);                                
                $this->saveObject($SlotInstance);
                $this->postSave($form, $SlotInstance);

                $entites=array();
                $entites[]=$SlotInstance;
                
                if ($session->has("nombre"))
                {
                    for ($i=1;$i<$session->get("nombre");$i++)
                    {
                        $entites[]=clone $SlotInstance;
                    }
                }
                
                foreach ($entites as $slotinst)
                {
                    $models=$slotinst->getIdComplexModel()->getIdSlot();
                    $cpt=0;
                    foreach ($models as $model)
                    {
                        if ($cpt>0)
                            $slotinst=clone $SlotInstance;
                        $cpt++;
                        $slotinst->setIdSlot($model);
                        $em->persist($slotinst);                                                                 
                        foreach ($model->getIdCard() as $dcard)
                        {
                            $dcardinst=new CardInstance();
                            $dcardinst->setCdCardInstance($dcard->getCdCard());
                            $dcardinst->setLbCardInstance($dcard->getLbCard());                                        
                            $dcardinst->setBlDeactivated(true);
                            $dcardinst->setIdCard($dcard);
                            $dcardinst->setIdMotherCard($cardinst);
                            foreach ($dcard->getIdCostingCardLine() as $costing)
                            {
                                $newcost=clone $costing;
                                $newcost->setIdCard(NULL);
                                $newcost->setIdCardInstance($dcardinst); 
                                $em->persist($newcost); 
                            }
                           
                            $em->persist($dcardinst);   
                            foreach ($dcard->getIdPort() as $port)
                            {
                                $portinst=new PortInstance();
                                $portinst->setCdPortInstance($port->getCdPort());
                                $portinst->setLbPortInstance($port->getLbPort());
                                $portinst->setCmPortInstance($port->getCmPort()); 
                                $portinst->setIdPortType($port->getIdPortType());                                
                                $portinst->setBlDeactivated(true);
                                $portinst->setIdPort($port);
                                $portinst->setIdCardInstance($cardinst);
                               
                                $em->persist($portinst);                                                                      
                            }                                    
                        }                                    
                    } 
                     
                }
                $em->flush();          
                
                $this->get('session')->getFlashBag()->add('success', $this->get('translator')->trans("action.object.edit.success", array(), 'Admingenerator') );
                return new Response('<html><body><script>parent.location.reload(true);</script></body></html>');

            } catch (\Exception $e) {
                $this->get('session')->getFlashBag()->add('error',  $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
                $this->onException($e, $form, $SlotInstance);
            }

        } else {
            $this->get('session')->getFlashBag()->add('error', $this->get('translator')->trans("action.object.edit.error", array(), 'Admingenerator') );
        }

        return $this->render('EtraliGinangBundle:SlotInstanceNew:index.html.twig', $this->getAdditionalRenderParameters($SlotInstance) + array(
            "SlotInstance" => $SlotInstance,
            "form" => $form->createView(),
        ));
    }    
}
