<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * BillingGroup
 *
 * @ORM\Table(name="billing_group")
 * @ORM\Entity
 */
class BillingGroup
{
    /**
     * @var integer $idBillingGroup
     *
     * @ORM\Column(name="id_billing_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idBillingGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_group", type="string", length=255, nullable=true)
     */
    private $lbGroup;

    /**
     * @var \Address
     *
     * @ORM\ManyToOne(targetEntity="Address", inversedBy="idBillingGroup")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_address", referencedColumnName="id_address")
     * })
     */
    private $idAddress;

    /**
     * @return string
     *
     */
    public function __toString()
    {
        return $this->lbGroup.'';
    } 
    
    


    /**
     * Get idBillingGroup
     *
     * @return integer 
     */
    public function getIdBillingGroup()
    {
        return $this->idBillingGroup;
    }

    /**
     * Set lbGroup
     *
     * @param string $lbGroup
     * @return BillingGroup
     */
    public function setLbGroup($lbGroup)
    {
        $this->lbGroup = $lbGroup;
    
        return $this;
    }

    /**
     * Get lbGroup
     *
     * @return string 
     */
    public function getLbGroup()
    {
        return $this->lbGroup;
    }

    /**
     * Set idCustomer
     *
     * @param \Etrali\GinangBundle\Entity\Customer $idCustomer
     * @return BillingGroup
     */
    public function setIdCustomer(\Etrali\GinangBundle\Entity\Customer $idCustomer = null)
    {
        $this->idCustomer = $idCustomer;
    
        return $this;
    }

    /**
     * Get idCustomer
     *
     * @return \Etrali\GinangBundle\Entity\Customer 
     */
    public function getIdCustomer()
    {
        return $this->idCustomer;
    }

    /**
     * Set idAddress
     *
     * @param \Etrali\GinangBundle\Entity\Address $idAddress
     * @return BillingGroup
     */
    public function setIdAddress(\Etrali\GinangBundle\Entity\Address $idAddress = null)
    {
        $this->idAddress = $idAddress;
    
        return $this;
    }

    /**
     * Get idAddress
     *
     * @return \Etrali\GinangBundle\Entity\Address 
     */
    public function getIdAddress()
    {
        return $this->idAddress;
    }public function getParentBranch() { return NULL; }  }