<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Calendar
 *
 * @ORM\Table(name="calendar")
 * @ORM\Entity
 */
class Calendar
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_calendar", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idCalendar;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_calendar", type="string", length=15, nullable=true)
     */
    private $cdCalendar;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_calendar", type="string", length=100, nullable=true)
     */
    private $lbCalendar;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_branch", type="integer", nullable=true)
     */
    private $idBranch;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_day_name", type="datetime", nullable=true)
     */
    private $dtDayName;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_calendar_date", type="datetime", nullable=true)
     */
    private $dtCalendarDate;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_begin_hour", type="datetime", nullable=true)
     */
    private $dtBeginHour;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end_hour", type="datetime", nullable=true)
     */
    private $dtEndHour;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idCalendar
     *
     * @return integer 
     */
    public function getIdCalendar()
    {
        return $this->idCalendar;
    }

    /**
     * Set cdCalendar
     *
     * @param string $cdCalendar
     * @return Calendar
     */
    public function setCdCalendar($cdCalendar)
    {
        $this->cdCalendar = $cdCalendar;
    
        return $this;
    }

    /**
     * Get cdCalendar
     *
     * @return string 
     */
    public function getCdCalendar()
    {
        return $this->cdCalendar;
    }

    /**
     * Set lbCalendar
     *
     * @param string $lbCalendar
     * @return Calendar
     */
    public function setLbCalendar($lbCalendar)
    {
        $this->lbCalendar = $lbCalendar;
    
        return $this;
    }

    /**
     * Get lbCalendar
     *
     * @return string 
     */
    public function getLbCalendar()
    {
        return $this->lbCalendar;
    }

    /**
     * Set idBranch
     *
     * @param integer $idBranch
     * @return Calendar
     */
    public function setIdBranch($idBranch)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return integer 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set dtDayName
     *
     * @param \DateTime $dtDayName
     * @return Calendar
     */
    public function setDtDayName($dtDayName)
    {
        $this->dtDayName = $dtDayName;
    
        return $this;
    }

    /**
     * Get dtDayName
     *
     * @return \DateTime 
     */
    public function getDtDayName()
    {
        return $this->dtDayName;
    }

    /**
     * Set dtCalendarDate
     *
     * @param \DateTime $dtCalendarDate
     * @return Calendar
     */
    public function setDtCalendarDate($dtCalendarDate)
    {
        $this->dtCalendarDate = $dtCalendarDate;
    
        return $this;
    }

    /**
     * Get dtCalendarDate
     *
     * @return \DateTime 
     */
    public function getDtCalendarDate()
    {
        return $this->dtCalendarDate;
    }

    /**
     * Set dtBeginHour
     *
     * @param \DateTime $dtBeginHour
     * @return Calendar
     */
    public function setDtBeginHour($dtBeginHour)
    {
        $this->dtBeginHour = $dtBeginHour;
    
        return $this;
    }

    /**
     * Get dtBeginHour
     *
     * @return \DateTime 
     */
    public function getDtBeginHour()
    {
        return $this->dtBeginHour;
    }

    /**
     * Set dtEndHour
     *
     * @param \DateTime $dtEndHour
     * @return Calendar
     */
    public function setDtEndHour($dtEndHour)
    {
        $this->dtEndHour = $dtEndHour;
    
        return $this;
    }

    /**
     * Get dtEndHour
     *
     * @return \DateTime 
     */
    public function getDtEndHour()
    {
        return $this->dtEndHour;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Calendar
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }