<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Domain
 *
 * @ORM\Table(name="domain")
 * @ORM\Entity
 */
class Domain
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_domain", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idDomain;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_domain", type="string", length=15, nullable=false)
     */
    private $cdDomain;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_domain", type="string", length=100, nullable=false)
     */
    private $lbDomain;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idDomain
     *
     * @return integer 
     */
    public function getIdDomain()
    {
        return $this->idDomain;
    }

    /**
     * Set cdDomain
     *
     * @param string $cdDomain
     * @return Domain
     */
    public function setCdDomain($cdDomain)
    {
        $this->cdDomain = $cdDomain;
    
        return $this;
    }

    /**
     * Get cdDomain
     *
     * @return string 
     */
    public function getCdDomain()
    {
        return $this->cdDomain;
    }

    /**
     * Set lbDomain
     *
     * @param string $lbDomain
     * @return Domain
     */
    public function setLbDomain($lbDomain)
    {
        $this->lbDomain = $lbDomain;
    
        return $this;
    }

    /**
     * Get lbDomain
     *
     * @return string 
     */
    public function getLbDomain()
    {
        return $this->lbDomain;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Domain
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }