<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Floor
 *
 * @ORM\Table(name="floor")
 * @ORM\Entity
 */
class Floor
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_floor", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idFloor;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_floor", type="string", length=15, nullable=true)
     */
    private $cdFloor;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_floor", type="string", length=255, nullable=true)
     */
    private $lbFloor;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idFloor
     *
     * @return integer 
     */
    public function getIdFloor()
    {
        return $this->idFloor;
    }

    /**
     * Set cdFloor
     *
     * @param string $cdFloor
     * @return Floor
     */
    public function setCdFloor($cdFloor)
    {
        $this->cdFloor = $cdFloor;
    
        return $this;
    }

    /**
     * Get cdFloor
     *
     * @return string 
     */
    public function getCdFloor()
    {
        return $this->cdFloor;
    }

    /**
     * Set lbFloor
     *
     * @param string $lbFloor
     * @return Floor
     */
    public function setLbFloor($lbFloor)
    {
        $this->lbFloor = $lbFloor;
    
        return $this;
    }

    /**
     * Get lbFloor
     *
     * @return string 
     */
    public function getLbFloor()
    {
        return $this->lbFloor;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Floor
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return Floor
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}