<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * GinaParam
 *
 * @ORM\Table(name="gina_param")
 * @ORM\Entity
 */
class GinaParam
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_gina_param", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idGinaParam;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_gina_param", type="string", length=15, nullable=true)
     */
    private $cdGinaParam;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_gina_param", type="string", length=100, nullable=true)
     */
    private $lbGinaParam;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_param", type="decimal", nullable=true)
     */
    private $nbParam;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_param", type="string", length=255, nullable=true)
     */
    private $lbParam;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_param", type="datetime", nullable=true)
     */
    private $dtParam;



    /**
     * Get idGinaParam
     *
     * @return integer 
     */
    public function getIdGinaParam()
    {
        return $this->idGinaParam;
    }

    /**
     * Set cdGinaParam
     *
     * @param string $cdGinaParam
     * @return GinaParam
     */
    public function setCdGinaParam($cdGinaParam)
    {
        $this->cdGinaParam = $cdGinaParam;
    
        return $this;
    }

    /**
     * Get cdGinaParam
     *
     * @return string 
     */
    public function getCdGinaParam()
    {
        return $this->cdGinaParam;
    }

    /**
     * Set lbGinaParam
     *
     * @param string $lbGinaParam
     * @return GinaParam
     */
    public function setLbGinaParam($lbGinaParam)
    {
        $this->lbGinaParam = $lbGinaParam;
    
        return $this;
    }

    /**
     * Get lbGinaParam
     *
     * @return string 
     */
    public function getLbGinaParam()
    {
        return $this->lbGinaParam;
    }

    /**
     * Set nbParam
     *
     * @param float $nbParam
     * @return GinaParam
     */
    public function setNbParam($nbParam)
    {
        $this->nbParam = $nbParam;
    
        return $this;
    }

    /**
     * Get nbParam
     *
     * @return float 
     */
    public function getNbParam()
    {
        return $this->nbParam;
    }

    /**
     * Set lbParam
     *
     * @param string $lbParam
     * @return GinaParam
     */
    public function setLbParam($lbParam)
    {
        $this->lbParam = $lbParam;
    
        return $this;
    }

    /**
     * Get lbParam
     *
     * @return string 
     */
    public function getLbParam()
    {
        return $this->lbParam;
    }

    /**
     * Set dtParam
     *
     * @param \DateTime $dtParam
     * @return GinaParam
     */
    public function setDtParam($dtParam)
    {
        $this->dtParam = $dtParam;
    
        return $this;
    }

    /**
     * Get dtParam
     *
     * @return \DateTime 
     */
    public function getDtParam()
    {
        return $this->dtParam;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }