<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * IomType
 *
 * @ORM\Table(name="iom_type")
 * @ORM\Entity
 */
class IomType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_iom_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idIomType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_iom_type", type="string", length=45, nullable=true)
     */
    private $cdIomType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_iom_type", type="string", length=255, nullable=true)
     */
    private $lbIomType;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_iom_type", type="string", length=255, nullable=true)
     */
    private $cmIomType;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_start", type="datetime", nullable=true)
     */
    private $dtStart;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_end", type="datetime", nullable=true)
     */
    private $dtEnd;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idIomType
     *
     * @return integer 
     */
    public function getIdIomType()
    {
        return $this->idIomType;
    }

    /**
     * Set cdIomType
     *
     * @param string $cdIomType
     * @return IomType
     */
    public function setCdIomType($cdIomType)
    {
        $this->cdIomType = $cdIomType;
    
        return $this;
    }

    /**
     * Get cdIomType
     *
     * @return string 
     */
    public function getCdIomType()
    {
        return $this->cdIomType;
    }

    /**
     * Set lbIomType
     *
     * @param string $lbIomType
     * @return IomType
     */
    public function setLbIomType($lbIomType)
    {
        $this->lbIomType = $lbIomType;
    
        return $this;
    }

    /**
     * Get lbIomType
     *
     * @return string 
     */
    public function getLbIomType()
    {
        return $this->lbIomType;
    }

    /**
     * Set cmIomType
     *
     * @param string $cmIomType
     * @return IomType
     */
    public function setCmIomType($cmIomType)
    {
        $this->cmIomType = $cmIomType;
    
        return $this;
    }

    /**
     * Get cmIomType
     *
     * @return string 
     */
    public function getCmIomType()
    {
        return $this->cmIomType;
    }

    /**
     * Set dtStart
     *
     * @param \DateTime $dtStart
     * @return IomType
     */
    public function setDtStart($dtStart)
    {
        $this->dtStart = $dtStart;
    
        return $this;
    }

    /**
     * Get dtStart
     *
     * @return \DateTime 
     */
    public function getDtStart()
    {
        return $this->dtStart;
    }

    /**
     * Set dtEnd
     *
     * @param \DateTime $dtEnd
     * @return IomType
     */
    public function setDtEnd($dtEnd)
    {
        $this->dtEnd = $dtEnd;
    
        return $this;
    }

    /**
     * Get dtEnd
     *
     * @return \DateTime 
     */
    public function getDtEnd()
    {
        return $this->dtEnd;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return IomType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }