<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * OfferType
 *
 * @ORM\Table(name="offer_type")
 * @ORM\Entity
 */
class OfferType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_offer_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idOfferType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_offer_type", type="string", length=15, nullable=false)
     */
    private $cdOfferType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_offer_type", type="string", length=100, nullable=false)
     */
    private $lbOfferType;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_circuit_max", type="integer", nullable=true)
     */
    private $nbCircuitMax;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_circuit_alert", type="integer", nullable=true)
     */
    private $nbCircuitAlert;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_bandwidth_max", type="decimal", nullable=true)
     */
    private $nbBandwidthMax;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_bandwidth_alert", type="decimal", nullable=true)
     */
    private $nbBandwidthAlert;



    /**
     * Get idOfferType
     *
     * @return integer 
     */
    public function getIdOfferType()
    {
        return $this->idOfferType;
    }

    /**
     * Set cdOfferType
     *
     * @param string $cdOfferType
     * @return OfferType
     */
    public function setCdOfferType($cdOfferType)
    {
        $this->cdOfferType = $cdOfferType;
    
        return $this;
    }

    /**
     * Get cdOfferType
     *
     * @return string 
     */
    public function getCdOfferType()
    {
        return $this->cdOfferType;
    }

    /**
     * Set lbOfferType
     *
     * @param string $lbOfferType
     * @return OfferType
     */
    public function setLbOfferType($lbOfferType)
    {
        $this->lbOfferType = $lbOfferType;
    
        return $this;
    }

    /**
     * Get lbOfferType
     *
     * @return string 
     */
    public function getLbOfferType()
    {
        return $this->lbOfferType;
    }

    /**
     * Set nbCircuitMax
     *
     * @param integer $nbCircuitMax
     * @return OfferType
     */
    public function setNbCircuitMax($nbCircuitMax)
    {
        $this->nbCircuitMax = $nbCircuitMax;
    
        return $this;
    }

    /**
     * Get nbCircuitMax
     *
     * @return integer 
     */
    public function getNbCircuitMax()
    {
        return $this->nbCircuitMax;
    }

    /**
     * Set nbCircuitAlert
     *
     * @param integer $nbCircuitAlert
     * @return OfferType
     */
    public function setNbCircuitAlert($nbCircuitAlert)
    {
        $this->nbCircuitAlert = $nbCircuitAlert;
    
        return $this;
    }

    /**
     * Get nbCircuitAlert
     *
     * @return integer 
     */
    public function getNbCircuitAlert()
    {
        return $this->nbCircuitAlert;
    }

    /**
     * Set nbBandwidthMax
     *
     * @param float $nbBandwidthMax
     * @return OfferType
     */
    public function setNbBandwidthMax($nbBandwidthMax)
    {
        $this->nbBandwidthMax = $nbBandwidthMax;
    
        return $this;
    }

    /**
     * Get nbBandwidthMax
     *
     * @return float 
     */
    public function getNbBandwidthMax()
    {
        return $this->nbBandwidthMax;
    }

    /**
     * Set nbBandwidthAlert
     *
     * @param float $nbBandwidthAlert
     * @return OfferType
     */
    public function setNbBandwidthAlert($nbBandwidthAlert)
    {
        $this->nbBandwidthAlert = $nbBandwidthAlert;
    
        return $this;
    }

    /**
     * Get nbBandwidthAlert
     *
     * @return float 
     */
    public function getNbBandwidthAlert()
    {
        return $this->nbBandwidthAlert;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }