<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Orientation
 *
 * @ORM\Table(name="orientation")
 * @ORM\Entity
 */
class Orientation
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_orientation", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idOrientation;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_orientation", type="string", length=15, nullable=true)
     */
    private $cdOrientation;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_orientation", type="string", length=255, nullable=true)
     */
    private $lbOrientation;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idOrientation
     *
     * @return integer 
     */
    public function getIdOrientation()
    {
        return $this->idOrientation;
    }

    /**
     * Set cdOrientation
     *
     * @param string $cdOrientation
     * @return Orientation
     */
    public function setCdOrientation($cdOrientation)
    {
        $this->cdOrientation = $cdOrientation;
    
        return $this;
    }

    /**
     * Get cdOrientation
     *
     * @return string 
     */
    public function getCdOrientation()
    {
        return $this->cdOrientation;
    }

    /**
     * Set lbOrientation
     *
     * @param string $lbOrientation
     * @return Orientation
     */
    public function setLbOrientation($lbOrientation)
    {
        $this->lbOrientation = $lbOrientation;
    
        return $this;
    }

    /**
     * Get lbOrientation
     *
     * @return string 
     */
    public function getLbOrientation()
    {
        return $this->lbOrientation;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Orientation
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }