<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ProductCommercials
 *
 * @ORM\Table(name="product_commercials")
 * @ORM\Entity
 */
class ProductCommercials
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_product_commercials", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProductCommercials;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_product_commercials", type="string", length=255, nullable=false)
     */
    private $lbProductCommercials;


    /**
     * @var \ProductType
     *
     * @ORM\ManyToOne(targetEntity="ProductType", inversedBy="idProductCaracs")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_product_type", referencedColumnName="id_product_type")
     * })
     */
    private $idProductType;


   

    
    public function __toString()
    {
       return $this->lbProductCommercials;
    }

   

    /**
     * Get idProductCommercials
     *
     * @return integer 
     */
    public function getIdProductCommercials()
    {
        return $this->idProductCommercials;
    }

    /**
     * Set lbProductCommercials
     *
     * @param string $lbProductCommercials
     * @return ProductCommercials
     */
    public function setLbProductCommercials($lbProductCommercials)
    {
        $this->lbProductCommercials = $lbProductCommercials;
    
        return $this;
    }

    /**
     * Get lbProductCommercials
     *
     * @return string 
     */
    public function getLbProductCommercials()
    {
        return $this->lbProductCommercials;
    }

    /**
     * Set idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     * @return ProductCommercials
     */
    public function setIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType = null)
    {
        $this->idProductType = $idProductType;
    
        return $this;
    }

    /**
     * Get idProductType
     *
     * @return \Etrali\GinangBundle\Entity\ProductType 
     */
    public function getIdProductType()
    {
        return $this->idProductType;
    }public function getParentBranch() { return NULL; }  }