<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Profile
 *
 * @ORM\Table(name="profile")
 * @ORM\Entity
 */
class Profile
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_profile", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idProfile;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_profile", type="string", length=15, nullable=false)
     */
    private $cdProfile;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_profile", type="string", length=100, nullable=false)
     */
    private $lbProfile;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_profile", type="string", length=255, nullable=true)
     */
    private $cmProfile;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idProfile
     *
     * @return integer 
     */
    public function getIdProfile()
    {
        return $this->idProfile;
    }

    /**
     * Set cdProfile
     *
     * @param string $cdProfile
     * @return Profile
     */
    public function setCdProfile($cdProfile)
    {
        $this->cdProfile = $cdProfile;
    
        return $this;
    }

    /**
     * Get cdProfile
     *
     * @return string 
     */
    public function getCdProfile()
    {
        return $this->cdProfile;
    }

    /**
     * Set lbProfile
     *
     * @param string $lbProfile
     * @return Profile
     */
    public function setLbProfile($lbProfile)
    {
        $this->lbProfile = $lbProfile;
    
        return $this;
    }

    /**
     * Get lbProfile
     *
     * @return string 
     */
    public function getLbProfile()
    {
        return $this->lbProfile;
    }

    /**
     * Set cmProfile
     *
     * @param string $cmProfile
     * @return Profile
     */
    public function setCmProfile($cmProfile)
    {
        $this->cmProfile = $cmProfile;
    
        return $this;
    }

    /**
     * Get cmProfile
     *
     * @return string 
     */
    public function getCmProfile()
    {
        return $this->cmProfile;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Profile
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }