<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Row
 *
 * @ORM\Table(name="row")
 * @ORM\Entity
 */
class Row
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_row", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idRow;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_row", type="string", length=15, nullable=true)
     */
    private $cdRow;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_row", type="string", length=100, nullable=true)
     */
    private $lbRow;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \Room
     *
     * @ORM\ManyToOne(targetEntity="Room")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_room", referencedColumnName="id_room")
     * })
     */
    private $idRoom;



    /**
     * Get idRow
     *
     * @return integer 
     */
    public function getIdRow()
    {
        return $this->idRow;
    }

    /**
     * Set cdRow
     *
     * @param string $cdRow
     * @return Row
     */
    public function setCdRow($cdRow)
    {
        $this->cdRow = $cdRow;
    
        return $this;
    }

    /**
     * Get cdRow
     *
     * @return string 
     */
    public function getCdRow()
    {
        return $this->cdRow;
    }

    /**
     * Set lbRow
     *
     * @param string $lbRow
     * @return Row
     */
    public function setLbRow($lbRow)
    {
        $this->lbRow = $lbRow;
    
        return $this;
    }

    /**
     * Get lbRow
     *
     * @return string 
     */
    public function getLbRow()
    {
        return $this->lbRow;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Row
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idRoom
     *
     * @param \Etrali\GinangBundle\Entity\Room $idRoom
     * @return Row
     */
    public function setIdRoom(\Etrali\GinangBundle\Entity\Room $idRoom = null)
    {
        $this->idRoom = $idRoom;
    
        return $this;
    }

    /**
     * Get idRoom
     *
     * @return \Etrali\GinangBundle\Entity\Room 
     */
    public function getIdRoom()
    {
        return $this->idRoom;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }