<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceType
 *
 * @ORM\Table(name="service_type")
 * @ORM\Entity
 */
class ServiceType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_service_type", type="string", length=15, nullable=false)
     */
    private $cdServiceType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_service_type", type="string", length=100, nullable=false)
     */
    private $lbServiceType;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_nrc_account", type="string", length=15, nullable=true)
     */
    private $cdNrcAccount;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_mrc_account", type="string", length=15, nullable=true)
     */
    private $cdMrcAccount;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_type_account", type="string", length=15, nullable=true)
     */
    private $cdTypeAccount;


    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 
    /**
     * Get idServiceType
     *
     * @return integer 
     */
    public function getIdServiceType()
    {
        return $this->idServiceType;
    }

    /**
     * Set cdServiceType
     *
     * @param string $cdServiceType
     * @return ServiceType
     */
    public function setCdServiceType($cdServiceType)
    {
        $this->cdServiceType = $cdServiceType;
    
        return $this;
    }

    /**
     * Get cdServiceType
     *
     * @return string 
     */
    public function getCdServiceType()
    {
        return $this->cdServiceType;
    }

    /**
     * Set lbServiceType
     *
     * @param string $lbServiceType
     * @return ServiceType
     */
    public function setLbServiceType($lbServiceType)
    {
        $this->lbServiceType = $lbServiceType;
    
        return $this;
    }

    /**
     * Get lbServiceType
     *
     * @return string 
     */
    public function getLbServiceType()
    {
        return $this->lbServiceType;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return ServiceType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set cdNrcAccount
     *
     * @param string $cdNrcAccount
     * @return ServiceType
     */
    public function setCdNrcAccount($cdNrcAccount)
    {
        $this->cdNrcAccount = $cdNrcAccount;
    
        return $this;
    }

    /**
     * Get cdNrcAccount
     *
     * @return string 
     */
    public function getCdNrcAccount()
    {
        return $this->cdNrcAccount;
    }

    /**
     * Set cdMrcAccount
     *
     * @param string $cdMrcAccount
     * @return ServiceType
     */
    public function setCdMrcAccount($cdMrcAccount)
    {
        $this->cdMrcAccount = $cdMrcAccount;
    
        return $this;
    }

    /**
     * Get cdMrcAccount
     *
     * @return string 
     */
    public function getCdMrcAccount()
    {
        return $this->cdMrcAccount;
    }

    /**
     * Set cdTypeAccount
     *
     * @param string $cdTypeAccount
     * @return ServiceType
     */
    public function setCdTypeAccount($cdTypeAccount)
    {
        $this->cdTypeAccount = $cdTypeAccount;
    
        return $this;
    }

    /**
     * Get cdTypeAccount
     *
     * @return string 
     */
    public function getCdTypeAccount()
    {
        return $this->cdTypeAccount;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return ServiceType
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}