<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * ServiceWorkflowScreen
 *
 * @ORM\Table(name="service_workflow_screen")
 * @ORM\Entity
 */
class ServiceWorkflowScreen
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_service_workflow_screen", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idServiceWorkflowScreen;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_service_ccial", type="boolean", nullable=false)
     */
    private $blServiceCcial;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_extremity_ccial", type="boolean", nullable=false)
     */
    private $blExtremityCcial;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_device_ccial", type="boolean", nullable=false)
     */
    private $blDeviceCcial;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_billing", type="boolean", nullable=false)
     */
    private $blBilling;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_technical", type="boolean", nullable=false)
     */
    private $blTechnical;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_connected_services", type="boolean", nullable=false)
     */
    private $blConnectedServices;

    /**
     * @var \ProductType
     *
     * @ORM\ManyToOne(targetEntity="ProductType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_product_type", referencedColumnName="id_product_type")
     * })
     */
    private $idProductType;



    /**
     * Get idServiceWorkflowScreen
     *
     * @return integer 
     */
    public function getIdServiceWorkflowScreen()
    {
        return $this->idServiceWorkflowScreen;
    }

    /**
     * Set blServiceCcial
     *
     * @param boolean $blServiceCcial
     * @return ServiceWorkflowScreen
     */
    public function setBlServiceCcial($blServiceCcial)
    {
        $this->blServiceCcial = $blServiceCcial;
    
        return $this;
    }

    /**
     * Get blServiceCcial
     *
     * @return boolean 
     */
    public function getBlServiceCcial()
    {
        return $this->blServiceCcial;
    }

    /**
     * Set blExtremityCcial
     *
     * @param boolean $blExtremityCcial
     * @return ServiceWorkflowScreen
     */
    public function setBlExtremityCcial($blExtremityCcial)
    {
        $this->blExtremityCcial = $blExtremityCcial;
    
        return $this;
    }

    /**
     * Get blExtremityCcial
     *
     * @return boolean 
     */
    public function getBlExtremityCcial()
    {
        return $this->blExtremityCcial;
    }

    /**
     * Set blDeviceCcial
     *
     * @param boolean $blDeviceCcial
     * @return ServiceWorkflowScreen
     */
    public function setBlDeviceCcial($blDeviceCcial)
    {
        $this->blDeviceCcial = $blDeviceCcial;
    
        return $this;
    }

    /**
     * Get blDeviceCcial
     *
     * @return boolean 
     */
    public function getBlDeviceCcial()
    {
        return $this->blDeviceCcial;
    }

    /**
     * Set blBilling
     *
     * @param boolean $blBilling
     * @return ServiceWorkflowScreen
     */
    public function setBlBilling($blBilling)
    {
        $this->blBilling = $blBilling;
    
        return $this;
    }

    /**
     * Get blBilling
     *
     * @return boolean 
     */
    public function getBlBilling()
    {
        return $this->blBilling;
    }

    /**
     * Set blTechnical
     *
     * @param boolean $blTechnical
     * @return ServiceWorkflowScreen
     */
    public function setBlTechnical($blTechnical)
    {
        $this->blTechnical = $blTechnical;
    
        return $this;
    }

    /**
     * Get blTechnical
     *
     * @return boolean 
     */
    public function getBlTechnical()
    {
        return $this->blTechnical;
    }

    /**
     * Set blConnectedServices
     *
     * @param boolean $blConnectedServices
     * @return ServiceWorkflowScreen
     */
    public function setBlConnectedServices($blConnectedServices)
    {
        $this->blConnectedServices = $blConnectedServices;
    
        return $this;
    }

    /**
     * Get blConnectedServices
     *
     * @return boolean 
     */
    public function getBlConnectedServices()
    {
        return $this->blConnectedServices;
    }

    /**
     * Set idProductType
     *
     * @param \Etrali\GinangBundle\Entity\ProductType $idProductType
     * @return ServiceWorkflowScreen
     */
    public function setIdProductType(\Etrali\GinangBundle\Entity\ProductType $idProductType = null)
    {
        $this->idProductType = $idProductType;
    
        return $this;
    }

    /**
     * Get idProductType
     *
     * @return \Etrali\GinangBundle\Entity\ProductType 
     */
    public function getIdProductType()
    {
        return $this->idProductType;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }