<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * Sla
 *
 * @ORM\Table(name="sla")
 * @ORM\Entity
 */
class Sla
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_sla", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idSla;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_sla", type="string", length=15, nullable=true)
     */
    private $cdSla;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_sla", type="string", length=250, nullable=true)
     */
    private $lbSla;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \SlaType
     *
     * @ORM\ManyToOne(targetEntity="SlaType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_sla_type", referencedColumnName="id_sla_type")
     * })
     */
    private $idSlaType;




    /**
     * Get idSla
     *
     * @return integer 
     */
    public function getIdSla()
    {
        return $this->idSla;
    }

    /**
     * Set cdSla
     *
     * @param string $cdSla
     * @return Sla
     */
    public function setCdSla($cdSla)
    {
        $this->cdSla = $cdSla;
    
        return $this;
    }

    /**
     * Get cdSla
     *
     * @return string 
     */
    public function getCdSla()
    {
        return $this->cdSla;
    }

    /**
     * Set lbSla
     *
     * @param string $lbSla
     * @return Sla
     */
    public function setLbSla($lbSla)
    {
        $this->lbSla = $lbSla;
    
        return $this;
    }

    /**
     * Get lbSla
     *
     * @return string 
     */
    public function getLbSla()
    {
        return $this->lbSla;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return Sla
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idSlaType
     *
     * @param \Etrali\GinangBundle\Entity\SlaType $idSlaType
     * @return Sla
     */
    public function setIdSlaType(\Etrali\GinangBundle\Entity\SlaType $idSlaType = null)
    {
        $this->idSlaType = $idSlaType;
    
        return $this;
    }

    /**
     * Get idSlaType
     *
     * @return \Etrali\GinangBundle\Entity\SlaType 
     */
    public function getIdSlaType()
    {
        return $this->idSlaType;
    }


public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }