<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * SlaType
 *
 * @ORM\Table(name="sla_type")
 * @ORM\Entity
 */
class SlaType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_sla_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idSlaType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_sla_type", type="string", length=15, nullable=true)
     */
    private $cdSlaType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_sla_type", type="string", length=250, nullable=true)
     */
    private $lbSlaType;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_quantity", type="decimal", nullable=true)
     */
    private $nbQuantity;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idSlaType
     *
     * @return integer 
     */
    public function getIdSlaType()
    {
        return $this->idSlaType;
    }

    /**
     * Set cdSlaType
     *
     * @param string $cdSlaType
     * @return SlaType
     */
    public function setCdSlaType($cdSlaType)
    {
        $this->cdSlaType = $cdSlaType;
    
        return $this;
    }

    /**
     * Get cdSlaType
     *
     * @return string 
     */
    public function getCdSlaType()
    {
        return $this->cdSlaType;
    }

    /**
     * Set lbSlaType
     *
     * @param string $lbSlaType
     * @return SlaType
     */
    public function setLbSlaType($lbSlaType)
    {
        $this->lbSlaType = $lbSlaType;
    
        return $this;
    }

    /**
     * Get lbSlaType
     *
     * @return string 
     */
    public function getLbSlaType()
    {
        return $this->lbSlaType;
    }

    /**
     * Set nbQuantity
     *
     * @param float $nbQuantity
     * @return SlaType
     */
    public function setNbQuantity($nbQuantity)
    {
        $this->nbQuantity = $nbQuantity;
    
        return $this;
    }

    /**
     * Get nbQuantity
     *
     * @return float 
     */
    public function getNbQuantity()
    {
        return $this->nbQuantity;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return SlaType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }