<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * StatusType
 *
 * @ORM\Table(name="status_type")
 * @ORM\Entity
 */
class StatusType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_status_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idStatusType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_status_type", type="string", length=50, nullable=true)
     */
    private $cdStatusType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_status_type", type="string", length=255, nullable=true)
     */
    private $lbStatusType;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var integer
     *
     * @ORM\Column(name="nb_order", type="integer", nullable=true)
     */
    private $nbOrder;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectType;

    /**
     * @var \Mail
     *
     * @ORM\ManyToOne(targetEntity="Mail")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_mail", referencedColumnName="id_mail")
     * })
     */
    private $idMail;



    /**
     * Get idStatusType
     *
     * @return integer 
     */
    public function getIdStatusType()
    {
        return $this->idStatusType;
    }

    /**
     * Set cdStatusType
     *
     * @param string $cdStatusType
     * @return StatusType
     */
    public function setCdStatusType($cdStatusType)
    {
        $this->cdStatusType = $cdStatusType;
    
        return $this;
    }

    /**
     * Get cdStatusType
     *
     * @return string 
     */
    public function getCdStatusType()
    {
        return $this->cdStatusType;
    }

    /**
     * Set lbStatusType
     *
     * @param string $lbStatusType
     * @return StatusType
     */
    public function setLbStatusType($lbStatusType)
    {
        $this->lbStatusType = $lbStatusType;
    
        return $this;
    }

    /**
     * Get lbStatusType
     *
     * @return string 
     */
    public function getLbStatusType()
    {
        return $this->lbStatusType;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return StatusType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set nbOrder
     *
     * @param integer $nbOrder
     * @return StatusType
     */
    public function setNbOrder($nbOrder)
    {
        $this->nbOrder = $nbOrder;
    
        return $this;
    }

    /**
     * Get nbOrder
     *
     * @return integer 
     */
    public function getNbOrder()
    {
        return $this->nbOrder;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return StatusType
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }

    /**
     * Set idMail
     *
     * @param \Etrali\GinangBundle\Entity\Mail $idMail
     * @return StatusType
     */
    public function setIdMail(\Etrali\GinangBundle\Entity\Mail $idMail = null)
    {
        $this->idMail = $idMail;
    
        return $this;
    }

    /**
     * Get idMail
     *
     * @return \Etrali\GinangBundle\Entity\Mail 
     */
    public function getIdMail()
    {
        return $this->idMail;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }