<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * TGroup
 *
 * @ORM\Table(name="t_group")
 * @ORM\Entity
 */
class TGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_group", type="string", length=100, nullable=false)
     */
    private $lbGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_public", type="boolean", nullable=true)
     */
    private $blPublic;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \TGroup
     *
     * @ORM\ManyToOne(targetEntity="TGroup")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_group_parent", referencedColumnName="id_group")
     * })
     */
    private $idGroupParent;



    /**
     * Get idGroup
     *
     * @return integer 
     */
    public function getIdGroup()
    {
        return $this->idGroup;
    }

    /**
     * Set lbGroup
     *
     * @param string $lbGroup
     * @return TGroup
     */
    public function setLbGroup($lbGroup)
    {
        $this->lbGroup = $lbGroup;
    
        return $this;
    }

    /**
     * Get lbGroup
     *
     * @return string 
     */
    public function getLbGroup()
    {
        return $this->lbGroup;
    }

    /**
     * Set blPublic
     *
     * @param boolean $blPublic
     * @return TGroup
     */
    public function setBlPublic($blPublic)
    {
        $this->blPublic = $blPublic;
    
        return $this;
    }

    /**
     * Get blPublic
     *
     * @return boolean 
     */
    public function getBlPublic()
    {
        return $this->blPublic;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return TGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idGroupParent
     *
     * @param \Etrali\GinangBundle\Entity\TGroup $idGroupParent
     * @return TGroup
     */
    public function setIdGroupParent(\Etrali\GinangBundle\Entity\TGroup $idGroupParent = null)
    {
        $this->idGroupParent = $idGroupParent;
    
        return $this;
    }

    /**
     * Get idGroupParent
     *
     * @return \Etrali\GinangBundle\Entity\TGroup 
     */
    public function getIdGroupParent()
    {
        return $this->idGroupParent;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }