<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * TOption
 *
 * @ORM\Table(name="t_option")
 * @ORM\Entity
 */
class TOption
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_option", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idOption;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_option", type="string", length=15, nullable=true)
     */
    private $cdOption;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_option", type="string", length=250, nullable=true)
     */
    private $lbOption;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * @var \OptionType
     *
     * @ORM\ManyToOne(targetEntity="OptionType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_option_type", referencedColumnName="id_option_type")
     * })
     */
    private $idOptionType;



    /**
     * Get idOption
     *
     * @return integer 
     */
    public function getIdOption()
    {
        return $this->idOption;
    }

    /**
     * Set cdOption
     *
     * @param string $cdOption
     * @return TOption
     */
    public function setCdOption($cdOption)
    {
        $this->cdOption = $cdOption;
    
        return $this;
    }

    /**
     * Get cdOption
     *
     * @return string 
     */
    public function getCdOption()
    {
        return $this->cdOption;
    }

    /**
     * Set lbOption
     *
     * @param string $lbOption
     * @return TOption
     */
    public function setLbOption($lbOption)
    {
        $this->lbOption = $lbOption;
    
        return $this;
    }

    /**
     * Get lbOption
     *
     * @return string 
     */
    public function getLbOption()
    {
        return $this->lbOption;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return TOption
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }


    /**
     * Set idOptionType
     *
     * @param \Etrali\GinangBundle\Entity\OptionType $idOptionType
     * @return TOption
     */
    public function setIdOptionType(\Etrali\GinangBundle\Entity\OptionType $idOptionType = null)
    {
        $this->idOptionType = $idOptionType;
    
        return $this;
    }

    /**
     * Get idOptionType
     *
     * @return \Etrali\GinangBundle\Entity\OptionType 
     */
    public function getIdOptionType()
    {
        return $this->idOptionType;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }