<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * TemplateNetwork
 *
 * @ORM\Table(name="template_network")
 * @ORM\Entity
 */
class TemplateNetwork
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_template_network", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idTemplateNetwork;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_template_network", type="string", length=100, nullable=true)
     */
    private $cdTemplateNetwork;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_template_network", type="text", nullable=true)
     */
    private $lbTemplateNetwork;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_object", type="integer", nullable=true)
     */
    private $idObject;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \ObjectType
     *
     * @ORM\ManyToOne(targetEntity="ObjectType")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_object_type", referencedColumnName="id_object_type")
     * })
     */
    private $idObjectType;



    /**
     * Get idTemplateNetwork
     *
     * @return integer 
     */
    public function getIdTemplateNetwork()
    {
        return $this->idTemplateNetwork;
    }

    /**
     * Set cdTemplateNetwork
     *
     * @param string $cdTemplateNetwork
     * @return TemplateNetwork
     */
    public function setCdTemplateNetwork($cdTemplateNetwork)
    {
        $this->cdTemplateNetwork = $cdTemplateNetwork;
    
        return $this;
    }

    /**
     * Get cdTemplateNetwork
     *
     * @return string 
     */
    public function getCdTemplateNetwork()
    {
        return $this->cdTemplateNetwork;
    }

    /**
     * Set lbTemplateNetwork
     *
     * @param string $lbTemplateNetwork
     * @return TemplateNetwork
     */
    public function setLbTemplateNetwork($lbTemplateNetwork)
    {
        $this->lbTemplateNetwork = $lbTemplateNetwork;
    
        return $this;
    }

    /**
     * Get lbTemplateNetwork
     *
     * @return string 
     */
    public function getLbTemplateNetwork()
    {
        return $this->lbTemplateNetwork;
    }

    /**
     * Set idObject
     *
     * @param integer $idObject
     * @return TemplateNetwork
     */
    public function setIdObject($idObject)
    {
        $this->idObject = $idObject;
    
        return $this;
    }

    /**
     * Get idObject
     *
     * @return integer 
     */
    public function getIdObject()
    {
        return $this->idObject;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return TemplateNetwork
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }

    /**
     * Set idObjectType
     *
     * @param \Etrali\GinangBundle\Entity\ObjectType $idObjectType
     * @return TemplateNetwork
     */
    public function setIdObjectType(\Etrali\GinangBundle\Entity\ObjectType $idObjectType = null)
    {
        $this->idObjectType = $idObjectType;
    
        return $this;
    }

    /**
     * Get idObjectType
     *
     * @return \Etrali\GinangBundle\Entity\ObjectType 
     */
    public function getIdObjectType()
    {
        return $this->idObjectType;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }