<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * UserGroup
 *
 * @ORM\Table(name="user_group")
 * @ORM\Entity
 */
class UserGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idUserGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_user_group", type="string", length=15, nullable=true)
     */
    private $cdUserGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_user_group", type="string", length=255, nullable=true)
     */
    private $lbUserGroup;

    /**
     * @var string
     *
     * @ORM\Column(name="cm_user_group", type="string", length=255, nullable=true)
     */
    private $cmUserGroup;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="dt_deactivated", type="datetime", nullable=true)
     */
    private $dtDeactivated; 

    /**
     * Get idUserGroup
     *
     * @return integer 
     */
    public function getIdUserGroup()
    {
        return $this->idUserGroup;
    }

    /**
     * Set cdUserGroup
     *
     * @param string $cdUserGroup
     * @return UserGroup
     */
    public function setCdUserGroup($cdUserGroup)
    {
        $this->cdUserGroup = $cdUserGroup;
    
        return $this;
    }

    /**
     * Get cdUserGroup
     *
     * @return string 
     */
    public function getCdUserGroup()
    {
        return $this->cdUserGroup;
    }

    /**
     * Set lbUserGroup
     *
     * @param string $lbUserGroup
     * @return UserGroup
     */
    public function setLbUserGroup($lbUserGroup)
    {
        $this->lbUserGroup = $lbUserGroup;
    
        return $this;
    }

    /**
     * Get lbUserGroup
     *
     * @return string 
     */
    public function getLbUserGroup()
    {
        return $this->lbUserGroup;
    }

    /**
     * Set cmUserGroup
     *
     * @param string $cmUserGroup
     * @return UserGroup
     */
    public function setCmUserGroup($cmUserGroup)
    {
        $this->cmUserGroup = $cmUserGroup;
    
        return $this;
    }

    /**
     * Get cmUserGroup
     *
     * @return string 
     */
    public function getCmUserGroup()
    {
        return $this->cmUserGroup;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return UserGroup
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  
    /**
     * Set dtDeactivated
     *
     * @param \DateTime $dtDeactivated
     * @return UserGroup
     */
    public function setDtDeactivated($dtDeactivated)
    {
        $this->dtDeactivated = $dtDeactivated;
    
        return $this;
    }

    /**
     * Get dtDeactivated
     *
     * @return \DateTime 
     */
    public function getDtDeactivated()
    {
        return $this->dtDeactivated;
    }
}