<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * UserInBranch
 *
 * @ORM\Table(name="user_in_branch")
 * @ORM\Entity
 */
class UserInBranch
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_in_branch", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idUserInBranch;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser", inversedBy="idUserInBranch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idMyuser;

    /**
     * @var \Branch
     *
     * @ORM\ManyToOne(targetEntity="Branch", inversedBy="idUserInBranch")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_branch", referencedColumnName="id_branch")
     * })
     */
    private $idBranch;

    /**
     * @var string
     *
     * @ORM\Column(name="role", type="string", length=100, nullable=false)
     */
    private $role;
    
    public function __toString() {
        return $this->role;
    }
    
    public function getHeadInfo()
    {      
        $retour= "<td >".$this->getIdBranch()->getCdBranch()."</td><td >".$this->role."</td>";
        $retour.="<td></td>";
            
        return $retour;
    }  
    
    public function getHeadColumns()
    {
        $retour= "<th>Branch ref</th><th>Role</th>";
        $retour.="<td></td>";
        
        return $retour;
    } 
    
    /**
     * Get idUserInBranch
     *
     * @return integer 
     */
    public function getIdUserInBranch()
    {
        return $this->idUserInBranch;
    }

    /**
     * Set idBranch
     *
     * @param \Etrali\GinangBundle\Entity\Branch $idBranch
     * @return UserInBranch
     */
    public function setIdBranch(\Etrali\GinangBundle\Entity\Branch $idBranch = null)
    {
        $this->idBranch = $idBranch;
    
        return $this;
    }

    /**
     * Get idBranch
     *
     * @return \Etrali\GinangBundle\Entity\Branch 
     */
    public function getIdBranch()
    {
        return $this->idBranch;
    }

    /**
     * Set role
     *
     * @param string $role
     * @return UserInBranch
     */
    public function setRole($role)
    {
        $this->role = $role;
    
        return $this;
    }

    /**
     * Get role
     *
     * @return string 
     */
    public function getRole()
    {
        return $this->role;
    }

    /**
     * Set idMyuser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idMyuser
     * @return UserInBranch
     */
    public function setIdMyuser(\Etrali\GinangBundle\Entity\Myuser $idMyuser = null)
    {
        $this->idMyuser = $idMyuser;
    
        return $this;
    }

    /**
     * Get idMyuser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdMyuser()
    {
        return $this->idMyuser;
    }public function getParentBranch() { return NULL; }  }