<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * UserInGroup
 *
 * @ORM\Table(name="user_in_group")
 * @ORM\Entity
 */
class UserInGroup
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_user_in_group", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idUserInGroup;

    /**
     * @var \User
     *
     * @ORM\ManyToOne(targetEntity="Myuser")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user", referencedColumnName="id")
     * })
     */
    private $idUser;

    /**
     * @var \UserGroup
     *
     * @ORM\ManyToOne(targetEntity="UserGroup")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="id_user_group", referencedColumnName="id_user_group")
     * })
     */
    private $idUserGroup;



    /**
     * Get idUserInGroup
     *
     * @return integer 
     */
    public function getIdUserInGroup()
    {
        return $this->idUserInGroup;
    }

    /**
     * Set idUser
     *
     * @param \Etrali\GinangBundle\Entity\Myuser $idUser
     * @return UserInGroup
     */
    public function setIdUser(\Etrali\GinangBundle\Entity\Myuser $idUser = null)
    {
        $this->idUser = $idUser;
    
        return $this;
    }

    /**
     * Get idUser
     *
     * @return \Etrali\GinangBundle\Entity\Myuser 
     */
    public function getIdUser()
    {
        return $this->idUser;
    }

    /**
     * Set idUserGroup
     *
     * @param \Etrali\GinangBundle\Entity\UserGroup $idUserGroup
     * @return UserInGroup
     */
    public function setIdUserGroup(\Etrali\GinangBundle\Entity\UserGroup $idUserGroup = null)
    {
        $this->idUserGroup = $idUserGroup;
    
        return $this;
    }

    /**
     * Get idUserGroup
     *
     * @return \Etrali\GinangBundle\Entity\UserGroup 
     */
    public function getIdUserGroup()
    {
        return $this->idUserGroup;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }