<?php

namespace Etrali\GinangBundle\Entity;

use Doctrine\ORM\Mapping as ORM; use Gedmo\Mapping\Annotation as Gedmo;

/**
 * VariantType
 *
 * @ORM\Table(name="variant_type")
 * @ORM\Entity
 */
class VariantType
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id_variant_type", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $idVariantType;

    /**
     * @var string
     *
     * @ORM\Column(name="cd_variant_type", type="string", length=15, nullable=false)
     */
    private $cdVariantType;

    /**
     * @var string
     *
     * @ORM\Column(name="lb_variant_type", type="string", length=250, nullable=false)
     */
    private $lbVariantType;

    /**
     * @var float
     *
     * @ORM\Column(name="nb_quantity", type="decimal", nullable=true)
     */
    private $nbQuantity;

    /**
     * @var boolean
     *
     * @ORM\Column(name="bl_deactivated", type="boolean", nullable=true)
     */
    private $blDeactivated=true;



    /**
     * Get idVariantType
     *
     * @return integer 
     */
    public function getIdVariantType()
    {
        return $this->idVariantType;
    }

    /**
     * Set cdVariantType
     *
     * @param string $cdVariantType
     * @return VariantType
     */
    public function setCdVariantType($cdVariantType)
    {
        $this->cdVariantType = $cdVariantType;
    
        return $this;
    }

    /**
     * Get cdVariantType
     *
     * @return string 
     */
    public function getCdVariantType()
    {
        return $this->cdVariantType;
    }

    /**
     * Set lbVariantType
     *
     * @param string $lbVariantType
     * @return VariantType
     */
    public function setLbVariantType($lbVariantType)
    {
        $this->lbVariantType = $lbVariantType;
    
        return $this;
    }

    /**
     * Get lbVariantType
     *
     * @return string 
     */
    public function getLbVariantType()
    {
        return $this->lbVariantType;
    }

    /**
     * Set nbQuantity
     *
     * @param float $nbQuantity
     * @return VariantType
     */
    public function setNbQuantity($nbQuantity)
    {
        $this->nbQuantity = $nbQuantity;
    
        return $this;
    }

    /**
     * Get nbQuantity
     *
     * @return float 
     */
    public function getNbQuantity()
    {
        return $this->nbQuantity;
    }

    /**
     * Set blDeactivated
     *
     * @param boolean $blDeactivated
     * @return VariantType
     */
    public function setBlDeactivated($blDeactivated)
    {
        $this->blDeactivated = $blDeactivated;
    
        return $this;
    }

    /**
     * Get blDeactivated
     *
     * @return boolean 
     */
    public function getBlDeactivated()
    {
        return $this->blDeactivated;
    }
public function __toString() { return ''; } public function getParentBranch() { return NULL; }  }