<?php

namespace Etrali\GinangBundle;

use Symfony\Component\HttpKernel\Bundle\Bundle;

class EtraliGinangBundle extends Bundle
{
    
    
    public static function getUnlinkedConnectionPath($connpath,$PortInstance)
    {
        if ($connpath!=NULL && $connpath!="")
        {
            $params=explode("/",$connpath);
            $params2=explode(":",$params[0]);
            $portid=$params2[1];           

            $tab=array();
            $tab[]=$PortInstance->getCdPortInstance();
            if ($PortInstance->getIdCardInstance()!=NULL)
            {
                $mere=$PortInstance->getIdCardInstance();
                if ($mere->getIdCard()->getBlCardForRef())
                    $tab[]=$mere->getCdCardInstance();        
                if ($mere->getIdMotherCard() != NULL)
                {
                    $card=$mere->getIdMotherCard();
                    if ($card->getIdCard()->getBlCardForRef())     
                        $tab[]=$card->getCdCardInstance();        
                    $mere=$card->getIdSlotInstance();
                    if ($mere->getIdSlot()->getBlSlotForRef())
                        $tab[]=$mere->getCdSlotInstance();                        
                }

                $equip=$mere->getIdEquipmentInstance();
                $tab[]=$equip->getCdEquipmentInstance();                    

            }
            else
            {
                $equip=$PortInstance->getIdPatchPanelInstance();
                if ($equip->getIdPatchPanel()->getBlPanelForRef())
                    $tab[]=$equip->getCdPatchPanelInstance(); 
            }
            $cab=$equip->getIdCabinetInstance();                       

            $pop=$cab->getIdPop();
            $tab[]=$pop->getCdPop();                     
            if ($pop->getIdAccess()!=NULL)
            {
                $access=$pop->getIdAccess();
                $tab[]=$access->getCdAccess(); 
            }

            $tab=array_reverse($tab);
            $chaine=implode(" / ",$tab);
            return $chaine;
        }
        else
            return "";
    }    
    
    public static function preFormEquipmentCostingLine($motherid,$motherentity,$Costing,$em)
    {
        $mother=$em->getRepository('EtraliGinangBundle:'.$motherentity)->find($motherid);
        if (method_exists($mother,"getIdProvider") && $mother->getIdProvider()!=NULL)
        {
                if ($mother->getIdProvider()->getIdBillingFrequency()!=NULL)
                        $Costing->setIdBillingFrequency($mother->getIdProvider()->getIdBillingFrequency());
                $Costing->setIdNoticePeriod($mother->getIdProvider()->getIdNoticePeriod());
                $Costing->setNbContractDuration($mother->getIdProvider()->getNbContractualPeriod());

        }
        
    }
    
    public static function preFormServiceCostingLine($motherid,$motherentity,$Costing,$em)
    {
        $mother=$em->getRepository('EtraliGinangBundle:'.$motherentity)->find($motherid);
        if ($mother->getDtDelivery()!=NULL)
        {
            $Costing->setDtStart($mother->getDtDelivery());
            $Costing->setDtStartMrc($mother->getDtDelivery());
        }
        if ($mother->getIdProviderOfCarrier()!=NULL)
        {
                $Costing->setIdProvider($mother->getIdProviderOfCarrier());
                    $adr=$mother->getIdProviderOfCarrier()->getUniqueBillingAddress();
                    if ($adr!=NULL)
                        $Costing->setIdProviderAddress($adr);

                $adr=$mother->getIdProviderOfCarrier()->getDefaultBillingContact();
                if ($adr!=NULL)
                    $Costing->setIdContact($adr);
                else {
                    $adr=$mother->getIdProviderOfCarrier()->getUniqueBillingContact();
                    if ($adr!=NULL)
                        $Costing->setIdContact($adr);
                }                
                if ($mother->getIdProviderOfCarrier()->getIdBillingFrequency()!=NULL)
                        $Costing->setIdBillingFrequency($mother->getIdProviderOfCarrier()->getIdBillingFrequency());
                $Costing->setIdNoticePeriod($mother->getIdProviderOfCarrier()->getIdNoticePeriod());
                $Costing->setNbContractDuration($mother->getIdProviderOfCarrier()->getNbContractualPeriod());

        }
        $setter="setId".$motherentity;
        $Costing->$setter($mother);
    } 
    
}
