<?php

namespace Etrali\GinangBundle\Form\Type;

use Symfony\Component\Form\Extension\Core\Type\IntegerType;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class IntComparatorType extends AbstractType
{

    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {

         $options['from']['required'] = $options['required'];
         $options['to']['required'] = $options['required'];       

         $builder
               ->add('fromop', 'choice', array('choices'   => array('>' => '>', '>=' => '>=', '=' => '='),'required'  => true,))         
               ->add('from', new IntegerType(), $options['from'])
               ->add('toop', 'choice', array('choices'   => array('<' => '<', '<=' => '<=', '=' => '='),'required'  => true,))
               ->add('to', new IntegerType(), $options['to']);
    }

    /**
     * {@inheritdoc}
     */
    public function getParent()
    {
        return 'form';
    }

    /**
     * {@inheritdoc}
     */
    public function getDefaultOptions(array $options)
    {
        return array(
        );
    }

    /**
     * {@inheritdoc}
     */
    public function getName()
    {
        return 'int_comparator';
    }
}
