<?php

namespace Etrali\GinangBundle\Form\Type\Reporting;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;


class ReportingLocalLoopType extends AbstractType 
{
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
  
    $builder->add('branch', 'entity',
            array(  
                'em' => 'default', 
                'required' => false, 
                'multiple' => true,
                'class' => 'EtraliGinangBundle:Branch',  
                'label' => 'Branch',  
                'help' => NULL,
                'translation_domain' => 'Admin',));
    
    $builder->add('carrier', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Provider',  
                'multiple' => true,  
                'label' => 'Carrier',  
                'empty_value'=>'Any Carrier',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('linkFunction', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\LinkFunction',  
                'multiple' => true,  
                'label' => 'Link function',  
                'empty_value'=>'Any Link function',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('localLoopStatus', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\TransactionStatus',  
                'multiple' => true,  
                'label' => 'Local Loop Status',  
                'empty_value'=>'Any Link function',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
    $builder->add('customer', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Customer',  
                'multiple' => true,  
                'label' => 'Customer',  
                'empty_value'=>'Any Customer',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
    
        $builder->add('provider', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Provider',  
                'multiple' => true,  
                'label' => 'Provider',  
                'empty_value'=>'Any Provider',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));
        
        $builder->add('pop', 'entity', 
            array(  
                'em' => 'default', 
                'required' => false, 
                'class' => 'Etrali\\GinangBundle\\Entity\\Pop',  
                'multiple' => true,  
                'label' => 'Pop',  
                'empty_value'=>'Any Pop',                
                'help' => NULL,  
                'translation_domain' => 'Admin',));

  }
  
  public function getName()
  {
    return 'etrali_ginangBundle_reporting_local_loop';
  }   

}

